#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>

using namespace std;

#define FOR(i,a,b) for(int i = a; i <= b; i++)
#define INF 1000000000
ifstream f("tetris.dat");
ofstream g("tetris.sol");

vector <int> a;
vector <int> b;
vector <int> c;
vector <vector <int> > z;
int n;

int fun (int l, int r)
{
	if (l < 0 || r < 0) return INF;
	if (l > r) return INF;
	if (l == r) return c[l];
	if (r - l == 1) return max(c[l], c[r]);
	if (z[l][r] != -1) return z[l][r];
	int _m = INF;
	int _x, _y;
	for(int  i = l + 1; i < r; i++)
	{
		//m = min(_m, min(fun(l,i-1),fun(i+1,r)));
		_x = fun(l,i-1);
		_y = fun(i+1,r);
		if (c[i] < _x && c[i] < _y)
			_m = min(_m, _x+_y-c[i]);
		else
			_m = min(_m, max(max(_x,_y), c[i]));
	}
	z[l][r] = _m;
	return z[l][r];
}

int main()
{
	f >> n;
	a.resize(n);
	b.resize(n);
	c.resize(n);
	z.resize(n);
	fill(z.begin(), z.end(), vector<int> (n,-1));
	FOR(i,0,n-1)
		f >> a[i];
	FOR(i,0,n-1)
	{
		f >> b[i];
		if (a[i] - b[i] <= 0)
			c[i] = -(a[i] - b[i]);
		else
			c[i] = 4 - a[i] + b[i];
	}
	g << fun(0,n-1);
	f.close();
	g.close();
	return 0;
}