#pragma comment ( linker, "/STACK:8666685")
#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <memory.h>
using namespace std;

int main()
{
	FILE *inf = fopen( "stones.dat", "r" );
	FILE *outf = fopen( "stones.sol", "w" );

	int N, M;
	fscanf( inf, "%d %d", &N, &M );

	vector < int > town[ 200005 ];

	for( int i = 1; i <= N; i++ )
	{
		int A;
		fscanf( inf, "%d", &A );

		if( A == 1 )
		{
			int B, C;
			fscanf( inf, "%d %d", &B, &C );
			if( !town[ B ].size() || C < town[ B ].back() )
				town[ B ].push_back( C );
			else
			{
				for( int j = 0; j < town[ B ].size(); j++ )
					if( C > town[ B ][ j ] )
					{
						town[ B ].insert( town[ B ].begin() + j, C );
						break;
					}
			}

		}
		else
		{
			int res = 0;
			int index;
			for( int j = 1; j <= M; j++ )
			{
				if( town[ j ].back() > res )
				{
					res = town[ j ].back();
					index = j;
				}
			}
			fprintf( outf, "%d\n", res );
			town[ index ].pop_back();
		}
	}

	fclose( inf );
	fclose( outf );
	exit( 0 );
}
