#pragma comment( linker, "/STACK:333335556" )
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <memory.h>
using namespace std;

struct sList
{
	int v;
	int next;
};

sList list[ 50000005 ];
int head[ 50000005 ] = { 0 };
int k = 0;
int s = 0;
int f = 0;

void AddEdge( int v, int u )
{
	k++;
	list[k].v = u;
	list[k].next = head[v];
	head[v] = k;
}

int main()
{
	FILE *inf = fopen( "cap.dat", "r" );
	FILE *outf = fopen( "cap.sol", "w" );

	int N, M;

	fscanf( inf, "%d %d", &N, &M );

	char str[ 1005 ][ 1005 ];

	for( int i = 0; i < N; i++ )
		fscanf( inf, "%s", str[i] );

	for( int i = 0; i < N; i++ )
	{
		for( int j = 0; j < M; j++ )
		{
			if( str[i][j] != '.' )
			{
				for( int k = i + 1; k < N; k++ )
				{
					if( str[k][j] != '.' )
					{
						AddEdge( M * i + j + 1, M * k + j + 1 );
						AddEdge( M * k + j + 1, M * i + j + 1 );
					}
				}

				for( int k = j + 1; k < M; k++ )
				{
					if( str[i][k] != '.' )
					{
						AddEdge( M * i + j + 1, M * i + k + 1 );
						AddEdge( M * i + k + 1, M * i + j + 1 );
					}
				}

				if( str[i][j] == 'o' )
				{
					s = M * i + j + 1;
				}
				else if( str[i][j] == '+' )
				{
					f = M * i + j + 1;
				}
			}
		}
	}


	int dist[ 1000005 ];
	bool used[ 1000005 ] = { false };
	memset( dist, 63, sizeof( dist ) );
	int INF = dist[0];
	dist[s] = 0;

	while( true )
	{
		int currentVertex = 0;
		bool finish = true;
		for( int i = 1; i <= N * M; i++ )
		{
			if( !used[ i ] && dist[i] < dist[ currentVertex ] )
			{
				currentVertex = i;
				finish = false;
			}
		}
		if( finish )
			break;
		used[ currentVertex ] = true;
		int currentEdge = head[ currentVertex ];
		while( currentEdge )
		{
			if( dist[ currentVertex ] + 1 < dist[ list[ currentEdge ].v ] )
				dist[ list[ currentEdge ].v ] = dist[ currentVertex ] + 1;
			currentEdge = list[ currentEdge ].next;
		}
	}

	if( dist[f] != INF )
		fprintf( outf, "%d\n", dist[f] );
	else
		fprintf( outf, "-1\n" );

	fclose( inf );
	fclose( outf );
}
