#pragma comment( linker, "/STACK:333335556" )
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <memory.h>
using namespace std;

struct sList
{
	int v;
	int next;
};

sList list[ 1000001 ];
int head[ 1000001 ] = { 0 };
int k = 0;
int n = 0;
int s = 0;
int f = 0;

void AddEdge( int v, int u )
{
	k++;
	list[k].v = u;
	list[k].next = head[v];
	head[v] = k;
}

int main()
{
	FILE *inf = fopen( "cap.dat", "r" );
	FILE *outf = fopen( "cap.sol", "w" );

	short int N, M;

	fscanf( inf, "%d %d", &N, &M );

	char str[ 1000 ];
	int v[ 1000 ][ 1000 ];
	memset( v, 0, sizeof( v ) );

	for( int i = 0; i < N; i++ )
	{
		fscanf( inf, "%s", str );
		for( int j = 0; j < M; j++ )
		{
			if( str[j] != '.' )
			{
				n++;
				v[ i ][ j ] = n;
			}
			if( str[j] == 'o' )
			{
				s = v[i][j];
			}
			else if( str[j] == '+' )
			{
				f = v[i][j];
			}
		}
	}

	for( int i = 0; i < N; i++ )
	{
		for( int j = 0; j < M; j++ )
		{
			if( v[i][j] )
			{
				for( int k = i + 1; k < N; k++ )
				{
					if( v[k][j] )
					{
						AddEdge( v[i][j], v[k][j] );
						AddEdge( v[k][j], v[i][j] );
					}
				}

				for( int k = j + 1; k < M; k++ )
				{
					if( v[i][k] )
					{
						AddEdge( v[i][j], v[i][k] );
						AddEdge( v[i][k], v[i][j] );
					}
				}


			}
		}
	}


	short int dist[ 1000001 ];
	bool used[ 1000001 ] = { false };
	memset( dist, 63, sizeof( dist ) );
	int INF = dist[0];
	dist[s] = 0;

	while( true )
	{
		int currentVertex = 0;
		bool finish = true;
		for( int i = 1; i <= n; i++ )
		{
			if( !used[ i ] && dist[i] < dist[ currentVertex ] )
			{
				currentVertex = i;
				finish = false;
			}
		}
		if( finish )
			break;
		used[ currentVertex ] = true;
		int currentEdge = head[ currentVertex ];
		while( currentEdge )
		{
			if( !used[ list[ currentEdge ].v ] && dist[ currentVertex ] + 1 < dist[ list[ currentEdge ].v ] )
				dist[ list[ currentEdge ].v ] = dist[ currentVertex ] + 1;
			currentEdge = list[ currentEdge ].next;
		}
	}

	if( dist[f] != INF )
		fprintf( outf, "%d\n", dist[f] );
	else
		fprintf( outf, "-1\n" );

	fclose( inf );
	fclose( outf );
	exit( 0 );
}
