#include <iostream>
#include <stdio.h>
#include <set>
#include <vector>
#include <algorithm>

using namespace std;

vector<int> mas1[ 200010 ];
int mas[ 200010 ];
int tree[ 4*200010 ];

void build( int v , int l , int r )
{
    if( l == r )
        tree[v] = l;
    else
    {
        int md = (l+r) >> 1;
        build( 2*v , l , md );
        build( 2*v+1 , md+1 , r );

        if( mas[tree[2*v]] < mas[tree[2*v+1]] )
            tree[v] = tree[2*v+1];
        else
            tree[v] = tree[2*v];
    }
}

int pos;

void upd( int v , int l , int r )
{
    if( l == r )
        tree[v] = l;
    else
    {
        int md = (l+r) >> 1;
        if( pos <= md )
            upd(2*v,l,md);
        else
            upd(2*v+1,md+1,r);

        if( mas[tree[2*v]] < mas[tree[2*v+1]] )
            tree[v] = tree[2*v+1];
        else
            tree[v] = tree[2*v];
    }
}

int main()
{
    freopen( "stones.dat" , "r" , stdin ); freopen( "stones.sol" , "w" , stdout );
    int n , m;
    scanf( "%d %d" , &n , &m );

    int t , w , d , pos, k;
    for( int i = 0 ; i < m ; ++i )
    {
        mas[i+1] = 1000000001ll;
        mas1[i+1].push_back(1000000001ll);
    }

    build( 1 , 1 , m );
    for( int i = 0 ; i < n ; ++i )
    {
        scanf( "%d" , &d );
        if( d == 1 )
        {
            scanf( "%d %d" , &t , &w );
            mas1[t].push_back(w);
           /* k = mas1[t].size()-2;
            while( k >= 0 )
            {
                if( mas1[t][k] < mas1[t][k+1] )
                {
                    swap(mas1[t][k],mas1[t][k+1]);
                    --k;
                }
                else break;
            }
*/

            k = *min_element(mas1[t].begin(),mas1[t].end());
            if( k == w )
            {
                mas[t] = k;
                pos = t;
                upd( 1 , 1 , m );
            }
        }
        else
        {
            pos = tree[1];
            printf( "%d\n" , mas[pos] );
            mas1[pos].erase( find(mas1[t].begin(),mas1[t].end(),mas[pos]) );
            mas[pos] = *min_element(mas1[t].begin(),mas1[t].end());
            pos = t;
            upd( 1 , 1 , m );
        }
    }
    return 0;
}
