#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <queue>
#include <time.h>

using namespace std;

char mas[1010][1010];
int d[1010][1010];

int main()
{
    ios::sync_with_stdio(0);
    freopen( "cap.dat" , "r" , stdin );
    freopen( "cap.sol" , "w" , stdout );
    int n , m;
    cin >> n >> m;
    int sx , sy , fx , fy;
    for( int i = 0 ; i < n ; ++i )
        for( int j = 0 ; j < m ; ++j )
        {
            d[i][j] = 99999999;
            cin >> mas[i][j];
            if( mas[i][j] == 'o' )
                sx = i , sy = j;
            if( mas[i][j] == '+' )
            {
                fx = i , fy = j;
                mas[i][j] = 'x';
            }
        }
    priority_queue< pair<int,pair<int,int> > > Q;
    Q.push( make_pair(0,make_pair(sx,sy)) );
    d[sx][sy] = 0;
    while( !Q.empty() )
    {
        int vx , vy , dd;
        vx = Q.top().second.first;
        vy = Q.top().second.second;
        dd = Q.top().first;
        //cout << vx << " "<< vy << endl;

        Q.pop();

        if( d[fx][fy] <= dd+1 )
        {
            //cout << dd << " " << d[fx][fy] << endl;
        }
        else
        {
            for( int i = fx ; i < n ; ++i )
            if( mas[i][vy] == 'x' )
            if( d[i][vy] > d[vx][vy]+1 )
            {
                d[i][vy] = d[vx][vy]+1;
                Q.push( make_pair( d[i][vy] , make_pair( i,vy ) ) );
            }
            for( int i = fx-1 ; i >= 0 ; --i )
            if( mas[i][vy] == 'x' )
            if( d[i][vy] > d[vx][vy]+1 )
            {
                d[i][vy] = d[vx][vy]+1;
                Q.push( make_pair( d[i][vy] , make_pair( i,vy ) ) );
            }

            for( int i = fy ; i < m ; ++i )
            if( mas[vx][i] == 'x' )
            if( d[vx][i] > d[vx][vy]+1 )
            {
                d[vx][i] = d[vx][vy]+1;
                Q.push( make_pair( d[vx][i] , make_pair( vx,i ) ) );
            }
            for( int i = fy-1 ; i >= 0 ; --i )
            if( mas[vx][i] == 'x' )
            if( d[vx][i] > d[vx][vy]+1 )
            {
                d[vx][i] = d[vx][vy]+1;
                Q.push( make_pair( d[vx][i] , make_pair( vx,i ) ) );
            }
        }
        if( (double)clock()/(double)CLOCKS_PER_SEC > 0.270 )
            break;
    }

    for( int i = 0 ; i < n ; ++i )
        d[fx][fy] = min(d[fx][fy],d[i][fy]+1);

    for( int i = 0 ; i < m ; ++i )
        d[fx][fy] = min(d[fx][fy],d[fx][i]+1);

    if( d[fx][fy] == 99999999 ) d[fx][fy] = -1;
    cout << d[fx][fy] << "\n";
    return 0;
}
