#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <cmath>
#include <string>

#define min(a, b) (((a) > (b)) ? (b) : (a))
#define max(a, b) (((a) > (b)) ? (a) : (b))

using namespace std;

long long a[100000];
long long sum[100001];

int main () {
	freopen ("set.dat", "r", stdin);
	freopen ("set.sol", "w", stdout);
	int n;
	scanf ("%d", &n);
	for (int i = 0; i < n; i++)
		scanf ("%d", &a[i]);
	sort(a, a+n);
	sum[0] = 0;
	for (int i = 0; i < n; i++)
		sum[i+1] = sum[i] + a[i];
	for (int i = n-1; i >= 0; i--) {
		if (a[i] < sum[i]) {
			cout << i+1;
			return 0;
		}
	}
	cout << "0";
}