#include <iostream>
#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <vector>
#include <string>
#include <map>
#include <list>
#include <set>
#include <queue>
#include <bitset>

using namespace std;

#define problem "mutation"

const int MAX_N = (int) 1e5;
const long long inf = 9223372036854775807LL;

typedef vector<int>::iterator itr;

int n, res = 0;
vector<int> a;
itr iter;
map<int, pair<itr, int> > bg;
bool exist[MAX_N];
set< pair<int, int> > dist;
set< pair<int, int> >::reverse_iterator set_iter;

int main() {
    freopen(problem ".dat", "r", stdin);
    freopen(problem ".sol", "w", stdout);

    scanf("%d\n", &n);
    a.reserve(n);

    for (int i = 0; i < n; ++i) {
        scanf("%d", &a[i]);

        exist[a[i]] = true;

        if (bg.count(a[i])) {
            if (i - bg[a[i]].second > 1)
                dist.insert(make_pair(i - bg[a[i]].second + 1, a[i]));
        } else {
            bg[a[i]] = make_pair(a.begin() + i, i);
        }
    }

    pair<int, int> pr; bool ne; set_iter = dist.rbegin();
    while (set_iter != dist.rend()) {
        pr = *set_iter;
        ++set_iter;

        if (exist[pr.second]) {
            ne = true;
            for (iter = (bg[pr.second].first + 1); ne && iter != (bg[pr.second].first + pr.first - 1); ++iter) {
                if (exist[*iter] && ((*iter) != pr.second)) {
                    ne = false;
                }
            }

            if (!ne) {
                exist[pr.second] = false;
                ++res;
            }
        }
    }

    printf("%d", res);

    return 0;
}
