#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <algorithm>
#include <cmath>
#include <set>
#include <vector>
#include <map>
#include <ctime>
#include <iomanip>
#include <cstdlib>

using namespace std;

const long long inf = 1e18+7;
const long long mod = 1e9+7;

#define ll long long
#define mp make_pair
#define forn(i,n) for(ll i=0;i<n;i++)
struct circle {
    ll x, y, r, c;
    friend bool operator<(circle x, circle y) {
        return x.c < y.c;
    }
} a[100005];
struct knight {
    ll x, y, l, c;
} b[100005];
ll q[1005][1005];
double dist(double x, double y, double x1, double y1) {
    return sqrt((x-x1)*(x-x1)+(y-y1)*(y-y1));
}
int main() {
    #ifndef ONLINE_JUDGE
        freopen("camelot.dat","rt",stdin);
        freopen("camelot.sol","wt",stdout);
    #endif
    ll n, m, k; cin >> n >> m >> k;
    forn(i,n) cin >> a[i].x >> a[i].y >> a[i].r >> a[i].c;
    sort(a,a+n);
    ll p = n-1;
    while(k && p) a[p].c = 0, k--, p--;
    forn(i,m) cin >> b[i].x >> b[i].y >> b[i].l, b[i].c = 0;
    for(ll i=0;i<n;i++)
        for(ll j=0;j<m;j++)
            if(dist(a[i].x,a[i].y,b[j].x,b[j].y)<=a[i].r)
                {b[j].c = b[j].l * a[i].c; q[i][j] = 1; break;}
    ll ans = inf;
    for(ll i=0;i<n;i++) {
        ll now = 0;
        for(ll j=0;j<m;j++)
            if(q[i][j]); else
                now += b[j].c + b[j].l * a[i].c;
        ans = min(ans,now);
    }
    cout << ans << endl;
    return 0;
}
