#include <iostream>
#include <algorithm>
#include <cstdio>
#include <string>
#include <cstring>
#include <set>
#include <map>
#include <vector>
#pragma comment (linker, "/stack:200000000")
#define min(a, b) ((a < b) ? (a) : (b))
#define min(a, b) ((a > b) ? (a) : (b))
#define abs(a) ((a < 0) ? (-(a)) : (a))

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef vector<int> vi;
typedef pair<int, int> pii;

const int MAXN = 100001;

int f[MAXN + 1];
int n;

void add(int pos, int val)
{
	for (int i = pos; i < n; i = (i | (i + 1)))
		f[i] += val;
}

int getR(int r)
{
	int res = 0;
	for (int i = r; i >= 0; i = (i & (i + 1)) - 1)
		res += f[i];
	return res;
}
int getSum(int l, int r)
{
	return getR(r) - (l == 0 ? 0 : getR(l - 1));
}
int main()
{
	freopen("mutation.dat", "r", stdin); freopen("mutation.sol", "w", stdout);
	scanf("%d", &n);
	pair<int, int> M[MAXN];
	for (int i = 0; i < n; i++)
	{
		int k;
		scanf("%d", &M[i].first);
		M[i].first--;
		M[i].second = i;
	}
	sort(M, M + n);

	pair<int, int> fl[MAXN];
	fl[M[0].first].first = M[0].second;
	fl[M[n - 1].first].second = M[n - 1].second;
	for (int i = 1; i < n; i++)
		if (M[i].first != M[i - 1].first)
			fl[M[i - 1].first].second = M[i - 1].second,
			fl[M[i].first].first = M[i].second;

	int result = 0;
	add(M[n - 1].second, 1);
	for (int i = n - 2; i >= 0; i--)
	{
		if (M[i].first != M[i + 1].first)
		{
			int val = getSum(fl[M[i].first].first, fl[M[i].first].second);
			if (val > 0)
				result++;
		}
		add(M[i].second, 1);
	}
	cout << result << endl;
}