#include <iostream>
#include <cstdio>
#include <set>
#include <vector>

using namespace std;

int n , m ;
vector <pair <int , int> > Graph[200000];
long long D[200000];

int main()
{
freopen("olympair.dat","r",stdin);
freopen("olympair.sol","w",stdout);
scanf("%d %d",&n,&m);
for (int i  = 1 ; i <= m ; i ++ )
{
	int type , a , b , c ;
	scanf("%d %d %d %d",&type,&a,&b,&c);
	if ( type == 1 )
		Graph[a].push_back(make_pair(b , c));
	else
	{
		for (int i = 0 ; i < Graph[a].size() ; i ++ )
			Graph[b].push_back(make_pair(Graph[a][i].first , Graph[a][i].second + c));
	};
};

D[1] = 0;
for (int i = 2 ; i <= n ; i ++ )
	D[i] = 2e18;

for (int k = 1 ; k <= n ; k ++ )
for (int i = 1 ; i <= n ; i ++ )
	for (int j = 0 ; j < Graph[i].size() ; j ++ )
	{
		int u = Graph[i][j].first , cost = Graph[i][j].second;
		if ( D[u] > D[i] + cost )
			D[u] = D[i] + cost;
	};

for (int i = 2 ; i <= n ; i ++ )
	if ( D[i] == 2e18 )
		printf("-1\n");
	else
		printf("%lld\n",D[i]);

return 0;
};
