#include <iostream>
#include <cstdio>
#include <set>
#include <vector>
#include <queue>

using namespace std;

int n , m ;
vector <pair <int , int> > Graph[200000];
long long D[200000];

int main()
{
freopen("olympair.dat","r",stdin);
freopen("olympair.sol","w",stdout);
scanf("%d %d",&n,&m);
for (int i  = 1 ; i <= m ; i ++ )
{
	int type , a , b , c ;
	scanf("%d %d %d %d",&type,&a,&b,&c);
	if ( type == 1 )
		Graph[a].push_back(make_pair(b , c));
	else
	{
		for (int j = 0 ; j < Graph[a].size() ; j ++ )
			Graph[b].push_back(make_pair(Graph[a][j].first , Graph[a][j].second + c));
	};
};

D[1] = 0;
for (int i = 2 ; i <= n ; i ++ )
	D[i] = 2e18;

priority_queue <pair <long long , int> > Q;
Q.push(make_pair(0 , 1));
while ( !Q.empty() )
{
	int v = Q.top().second;
	long long cost = -Q.top().first;
	Q.pop();
	if ( cost > D[v] )
		continue;
	for (int i = 0 ; i < Graph[v].size() ; i ++ )
	{
		int u = Graph[v][i].first;
		if ( D[u] > D[v] + Graph[v][i].second )
		{
			D[u] = D[v] + Graph[v][i].second;
			Q.push(make_pair(-D[u] , u));
		};
	};
};
/*
for (int k = 1 ; k <= n ; k ++ )
for (int i = 1 ; i <= n ; i ++ )
	for (int j = 0 ; j < Graph[i].size() ; j ++ )
	{
		int u = Graph[i][j].first , cost = Graph[i][j].second;
		if ( D[u] > D[i] + cost )
			D[u] = D[i] + cost;
	};
	*/
for (int i = 2 ; i <= n ; i ++ )
	if ( D[i] == 2e18 )
		printf("-1\n");
	else
		printf("%lld\n",D[i]);

return 0;
};
