#include <iostream>
#include <cstdio>
#include <algorithm>
#include <set>
#include <queue>
#include <vector>

using namespace std;

int N , B[2000][2] , A[2000] , f[1111][1111][4] , add;

int g(int L , int R)
{
	if ( L > R )
		return 0;
	if ( L == R )
		return A[L];
	int min_value = 2e9;
	for (int i = L ; i <= R ; i ++ )
		min_value = min(A[i] , min_value);
	int answer = 2e9 , curv = min_value;
	for (int i = L ; i <= R ; i ++ )
		A[i] -= min_value;
	for (int i = L ; i <= R && curv <= 10 ; i ++ )
		if ( !A[i] )
		{
			answer = min(answer , g(L , i - 1) + g(i + 1 , R) + curv );
			curv += 4;
		};
	for (int i = L ; i <= R ; i ++ )
		A[i] += min_value;
	return answer;
};

int main()
{
//srand(time(0));
freopen("tetris.dat","r",stdin);
freopen("tetris.sol","w",stdout);
scanf("%d",&N);
for (int i = 1 ; i <= N ; i ++ )
	scanf("%d",&B[i][0]);

for (int i = 1 ; i <= N ; i ++ )
	scanf("%d",&B[i][1]);

for (int i = 1 ; i <= N ; i ++ )
	A[i] = (B[i][1] - B[i][0] + 4) % 4;

if ( N > 100 )
{
	printf("%d\n",g(1 , N));
	//printf("%d\n",rand() % 10);
	return 0;
};

for (int r = 1 ; r <= N ; r ++ )
	for (int l = r ; l >= 1 ; l -- )
		for (int ost = 0 ; ost < 4 ; ost ++ )
		{
			if ( l == r )
			{
				f[l][r][ost] = (A[l] - ost + 4) % 4;
			}
			else
			{
				f[l][r][ost] = 2e9;
				for (int k = l ; k <= r ; k ++ )
				{
					for (int add = 0 ; add < 4 ; add ++ )
					{
						int new_f = f[l][k - 1][(ost + add) % 4] + f[k + 1][r][(ost + add) % 4] + (A[k] - (ost + add) + 8) % 4 + add;
						f[l][r][ost] = min(new_f , f[l][r][ost]);
						if ( f[l][r][ost] <= add )
							break;
					};
					if ( !f[l][r][ost] )
						break;
				};
			};
		};

int answer = 2e9;
for (int ost = 0 ; ost < 1 ; ost ++ )
	answer = min(answer , f[1][N][ost]);

printf("%d\n",answer);
return 0;
};