#include <iostream>
#include <cstdio>
#include <algorithm>
#include <set>
#include <queue>
#include <vector>
#include <cmath>

using namespace std;

int N , M , K , ID[36000];
int Cx[36000] , Cy[36000] , Cr[36000] , Cost[36000];
int X[36000] , Y[36000] , C[36000];

vector <pair<int , int> > Graph[36000];
bool used[36000];

//bool inside(int id1 , int id2)
//{
//	return hypot(Cx[id1] - Cx[id2] , Cy[id1] - Cy[id2]) + Cr[id1] <= Cr[id2];
//};

int main()
{
freopen("camelot.dat","r",stdin);
freopen("camelot.sol","w",stdout);
scanf("%d %d %d",&N,&M,&K);
for (int i = 1 ; i <= N ; i ++ )
	scanf("%d %d %d %d",&Cx[i],&Cy[i],&Cr[i],&Cost[i]);

//Cx[N + 1] = Cy[N + 1] = 0;
//Cr[N + 1] = 2e9;
//N ++ ;

for (int i = 1 ; i <= M ; i ++ )
	scanf("%d %d %d",&X[i],&Y[i],&C[i]);

for (int i = 1 ; i <= N ; i ++ )
{
	bool f = false;
	for (int j = 1 ; j <= M ; j ++ )
		if ( (Cx[i] - X[j]) * 1ll * (Cx[i] - X[j]) + (Cy[i] - Y[j]) * 1ll * (Cy[i] - Y[j]) <= Cr[i] * Cr[i] )
			ID[i] += C[j] , used[j] = true;
};
for (int i = 1 ; i <= M ; i ++ )
	if ( !used[i] )
		ID[0] += C[i];
long long answer = 2e18;
for (int i = 1 ; i <= N ; i ++ )
{
	long long cur = 0;
	vector <long long> sub;
	for (int j = 1 ; j <= N ; j ++ )
		if ( j != i )
		{
			sub.push_back(ID[j] * 1ll * Cost[j]);
			cur += ID[j] * 1ll * Cost[i];
		};
	cur += ID[0] * Cost[i];
	sort(sub.begin() , sub.end());
	for (int j = (int)sub.size() - K - 1 ; j >= 0 ; j -- )
		cur += sub[j];
	answer = min(answer , cur);
};
cout << answer << endl;/*
for (int i = 1 ; i <= N ; i ++ )
	for (int j = 1 ; j <= N ; j ++ )
		if ( i != j && inside(i , j) )
			Graph[i].push_back(make_pair(j , Cost[i])) , Graph[j].push_back(make_pair(i , Cost[i]));
			*/
//for (int i = 1 ; i < N ; i ++ )
//	;
return 0;
};