PROGRAM olympair;

CONST
   MaxN=100;

TYPE
   TEdge=
      Record
         A, B, C:integer;
      End;

VAR
   graph:array [1..MaxN] of TEdge;
   Arr: array [1..MaxN, 1..MaxN] of integer;
   range, D, G:array[1.. MaxN] of Integer;
   i, j, k, N, M, U, V, W, last, kilk, o, event:integer;
   A, B, C:integer;


procedure Sort(kilk:integer);
var
   i, j, c:integer;
begin
   for i:=1 to kilk do
      for j:=1 to kilk do
       if graph[i].A>graph[j].A then
       begin
         c:=graph[i].A;
         graph[i].A:=graph[j].A;
         graph[j].A:=c;
         c:=graph[i].B;
         graph[i].B:=graph[j].B;
         graph[j].B:=c;
         c:=graph[i].C;
         graph[i].C:=graph[j].C;
         graph[j].C:=c;
       end;
end;

BEGIN
   Assign(input, 'olympair.dat');
   Reset(input);
   ReadLN(N, kilk);
   for i:=1 to kilk do
   begin
      ReadLN(event, A, B, C);
      if event=1 then
         Arr[A, B]:=C;
      if event=2 then
         for j:=1 to N do
           if Arr[A, j]<>0 then
           Arr[B, j]:=Arr[A, j]+C
   end;
   o:=0;
   for i:=1 to N do
      for j:=1 to N do
         if Arr[i, j]<>0 then
         begin
            Inc(o);
            graph[o].A:=i;
            graph[o].B:=j;
            graph[o].C:=Arr[i, j];
         end;
   M:=o;
   G[1]:=1;
   j:=1;
   for i:=2 to M do
      if (graph[i].A<>graph[i-1].A) then
      begin
         Inc(j);
         G[j]:=i;
      end;
   last:=1;
   i:=0;
   range[1]:=1;
   repeat
      Inc(i);
      for j:=G[range[i]] to G[range[i]+1]-1 do
         if (D[graph[j].B]>=D[graph[j].A]+graph[j].C) or (D[graph[j].B]=0) then
         begin
            D[graph[j].B]:=D[graph[j].A]+graph[j].C;
            Inc(last);
            range[last]:=graph[j].B;
         end;
   until i=last;
   Close(input);
   Assign(output, 'olympair.sol');
   Rewrite(output);
   for i:=2 to N do
   WriteLN(D[i]-1);
   Close(output);
END.
