#include <iostream>
#include <fstream>
#include <vector>
#include <string>

#define task_name "calendar"

using namespace std;

int n;
pair<int,int> village[100000];

int fetch(int start1, int start2) {
    int retval = 0;
    for(int i=0;i<n;i++) {
        if(village[(start1+i)%n].first == village[(start2+i)%n].second)
            retval++;
    }
    return retval;
}

int main() {
	ifstream inp(task_name".dat");
	ofstream out(task_name".sol");

    inp >> n;
    for(int i=0;i<n;i++)
        inp >> village[i].first;
    for(int i=0;i<n;i++)
        inp >> village[i].second;
    int tmp,best = 0;
    for(int i=0;i<n;i++) {
        for(int j=0;j<n;j++) {
            tmp = fetch(i,j);
            if(best < tmp)
                best = tmp;
        }
    }
    out << best << endl;

	inp.close();
	out.close();
}
