#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>

#define task_name "stones"

using namespace std;

struct city_t {
    vector<int> stone;
};

city_t city[100001];
int n,m;

int get_smallest(int c) {
    sort(city[c].stone.begin(),city[c].stone.end());
    reverse(city[c].stone.begin(),city[c].stone.end());
    return city[c].stone.back();
}

int give_stones() {
    int best_stone = -1,best_city = -1;
    for(int i=1;i<=m;i++) {
        int this_stone = get_smallest(i);
        if(best_stone < this_stone || best_stone == -1) {
            best_stone = this_stone;
            best_city = i;
        }
    }
    city[best_city].stone.pop_back();
    return best_stone;
}

int main() {
	ifstream inp(task_name".dat");
	ofstream out(task_name".sol");

    int type,w,t;
    inp >> n >> m;
    for(int i=0;i<n;i++) {
        inp >> type;
        if(type == 2) {
            out << give_stones() << endl;
            continue;
        }
        inp >> t >> w;
        city[t].stone.push_back(w);
    }


	inp.close();
	out.close();
}
