#include <fstream>
#include <vector>
#include <queue>

using namespace std;

ifstream fin("cap.dat");
ofstream fout("cap.sol");

const int INF=424242;

int main()
{
    int n,m;
    fin>>n>>m;
    vector<vector<char> > a(n,vector<char>(m,'.'));
    pair<int,int> s,finish;
    for (int i=0;i<n;i++)
    {
        for (int j=0;j<m;j++)
        {
            fin>>a[i][j];
            if (a[i][j]=='o')
            {
                s=make_pair(i,j);
            }
            if (a[i][j]=='+')
            {
                finish=make_pair(i,j);
            }
        }
    }
    queue<pair<int,int> > q;
    vector<vector<int> > d(n,vector<int>(n,-1));
    q.push(s);
    d[s.first][s.second]=0;
    while(!q.empty())
    {
        pair<int,int> v=q.front();
        q.pop();
        for (int i=v.first+1;i<n;i++)
        {
            if (a[i][v.second]=='x'||a[i][v.second]=='+')
            {
                a[i][v.second]='.';
                q.push(make_pair(i,v.second));
                d[i][v.second]=d[v.first][v.second]+1;
            }
        }
        for (int i=v.first-1;i>=0;i--)
        {
            if (a[i][v.second]=='x'||a[i][v.second]=='+')
            {
                a[i][v.second]='.';
                q.push(make_pair(i,v.second));
                d[i][v.second]=d[v.first][v.second]+1;
            }
        }
        for (int i=v.second+1;i<m;i++)
        {
            if (a[v.first][i]=='x'||a[i][v.second]=='+')
            {
                a[v.first][i]='.';
                q.push(make_pair(v.first,i));
                d[v.first][i]=d[v.first][v.second]+1;
            }
        }
        for (int i=v.second-1;i>=0;i--)
        {
            if (a[v.first][i]=='x'||a[i][v.second]=='+')
            {
                a[v.first][i]='.';
                q.push(make_pair(v.first,i));
                d[v.first][i]=d[v.first][v.second]+1;
            }
        }
    }
    fout<<d[finish.first][finish.second];
    return 0;
}
