#include <stdio.h>
#include <iostream>
#include <algorithm>
using namespace std;

int binheaps[2400][100000];

inline int Parent(int p){
	return p/2;
}
inline int leftChild(int p){
	return 2*p;
}
inline int rightChild(int p){
	return 2*p+1;
}
inline int getMass(int v){
	return binheaps[v][1];
}

void Heapify(int v, int pos){
	if (pos != 1 && pos != 0 && binheaps[v][pos] < binheaps[v][Parent(pos)]){
		swap(binheaps[v][pos], binheaps[v][Parent(pos)]);
	}
	if (pos != 1 && pos != 0) Heapify(v, Parent(pos));
}

void addMass(int v, int m){
	binheaps[v][++binheaps[v][0]] = m;
	Heapify(v, binheaps[v][0]);
}

void removeMin(int v){
	binheaps[v][1] = binheaps[v][binheaps[v][0]];
	Heapify(v, --binheaps[v][0]);
}

int main(){
	freopen("stones.dat", "r", stdin);
	freopen("stones.sol", "w", stdout);
	int n, m; scanf("%d %d", &n, &m);
	int v, ms;
	int maxms = 0, maxv = 0;
	for(int i = 0; i < 2516; i++){
		binheaps[i][0] = 0;
	}
	for(int i = 0; i < n; i++){
		int t; scanf("%d", &t);
		if (t == 1){
			scanf("%d %d", &v, &ms);
			addMass(v, ms);
		}
		if (t == 2){
			for(int j = 1; j <= m; j++){
				if (getMass(j) > maxms){
					maxms = getMass(j);
					maxv = j;
				}
			}
			removeMin(maxv);
			cout<<maxms<<endl;
			maxms = 0;
		}
	}
}
