#include <iostream>
#include <stdio.h>
#include <queue>
#include <algorithm>
using namespace std;

int n, m;
bool fld[1000][1000];
bool wasin[1000][1000];
int times[1000][1000];

void bfs(int xs, int ys, int xf, int yf){
	int xn, yn;
	queue< pair<int, int> > nowin;
	nowin.push(make_pair(xs, ys));
	while (!nowin.empty()){
		xn = nowin.front().first;
		yn = nowin.front().second;
		wasin[xn][yn] = true;
		nowin.pop();
		for(int i = 0; i < n; i++)
			if (!wasin[i][yn] && fld[i][yn]){
				times[i][yn] = min(times[i][yn], times[xn][yn]+1);
				//if (i == xf && yf == yn) return;
				nowin.push(make_pair(i, yn));
			}
		for(int i = 0; i < m; i++)
			if (!wasin[xn][i] && fld[xn][i]){
				times[xn][i] = min(times[xn][i], times[xn][yn]+1);
				//if (xf == xn && yf == i) return;
				nowin.push(make_pair(xn, i));
			}
	}
}

int main(){
	freopen("cap.dat", "r", stdin);
	freopen("cap.sol", "w", stdout);
	scanf("%d %d", &n, &m);
	for(int i = 0; i < n; i++)
		for(int j = 0; j < m; j++){
			fld[i][j] = false;
			wasin[i][j] = false;
			times[i][j] = 99999;
	}
	char d;
	int xs, ys;
	int xf, yf;
	for(int i = 0; i < n; i++){
		for(int j = 0; j < m; j++){
			cin>>d;
			if (d == 'x') fld[i][j] = true;
			else if (d == 'o'){ fld[i][j] = true; xs = i; ys = j; }
			else if (d == '+'){ fld[i][j] = true; xf = i; yf = j; }
		}
	}
	times[xs][ys] = 0;
	bfs(xs, ys, xf, yf);
	if (times[xf][yf] == 99999) times[xf][yf] = -1;
	cout<<times[xf][yf]<<endl;
	//system("pause");
}
