type
  coord = record
            x,y: longint;
          end;

const
  inf = 2147483647;

var
  n,m,i,j: longint;
  a: array[1..1000,1..1000] of longint;
  start, fin: coord;
  ch: char;

procedure go (x,y: longint);
var
  i,j: longint;
begin
  if ( x <> fin.x ) or ( y <> fin.y ) then
  begin
    for i:=1 to n do
    begin
      if ( a[i,y] > 0 ) and ( a[x,y]+1 < a[i,y] ) then
      begin
        a[i,y]:=a[x,y]+1;
        go(i,y);
      end;
    end;
    for j:=1 to m do
    begin
      if ( a[x,j] > 0 ) and ( a[x,y]+1 < a[x,j] ) then
      begin
        a[x,j]:=a[x,y]+1;
        go(x,j);
      end;
    end;
  end;
end;

begin
  assign(input, 'cap.dat');
  assign(output, 'cap.sol');
  reset(input);
  rewrite(output);
  readln(n,m);
  for i:=1 to n do
    for j:=1 to m do
    begin
      if ( j <> m ) then
        read(ch)
      else
        readln(ch);
      case ch of
        'x':
        begin
          a[i,j]:=inf;
        end;
        '.':
        begin
          a[i,j]:=-1;
        end;
        'o':
        begin
          a[i,j]:=0;
          start.x:=i;
          start.y:=j;
        end;
        '+':
        begin
          a[i,j]:=inf;
          fin.x:=i;
          fin.y:=j;
        end;
      end;
    end;
  go(start.x,start.y);
  if ( a[fin.x,fin.y] <> inf ) then
    writeln(a[fin.x,fin.y])
  else
    writeln('-1');
  close(input);
  close(output);
end.
