#include<cstdio>
#include<cstdlib>
#include<vector>
#include<string>
#include<memory.h>
#include<algorithm>
#include<iostream>
#include<cmath>

using namespace std;

#define rep(i,n) for(int (i)=0;(i)<(n);(i)++)
#define FOR(i,a,b) for(int (i)=(a);(i)<=(b);(i)++)
#define ROF(i,a,b) for(int (i)=(b);(i)>=(b);(i)--)
#define fe(i,a) for(int (i)=0;(i)<int((a).size());(i)++)

#define N 100010
#define pi 2*acos(0.0)
#define eps 1e-9
#define inf int(1e9)

#define pb push_back
#define ppb pop_back
#define all(c) (c).begin(),(c).end()
#define sz(c) int((c).size())

#define mp(a,b) make_pair((a),(b))

#define FREOPEN(a,b) freopen(a,"r",stdin);freopen(b,"w",stdout)

typedef pair<int,int> pii;
vector<pii> G[N];
int d[N];
bool used[N];

int main()
{
	//FREOPEN("input.txt","output.txt");
	FREOPEN("olympair.dat","olympair.sol");
	int n,m,op,a,b,c,to,len,v;
	scanf("%d%d",&n,&m);
	rep(i,m)
	{
		scanf("%d%d%d%d",&op,&a,&b,&c);
		a--; b--;
		if(op == 1)
		{
			G[a].pb(mp(b,c));
		} else
		if(op == 2)
		{
			fe(j,G[a])
			{
				to=G[a][j].first;
				len=G[a][j].second;
				G[b].pb(mp(to,len + c));
			}
		}
	}
	rep(i,n)d[i]=inf;
	d[0]=0;
	rep(t,n)
	{
		v=-1;
		rep(i,n)
			if(!used[i] && (v==-1 || d[i]<d[v]))v=i;
		if(d[v]==inf)break;
		used[v]=true;
		fe(i,G[v])
		{
			to=G[v][i].first;
			len=G[v][i].second;
			if(d[to]>d[v] + len)d[to]=d[v] + len;
		}
	}
	for(int i=1;i<n;i++)
		if(d[i] == inf)puts("-1"); else printf("%d\n",d[i]);

	return 0;
}