#include<cstdio>
#include<cstdlib>
#include<cmath>
#include<vector>
#include<algorithm>
#include<string>
#include<memory.h>
#include<set>
#include<queue>

using namespace std;

#define rep(i,n) for(int (i)=0;(i)<(n);(i)++)
#define FOR(i,a,b) for(int (i)=(a);(i)<=(b);(i)++)
#define ROF(i,a,b) for(int (i)=(b);(i)>=(a);(i)--)
#define fe(i,a) for(int (i)=0;(i)<int((a).size());(i)++)

#define sz(a) int((a).size())
#define pb push_back
#define ppb pop_back
#define all(a) (a).begin(),(a).end()

#define N 1010
#define pi 2.0*acos(0.0)
#define eps 1e-9
#define inf int(1e9)

#define mp(a,b) make_pair((a),(b))
#define FREOPEN(a,b) freopen(a,"r",stdin);freopen(b,"w",stdout)

typedef pair<int,int> pii;
typedef long long ll;

char s[N][N];
struct type
{
	int x,y,p,sum;
	bool friend operator<(type a,type b)
	{
		return a.sum > b.sum;
	}
};
int n,m;
bool check(int x,int y)
{
	if(x==n || y==m || x<0 || y<0 || s[x][y]=='.')return false;
	return true;
}
int bfs(int x,int y)
{
	priority_queue<type> q;
	type next,cur;
	int dx[4]={0,0,1,-1};
	int dy[4]={1,-1,0,0};
	cur.x=x; cur.y=y; cur.p=0; cur.sum=0; s[x][y]='.';
	q.push(cur);
	while(!q.empty())
	{
		cur=q.top();
		//printf("%d %d %d\n",cur.x,cur.y,cur.sum);
		q.pop();
		rep(i,4)
		{
			x=cur.x + dx[i]; y=cur.y + dy[i];
			if(check(x,y))
			{
				next.x=x; next.y=y; next.sum=cur.sum;
			    if(dx[i] == 0)next.p=1; else next.p=2;								
				if(cur.p == 0)next.sum++; else
				if(cur.p != next.p)next.sum++;
				if(s[x][y] == '+')return next.sum;
				s[x][y]='.';
				q.push(next);
			}
		}
	}
	return -1;
}
int main()
{
	//FREOPEN("input.txt","output.txt");
	FREOPEN("cap.dat","cap.sol");
	int f=0,xs,ys;
	scanf("%d%d\n",&n,&m);
	rep(i,n)
	{
		gets(s[i]);
		if(!f)
		{
		  rep(j,m)
			if(s[i][j] == 'o')
			{
				xs=i; ys=j; f=1; break;
			}
		}
	}
	//printf("%d %d\n",xs,ys);
	printf("%d\n",bfs(xs,ys));
	return 0;
}
