procedure qsort(var a: array of int64; first, last: longint);
var
  m, left, right, temp: longint;
begin
  m := a[(first + last) div 2];
  left := first;
  right := last;
  while left <= right do
  begin
    while a[left] < m do
      inc(left);
    while a[right] > m do
      dec(right);
    if left <= right then
    begin
      temp := a[left];
      a[left] := a[right];
      a[right] := temp;
      inc(left);
      dec(right);
    end;
  end;
  if left < last then
    qsort(a, left, last);
  if right > first then
    qsort(a, first, right);
end;

var
  n, i: longint;
  sum, res: int64;
  a: array of int64;

begin
  assign(input, 'set.dat');
  reset(input);
  assign(output, 'set.sol');
  rewrite(output);

  readln(n);

  setlength(a, n);

  for i := 0 to n - 1 do
    read(a[i]);
  qsort(a, 0, n - 1);

  res := 0;
  sum := 0;

  sum := a[0];
  for i := 1 to n - 1 do
    inc(sum, a[i]);

  for i := n - 1 downto 0 do
  begin
    if a[i] < sum - a[i] then
    begin
      res := i + 1;
      break;
    end;
    dec(sum, a[i]);
  end;
  writeln(res);
  close(input);
  close(output);
end.
