program olo;

type cord = record
  x, y: word;
end;

var i, j, n, m, ans, head, tail: longint;
    field: array[1..1000, 1..1000] of boolean;
	ln, cl: array[0..1000, 0..1000] of word;
	cash: array[1..1000, 1..1000] of longint;
	st, fin: cord;
	q: array[1..1000010] of cord;
        c: char;

procedure bfs;
  var cur: cord;
      i: longint;
  begin
    head := 1; tail := 2;
	q[1] := st;
	while head <> tail do
	  begin
	    cur := q[head];
		for i := 1 to ln[cur.x][0] do
		  if cash[cur.x, ln[cur.x][i]] = 0 then
		    begin
			  q[tail].x := cur.x;
			  q[tail].y := ln[cur.x][i];
			  cash[q[tail].x, q[tail].y] := cash[cur.x, cur.y] + 1;
			  inc(tail);
			end;
		for i := 1 to cl[cur.y][0] do
		  if cash[cl[cur.y][i], cur.y] = 0 then
		    begin
			  q[tail].x := cl[cur.y][i];
			  q[tail].y := cur.y;
			  cash[q[tail].x, q[tail].y] := cash[cur.x, cur.y] + 1;
			  inc(tail);
			end;
		inc(head);
	  end;
  end;
	
begin
  assign(input, 'cap.dat');
  assign(output, 'cap.sol');
  reset(input); rewrite(output);
  readln(n, m);
  for i := 1 to n do
    begin
	  for j := 1 to m do
	    begin
		  read(c);
		  if c = '.' then field[i, j] := false else
		                  field[i, j] := true;
		  if c = 'o' then
            begin
			  st.x := i; st.y := j;
            end;			
		  if c = '+' then
            begin
			  fin.x := i; fin.y := j;
            end;			
		end;
      readln;		
	end;
  for i := 1 to n do ln[i][0] := 0;
  for i := 1 to m do cl[i][0] := 0;
  for i := 1 to n do
    for j := 1 to m do
      if field[i, j] then
        begin
		  inc(ln[i][0]);
		  ln[i][ln[i][0]] := j;
		  inc(cl[j][0]);
		  cl[j][cl[j][0]] := i;
		end;	
  fillchar(cash, sizeof(cash), 0);		
  cash[st.x, st.y] := 1;		
  bfs;
  if cash[fin.x, fin.y] = 0 then writeln(-1) else writeln(cash[fin.x, fin.y]-1);
  close(input);
  close(output);
end.
