#include <cstdio>
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <list>
#include <queue>
#include <deque>
#include <string>
#include <cstring>

using namespace std;

#if (_WIN32 || __WIN32__)
    #define LLD "%I64d"
#else
    #define LLD "%lld"
#endif

typedef long long INT;

#define INPUT(a) freopen(#a, "r", stdin);
#define OUTPUT(a) freopen(#a, "w", stdout);
#define WITH_FILES(a, b) {INPUT(a) OUTPUT(b)}

#define Max(a, b) ((a)>(b)?(a):(b))
#define Min(a, b) ((a)<(b)?(a):(b))
#define Abs(a) ((a)>0?(a):-(a))

const int MAXN = 200010;

set<int> a[MAXN];
map<int, int> mins;
map<int, int>::iterator it;

int main(){
    WITH_FILES(stones.dat, stones.sol)
    int n, m;
    scanf("%d%d", &n, &m);
    while (n--){
        int inp;
        scanf("%d", &inp);
        if (inp == 1){
            int t, w;
            scanf("%d%d" ,&t, &w);
            t--;
            if (a[t].empty())
                mins[w] = t;
            else{
                int x = *a[t].begin();
                if (w < x){
                    mins.erase(x);
                    mins[w] = t;
                }
            }
            a[t].insert(w);
            /*printf("\tMins: ");
            for (it = mins.begin(); it != mins.end(); it++)
                printf("%d ", it->first);
            printf("\n");
            printf("Inserted!\n");*/
        }
        else{
            it = mins.end();
            it--;
            //printf("Iterator: %d %d\n", it->first, it->second);
            printf("%d\n", it->first);
            int x = it->second;
            //printf("*a[%d].begin() = %d", x, *a[x].begin());
            a[x].erase(a[x].begin());
            mins.erase(it);
            if (!a[x].empty())
                mins[*a[x].begin()] = x;
            /*printf("\tMins: ");
            for (it = mins.begin(); it != mins.end(); it++)
                printf("%d ", it->first);
            printf("\n");
            printf("Erased!\n");*/
        }
    }
    return 0;
}
