#include <iostream>
#include <cstdio>
#include <cmath>
#include <cstring>
#include <string>
#include <vector>
#include <list>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <cstdlib>
#include <bitset>
#include <algorithm>

using namespace std;

typedef long long INT;

#if (_WIN32 || __WIN32|__)
    #define LLD "%I64d"
#else
    #define LLD "%lld"
#endif

#define INPUT(a) freopen(#a, "r", stdin);
#define OUTPUT(a) freopen(#a, "w", stdout);
#define WITH_FILES(a, b) {INPUT(a) OUTPUT(b)}
#define pu push_back

#define Max(a, b) ((a)>(b)?(a):(b))
#define Min(a, b) ((a)<(b)?(a):(b))

const int MAXN = 1010;

int a[MAXN];
int d[MAXN][MAXN];

int main(){
    WITH_FILES(tetris.dat, tetris.sol)
    int n;
    scanf("%d", &n);
    for (int i = 0; i < n; i++)
        scanf("%d", &a[i]);
    for (int i = 0; i < n; i++){
        int x;
        scanf("%d", &x);
        a[i] = x - a[i];
        if (a[i] < 0)
            a[i] += 4;
    }
    /*for (int i = 0; i < n; i++)
        printf("%d ", a[i]);
    printf("\n");*/
    for (int i = 0; i < n; i++)
        d[i][i] = a[i];
    for (int len = 2; len <= n; len++)
        for (int i = 0; i <= n - len; i++){
            int j = i + len - 1;
            int x = d[i+1][j];
            if (a[i] > a[i + 1])
                x += a[i] - a[i + 1];
            int y = d[i][j - 1];
            if (d[j] > d[j - 1])
                y += d[j] - d[j - 1];
            d[i][j] = Min(x, y);
        }
    printf("%d\n", d[0][n - 1]);
    return 0;
}
