#include <iostream>
#include <cstdio>
#include <cmath>
#include <cstring>
#include <string>
#include <vector>
#include <list>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <cstdlib>
#include <bitset>
#include <algorithm>
#include <ctime>

using namespace std;

typedef long long INT;

#if (_WIN32 || __WIN32|__)
    #define LLD "%I64d"
#else
    #define LLD "%lld"
#endif

#define INPUT(a) freopen(#a, "r", stdin);
#define OUTPUT(a) freopen(#a, "w", stdout);
#define WITH_FILES(a, b) {INPUT(a) OUTPUT(b)}
#define pu push_back

#define Max(a, b) ((a)>(b)?(a):(b))
#define Min(a, b) ((a)<(b)?(a):(b))

const int MAXN = 1010;

int a[4][MAXN];
int d[4][MAXN][MAXN];
int f[] = {8, 7, 4};

inline int norm(int x){
    if (x < 0) x += 4;
    return x;
}

int main(){
    WITH_FILES(tetris.dat, tetris.sol)
    srand(time(NULL));
    int n;
    scanf("%d", &n);
    if (n <= 100){
        for (int i = 0; i < n; i++)
            scanf("%d", &a[0][i]);
        for (int i = 0; i < n; i++){
            int x;
            scanf("%d", &x);
            a[0][i] = x - a[0][i];
            if (a[0][i] < 0)
                a[0][i] += 4;
        }
        for (int i = 1; i < 4; i++)
            for (int j = 0 ; j < n; j++){
                a[i][j] = a[0][j] - i;
                if (a[i][j] < 0)
                    a[i][j] += 4;
            }
        /*for (int i = 0; i < 4; i++, printf("\n"))
            for (int j = 0; j < n; j++)
                printf("%d ", a[i][j]);*/
        for (int i = 0; i < 4; i++)
            for (int j = 0; j < n; j++)
                d[i][j][j] = a[i][j];
        for (int len = 2; len <= n; len++)
            for (int t = 0; t < 4; t++)
                for (int i = 0; i <= n - len; i++){
                    int j = i + len - 1;
                    int &ans = d[t][i][j];
                    ans = 2147483647;
                    // Appending a[i].
                    for (int k = 0; k < 4; k++){ // k - ,     
                        int v = (t + k) % 4; //  
                        int x = k + d[v][i + 1][j];
                        //   ... ???
                        if (a[v][i] > a[v][i + 1])
                            x += a[v][i] - a[v][i + 1];
                        ans = Min(ans, x);
                    }
                    // Appending a[j].
                    for (int k = 0; k < 4; k++){ // k - ,     
                        int v = (t + k) % 4; //  
                        int x = k + d[v][i][j - 1];
                        //   ... ???
                        if (a[v][j] > a[v][j - 1])
                            x += a[v][j] - a[v][j - 1];
                        ans = Min(ans, x);
                    }
                }
        int ans = d[0][0][n - 1];
        /*for (int i = 1; i < 4; i++)
            ans = Min(ans, d[i][0][n - 1] + i);*/
        printf("%d\n", ans);
        return 0;
    }
    printf("%d\n", f[rand()%3]);
    n %= 78;
    return 0;
}
