#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <queue>
#include <cstdio>
#include <cmath>
#include <climits>

using namespace std;

int n, a[1000], q, Min = INT_MAX, cur = 0;

int AR[] = {1, 3, 6, 10, 15, 21, 28, 36};

void rec(int Q = 1)
{
	if (cur > Min)
		return;
	if (Q == AR[n-1]+1)
	{
		int ss = 0;
		for (int i = 0; i < n; ++i)
			ss += a[i];
		if (ss == 0)
			Min = min(Min, cur);
		return;
	}

	int w;
	for (int i = 0; i < n; ++i)
		if (Q <= AR[i])
		{
			w = i;
			break;
		}
	int e;
	if (Q == 1)
		e = 0;
	else
		e = Q - AR[w-1] - 1;

	int Max = 0;
	for (int i = e; i < n - w + e; ++i)
		Max = max(Max, a[i]);

/*	for (int i = e; i < n - w + e; ++i)
		a[i] = (a[i] + 1) % 4;
	--cur;*/
	rec(Q+1);
	for (int j = 0; j < Max; ++j)
	{
		for (int i = e; i < n - w + e; ++i)
			a[i] = (a[i] + 3) % 4;
		++cur;
		rec(Q+1);
	}
	cur -= Max;
	for (int i = e; i < n - w + e; ++i)
		a[i] = (a[i] + Max) % 4;
}

int main()
{
	freopen("tetris.dat", "r", stdin);
	freopen("tetris.sol", "w", stdout);

	scanf("%d", &n);
	for (int i = 0; i < n; ++i)
		scanf("%d", &a[i]);
	for (int i = 0; i < n; ++i)
	{
		scanf("%d", &q);
		a[i] = (q + 4 - a[i]) % 4;
	}

	rec();

	printf("%d", Min);

	return 0;
}
