#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <cstring>
#include <cassert>
#include <cmath>
#include <queue>
#include <deque>
using namespace std;

#define pb push_back
#define mp make_pair
#define sz(x) (int)(x).size()
#define foreach(i,x) for(__typeof(x.begin()) i = x.begin();i!=x.end();++i)
#define eprintf(...) fprintf(stderr, __VA_ARGS__)

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;

#define task "calendar"
const int maxn = (int)1e5+20;
int n;
int pos[maxn];
map<int,int> ass;

int main(){
	#ifdef DEBUG
	freopen("input.txt","r",stdin);
	freopen("output.txt","w",stdout);
	#else
	freopen(task".dat","r",stdin);
	freopen(task".sol","w",stdout);
	#endif
	scanf("%d",&n);
	for (int i=0;i<n;++i){
		int x;
		scanf("%d",&x);
		pos[x] = i;
	}
	for (int i=0;i<n;++i){
		int x;
		scanf("%d",&x);
		int j = pos[x];
		if (j==-1)
			continue;
		int d1 = j-i;
		int d2;
		if (d1>0)
			d2 = d1-n; else
			d2 = n+d1;
		ass[d1]++;
		ass[d2]++;
	}
	int ans = 0;
	foreach(i,ass)
		ans = max((*i).second,ans);
	printf("%d\n",ans);
	return 0;
}
