#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <cstring>
#include <cassert>
#include <cmath>
#include <queue>
#include <deque>
using namespace std;

#define pb push_back
#define mp make_pair
#define sz(x) (int)(x).size()
#define foreach(i,x) for(__typeof(x.begin()) i = x.begin();i!=x.end();++i)
#define eprintf(...) fprintf(stderr, __VA_ARGS__)

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;

const ll inf = (ll)1e15;
const int maxn = (int)1e5+1;

#define task "olympair"
int n,m;
vector< pair<int,ll> > g[maxn];
int main(){
	#ifdef DEBUG
	freopen("input.txt","r",stdin);
	freopen("output.txt","w",stdout);
	#else
	freopen(task".dat","r",stdin);
	freopen(task".sol","w",stdout);
	#endif

	scanf("%d%d",&n,&m);
	for (int i=0;i<m;++i){
		int t,a,b;
		ll c;
		scanf("%d%d%d%lld",&t,&a,&b,&c);
		if (t==1){
			g[a].pb(mp(b,c));
		} else
		for (int j=0;j<sz(g[a]);j++)
			g[b].pb(mp(g[a][j].first,g[a][j].second+c));
	}
	set< pair<long,int> > q;
	vector<ll> d(n+1,inf);
	d[1] = 0;
	q.insert(mp(0,1));
	while (!q.empty()){
		int v = q.begin()->second;
		q.erase(q.begin());
		for (int i=0;i<sz(g[v]);++i){
			int to = g[v][i].first, len = g[v][i].second;
			if (d[to]>d[v]+len){
				q.erase(mp(d[to],to));
				d[to] = d[v]+len;
				q.insert(mp(d[to],to));
			}
		}
	}
	for (int i=2;i<=n;++i)
		printf("%lld\n",(d[i]!=inf)?d[i]:-1);
	return 0;
}
