#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
#include <deque>
using namespace std;

#define mp make_pair
#define pb push_back
#define sz(x) (int)(x).size()
#define eprintf(...) fprintf(stderr, __VA_ARGS__)

typedef long long ll;
typedef pair<int,int> pii;
typedef vector<int> vi;

const int maxn = (int)1005;
const ll inf = (ll)1e9;

#define task "tetris"

  int n, ans = 0;
  int a[maxn],b[maxn],d[maxn];
int main(){
  #ifdef DEBUG
  freopen("input.txt","r",stdin);
  freopen("output.txt","w",stdout);
  #else
  freopen(task".dat","r",stdin);
  freopen(task".sol","w",stdout);
  #endif

  cin >> n;

  for (int i=0;i<n;++i)
    cin >> a[i];
  for (int i=0;i<n;++i)
    cin >> b[i];
  for (int i=0;i<n;++i){
    if (b[i]>=a[i])
      d[i] = b[i] - a[i]; else
      d[i] = b[i]+4-a[i];
  }

  while (true){
    int r;
    bool f = false;
    for (int l=0;l<n;l = r){
      r = l;
      int mn = inf;
      while (r<n && d[r]!=0){
        mn = min(mn,d[r]);
        ++r;
      }
      if (mn!=inf)
        ans+=mn;
      for (int i=l;i<r;++i){
        if (d[i]-mn>0)
          f = true;
        d[i]-=mn;
      }
      if (r==l)
        ++r;
    }
    if (!f)
      break;
  }
  cout << ans;
  return 0;
}

