#include <stdio.h>
#include <iostream>
#include <math.h>

using namespace std;

#define F first
#define S second

struct f
{
       int X, Y, R, C;
};

struct l
{
       int X, Y, L;
};

double dist( long long x1, long long y1, long long x2, long long y2 )
{
    return sqrt( (x1 - x2) * ( x1 - x2 ) + (y1 - y2) * ( y1 - y2 ) );
}

int N, M, K, wh[35000];
f fort[35000];
l lyc[35000];
pair < long long, int > vart[35000];

int main()
{
    freopen("camelot.dat", "r", stdin);
    freopen("camelot.sol", "w", stdout);
    
    scanf("%d%d%d", &N, &M, &K);
    for( int i = 0; i < N; i++ )
    {
         scanf("%d%d%d%d", &fort[i].X, &fort[i].Y, &fort[i].R, &fort[i].C);
    }
    for( int i = 0; i < M; i++ )
    {
         scanf("%d%d%d", &lyc[i].X, &lyc[i].Y, &lyc[i].L);
    }
    
    for( int i = 0; i < N; i++ )
    {
         vart[i].F = 0;
         vart[i].S = i;
         for( int j = 0; j < M; j++ )
         {
              if( dist( fort[i].X, fort[i].Y, lyc[j].X, lyc[j].Y ) < (double)fort[i].R )
              {
                  wh[j] = i;
                  vart[i].F += (long long)fort[i].C * (long long)lyc[j].L;
              }
         }
    }
    
    sort( &vart[0], &vart[N] );
    for( int i = 0; i < K; i++ )
    {
         fort[vart[N - 1 - i].S].C = 0;
    }
    
    long long ans = 0;
    for( int i = 0; i < M; i++)
    {
         ans += (long long)fort[wh[i]].C * (long long)lyc[i].L;
    }
    
    cout << ans << endl;
    
    fclose(stdin);
    fclose(stdout);
    return 0;
}
