#include <fstream>
#include <math.h>
#include <stack>

using namespace std;
int width,height;
struct Point
{
	int X,Y;
};
int main()
{
	ifstream cin("cap.dat");
	ofstream cout("cap.sol");

	cin>>width>>height;
	char** arr=new char*[width];
	int** data=new int*[width];
	for(int i=0;i<width;i++)
	{
		arr[i]=new char[height];
		data[i]=new int[height];
		for(int j=0;j<height;j++)
			data[i][j]=0;
	}
	char c;
	int t=0;
	int sX,sY,fX,fY;
	for(int i=0;i<width;i++)
	{
		for(int j=0;j<height;j++)
		{
			cin>>c;
			arr[i][j]=c;
			if(c=='x' || c=='o' || c=='+')
			{
				t++;
				arr[i][j]='x';
			}

			if(c=='o')
			{
				sX=i;
				sY=j;
			}
			else if(c=='+')
			{
				fX=i;
				fY=j;
			}
		}
	}
	int counter=0;

	int cX=sX,cY=sY;
	int step=0;
	bool hasResult=false;
	Point p={sX,sY},temp;
	stack<Point> *current=new stack<Point>();
	stack<Point> *next=new stack<Point>();
	current->push(p);
	while(true)
	{
		step++;
		hasResult=false;
		while(!current->empty())
		{
			temp=current->top();
			current->pop();
			cX=temp.X;
			cY=temp.Y;
			for(int i=0;i<width;i++)
			{
				if(i==cX)
					continue;

				if(arr[i][cY]=='x')
				{
					if(i==fX && cY==fY)
					{
						cout<<step<<endl;
						return 0;
					}
					if(data[i][cY]==0)
					{
						data[i][cY]=step;
						p.X=i;
						p.Y=cY;
						next->push(p);
						hasResult=true;
					}
				}
			}

			for(int j=0;j<height;j++)
			{
				if(j==cY)
					continue;
				if(arr[cX][j]=='x')
				{
					if(cX==fX && j==fY)
					{
						cout<<step<<endl;
						return 0;
					}
					if(data[cX][j]==0)
					{
						data[cX][j]=step;
						p.X=cY;
						p.Y=j;
						next->push(p);
						hasResult=true;
					}
				}
			}
			if(!hasResult)
			{
				cout<<-1<<endl;
				return 0;
			}
		}
		current=next;
		next=new stack<Point>();
	}

	cout<<step<<endl;
	return 0;
}