#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <list>
#include <queue>
#include <set>
#include <map>
#include <utility>
#include <algorithm>

using namespace std;

//ifstream fin("calendar.dat");
ofstream fout("calendar.sol");
FILE *fh = fopen ( "calendar.dat", "r" );

const int MAXN = int(1e5)+42;

int calendar_1[2*MAXN], calendar_2[2*MAXN];

int main(){
    int n;
    fscanf( fh, "%d", &n );
    //fin >> n;

    for ( int i = 0; i < n; ++i ) {
        //fin >> calendar_1[i];
        fscanf( fh, "%d", &calendar_1[i] );

    }
    memcpy ( calendar_1+n, calendar_1, sizeof ( int ) * n );
    for ( int i = 0; i < n; ++i ) {
        //fin >> calendar_2[i];
        fscanf( fh, "%d", &calendar_2[i] );
    }
    int max_cnt = -1;
    for ( int shift = 0; shift < n; ++shift ) {
        int cnt = 0;
        for ( int i = 0; i < n; ++i ) {
            if ( calendar_1[i+shift] == calendar_2[i] ) {
                ++cnt;
            }
        }
        max_cnt = max ( cnt, max_cnt );
    }

    fout << max_cnt << endl;
    fout.close();
    return 0;
}
