#include<cstdio>
#include<iostream>
#include<algorithm>
#include<queue>
#include<map>
#include<vector>
using namespace std;
long long const infinyty=(long long)1000*1000*1000*1000*1000*10;
map<int,long long> m[200000];
long long dist[200000];
priority_queue<pair<long long,int> > q;
vector<pair<int,int> > graph[200000];
void create(int a,int b,long long cost)
{
    graph[a].push_back(make_pair(b,cost));
}
void mascreate(int a,int b,int dop)
{
    for(int i=0;i<graph[a].size();i++)
    {
        graph[b].push_back(make_pair(graph[a][i].first,graph[a][i].second+dop));
    }
}
void dextra()
{
	while(!q.empty())
	{
		pair<int,int> p=q.top();
		q.pop();
		long long cost=p.first*-1;
		int from=p.second;
		if(dist[from]<cost)
			continue;
        for(int i=0;i<graph[from].size();i++)
        {
            if(dist[from]+graph[from][i].second<dist[graph[from][i].first])
            {
                dist[graph[from][i].first]=dist[from]+graph[from][i].second;
                q.push(make_pair((dist[from]+graph[from][i].second)*-1,graph[from][i].first));
            }
        }
	}
}
int main()
{
	freopen("olympair.dat","r",stdin);
	freopen("olympair.sol","w",stdout);
	int n,m;
	cin>>n>>m;
	for(int i=0;i<m;i++)
	{
		int t,a,b,c;
		scanf("%d%d%d%d",&t,&a,&b,&c);
		if(t==1)
			create(a,b,c);
		else
			mascreate(a,b,c);
	}
	for(int i=0;i<=n;i++)
		dist[i]=infinyty;
	dist[1]=0;
	q.push(make_pair(0,1));
	dextra();
	for(int i=2;i<=n;i++)
	{
		if(dist[i]!=infinyty)
		printf("%lld\n",dist[i]);
		else
			printf("-1\n");
	}
	return 0;
}
