#include <iostream>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <queue>

using namespace std;

int N, M, t, A, B, C;

vector < vector < pair < int, long long > > > g;
vector < long long > d;

set < pair < long long, int > > s;

long long INF = (long long)1e15;

int main()
{
	freopen("olympair.dat", "r", stdin);
	freopen("olympair.sol", "w", stdout);
	scanf("%d %d", &N, &M);
	g.resize(N);
	d.assign(N, INF);

	for (int i = 0; i < M; ++i)
	{
		//cin >> t >> A >> B >> C;
		scanf("%d %d %d %d", &t, &A, &B, &C);
		if (t == 1)
			g[A - 1].push_back(make_pair(B - 1, C));
		else
		{
			for (int j = 0; j < g[A - 1].size(); ++j)
			{
				int v_j = g[A - 1][j].first;
				long long t_j = g[A - 1][j].second;
				g[B - 1].push_back(make_pair(v_j, t_j + C));
			}
		}
	}

	d[0] = 0;
	s.insert(make_pair(0, 0));

	while (!s.empty())
	{
		int v = s.begin()->second;
		long long c = s.begin()->first;
		s.erase(s.begin());
		
		for (int i = 0; i < g[v].size(); ++i)
		{
			int to = g[v][i].first;
			long long cost = g[v][i].second;
			if (c + cost < d[to])
			{
				s.erase(make_pair(d[to], to));
				d[to] = c + cost;
				s.insert(make_pair(d[to], to));
			}
		}
	}

	for (int i = 0; i < N - 1; ++i)
		if (d[i + 1] == INF)
			printf("%d\n", -1);
		else
			printf("%Ld\n", d[i + 1]);
	//system("pause");
}