#include <iostream>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <time.h>

using namespace std;

const int INF = (int)1e9 + 7;

int N, M;
int p1[2], p2[2];

string s;
int m[1001][1001];

//vector < vector < int > > col;
//vector < vector < int > > row;
vector < int > col;
vector < int > row;

vector < vector < int > > g;
int p[1000010];

unsigned char c;

int get_ch()
{
	if (c == '.')
		return 0;
	if (c == 'x')
		return 1;
	if (c == 'o')
		return 2;
	return 3;
}

int get(int i, int j)
{
	return i * M + j;
}

void read()
{
	scanf("%d %d\n", &N, &M);
	col.assign(M, -1);
	row.assign(N, - 1);
	g.resize(N * M + 10);

	for (int i = 0; i < N; ++i)
	{
		for (int j = 0; j < M; ++j)
		{
			scanf("%c", &c);
			m[i][j] = get_ch();
			if (m[i][j] == 2)
				p1[0] = i, p1[1] = j;
			if (m[i][j] == 3)
				p2[0] = i, p2[1] = j;

			if (m[i][j] != 0)
			{
				if (row[i] != -1)
				{
					int x = i;
					int y = row[i];
					g[get(i, j)].push_back(get(x, y));
					g[get(x, y)].push_back(get(i, j));
				}

				if (col[j] != -1)
				{
					int x = col[j];
					int y = j;
					g[get(i, j)].push_back(get(x, y));
					g[get(x, y)].push_back(get(i, j));
				}

				row[i] = j;
				col[j] = i;
			}
		}
		scanf("%c", &c);
	}
}



vector < int > d;

pair < int, int > cord(int i)
{
	return make_pair(i / M, i % M);
}

vector < int > w;

int main()
{
	ios::sync_with_stdio(0);

	freopen("cap.dat", "r", stdin);
	freopen("cap.sol", "w", stdout);
	read();
	d.assign(N * M + 10, INF);

	if (p1[0] == p2[0] || p1[1] == p2[1])
	{
		printf("%d\n", 1);
		return 0;
	}

	queue < int > q;
	d[get(p1[0], p1[1])] = 0;
	q.push(get(p1[0], p1[1]));
	p[get(p1[0], p1[1])] = -1;

	int cnt = 0;

	while (!q.empty() && d[get(p2[0], p2[1])] == INF)
	{
		if (((double)clock() / (double)CLOCKS_PER_SEC) > 0.25)
		{
			printf("%d\n", -1);
			return 0;
		}
		
		int v = q.front();
		q.pop();

		for (int k = 0; k < g[v].size(); ++k)
		{
			int to = g[v][k];
			if (d[v] + 1 < d[to])
			{
				p[to] = v;
				d[to] = d[v] + 1;
				q.push(to);
			}
		}
	}

	if (d[get(p2[0], p2[1])] == INF)
		printf("%d\n", -1);
	else
	{
		long long ans = 0;
		int last = 0;

		int t = get(p2[0], p2[1]);
		while (t != get(p1[0], p1[1]))
		{
			pair < int, int > r1 = cord(t);
			pair < int, int > r2 = cord(p[t]);
			if (r1.first == r2.first)
				w.push_back(1);
			else
				w.push_back(2);
			t = p[t];
		}

		ans = 1;
		last = w[0];
		for (int i = 1; i < w.size(); ++i)
			if (w[i] != last)
			{
				++ans;
				last = w[i];
			}
		cout << ans << endl;
	}
	//system("pause");
}