#include <iostream>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <time.h>

using namespace std;

const int INF = (int)1e9 + 7;

int a[1001], b[1001], d[1001];

int N, ans, m;

bool cmp()
{
	bool f = true;
	for (int i = 0; i < N && f; ++i)
		if (a[i] % 4  != b[i])
			f = false;
	return f;
}



bool dfs(int c)
{
	if (c == 0)
		return cmp();

	/*for (int i = 0; i < N; ++i)
		for (int j = i; j < N; ++j)
		{
			for (int k = i + 1; k <= j; ++k)
				if (d[k] != d[k - 1])
					continue;
			for (int k = i; k <= j; ++k)
				++a[k];

			if(dfs(c - 1))
			{
				for (int k = i; k <= j; ++k)
					--a[k];
				return true;
			}
			
			for (int k = i; k <= j; ++k)
				--a[k];
		}*/

	for (int i = 0; i < N; ++i)
	{
		int r = i + 1;
		while (r < N && d[r] == d[i]) ++r;
		
		for (int j = i; j < r; ++j)
			++a[j], --d[j];

		if (dfs(c - 1))
		{
			for (int j = i; j < r; ++j)
			--a[j], ++d[j];
			return true;
		}

		for (int j = i; j < r; ++j)
			--a[j], ++d[j];
	}

	return false;
}

int main()
{
	srand(time(0));
	ios::sync_with_stdio(0);
	freopen("tetris.dat", "r", stdin);
	freopen("tetris.sol", "w", stdout);

	scanf("%d", &N);
	for (int i = 0; i < N; ++i)
		scanf("%d", &a[i]);
	for (int i = 0; i < N; ++i)
		scanf("%d", &b[i]);

	for (int i = 0; i < N; ++i)
		d[i] = (b[i] - a[i] > 0) ? b[i] - a[i] : 4 + b[i] - a[i];

	int l = 1;
	int r = 30;
	int tm = 0;

	while (l + 1 < r)
	{
		tm = (l + r) / 2;
		if (dfs(tm))
			r = tm;
		else
			l = tm;
	}

	if (dfs(l))
		printf("%d\n", l);
	else
		printf("%d\n", r);
		

	/*for (int i = 0; i < 100; ++i)
	{
		if (dfs(i))
		{
			printf("%d\n", i);
			break;
		}
	}*/

	//system("pause");
}