#include<cstdio>
#include<cmath>
#include<algorithm>
#include<list>
#include<set>

#define Min(a,b) (a)<(b)?(a):(b)

using namespace std;

typedef long long ll;

const int maxn = 35011;
const int INF=1e18;

struct _fort{
	int x, y, r, c,hm;
	ll cost;
	int id;
};
/*bool operator<(_fort a, _fort b){
	if(a.r != b.r) return a.r < b.r;
	return (a.x<b.x) || (a.x==b.x && a.y<b.y);
}*/

struct _knight{
	int x, y, am;
};

int n, m, k;
int hm[maxn];
_fort F[maxn];
_knight K[maxn];

bool rvs(_fort a, _fort b){
	return a.cost>b.cost || (a.cost == b.cost && a.id<b.id);
}

bool in(_knight k, _fort f){
	//printf("[%d %d] [%d %d] (%d)\n", k.x, k.y, f.x, f.y, f.r);
	ll d = ((ll)k.x-f.x)*(k.x-f.x) + ((ll)k.y-f.y)*(k.y-f.y);
	if(d < (ll)f.r*f.r) {
		//printf("+\n");
		return true;
	}
	//printf("false\n");
	return false;
}

ll _min(ll a, ll b){
	if(a>b) a=b;
	return a;
}

int find_id(int a){
	for(int i=1; i<=n; i++)
		if(F[i].id==a) return i;
	return 0;
}

int main(){
	freopen("camelot.dat","r",stdin);
	freopen("camelot.sol","w",stdout);
	scanf("%d%d%d", &n, &m, &k);
	for(int i=1;i<=n;i++){
		scanf("%d%d%d%d", &F[i].x, &F[i].y, &F[i].r, &F[i].c);
		F[i].id=i;
	}
	for(int i=1;i<=m;i++){
		scanf("%d%d%d", &K[i].x, &K[i].y, &K[i].am);
	}
	bool any;
	for(int i=1;i<=m;i++){
		any = false;
		for(int j=1; j<=n; j++)
			if(in(K[i],F[j])){
				F[j].hm += K[i].am;
				any = true;
				break;
			}
		if(any == false){
			F[0].hm += K[i].am;
		}
	}
	int sum=0;//total men
	for(int i=1; i<=n; i++)
		F[i].cost = (ll)F[i].hm*F[i].c;
	for(int i=0; i<=n; i++) {
		sum += F[i].hm;
		//printf("cost in %d castle : %d*%d\n", i,hm[i], F[i].c);
	}
	sort(F+1, F+1+m,rvs);
	for(int i=0; i<=n; i++) {
		//printf("cost in %d castle : %d*%d -- %I64d\n", i,F[i].hm, F[i].c, F[i].cost);
	}
	F[0].cost = 0;
	int bc;
	ll cmin =0, cnt;
	for(int i=k+1; i<=n; i++)
		cmin+=F[i].cost;
	//printf("now %I64d\n",cmin);
	//printf("total population %d\n", sum);
	bool was;
	for(int i=1; i<=n;i++){
		//printf("hostedby %d\n",i);
		cnt = 0;
		for(int i=k; i<=n; i++)
			cnt += F[i].cost;
		cmin = _min(cmin,cnt);
		//printf("now %I64d\n",cmin);
		cnt = (sum - F[i].hm)*F[i].c;
		was = false;
		for(int j=k+1; j<=n; j++)
			if(i!=j)
				cnt += F[j].cost;
			else was = true;
		if(was == true)
			cnt -= F[k].cost;
		cmin = _min(cmin,cnt);
		//printf("now %I64d\n",cmin);
	}
	printf("%lld\n",cmin);
	return 0;
}
