type
  int=longint;

var
  n,m:int;
  i,j:int;
  x,t,w,y,u:int;
  stones:array[1..100000]of array of int;

procedure swap(var a,b:int);
var
  k:int;
begin
  k:=a;
  a:=b;
  b:=k;
end;

procedure Heapify(i,k:int);
begin
  if k=0 then exit;
  if(stones[i,k]<stones[i,(k-1)shr 1])then begin
    swap(stones[i,k],stones[i,(k-1)shr 1]);
    Heapify(i,(k-1)shr 1);
  end;
end;

procedure RevHeapify(i,k:int);
begin
  if k shl 1+1>high(stones[i])then exit;
  if k shl 1+1=high(stones[i])then begin
    if stones[i,k shl 1+1]<stones[i,k] then begin
      swap(stones[i,k],stones[i,k shl 1+1]);
      RevHeapify(i,k shl 1+1);
    end;
    exit;
  end;
  if(stones[i,k shl 1+1]<stones[i,k shl 1+2])then begin
    if stones[i,k shl 1+1]<stones[i,k] then begin
      swap(stones[i,k],stones[i,k shl 1+1]);
      RevHeapify(i,k shl 1+1);
    end;
  end else begin
    if stones[i,k shl 1+2]<stones[i,k] then begin
      swap(stones[i,k],stones[i,k shl 1+2]);
      RevHeapify(i,k shl 1+2);
    end;
  end;
  {
  if k shl 1+1>high(stones[i])then exit;
  if stones[i,k]>stones[i,k shl 1+1]then begin
    swap(stones[i,k],stones[i,k shl 1+1]);
    RevHeapify(i,k shl 1+1);
  end;
  if k shl 1+2>high(stones[i])then exit;
  if stones[i,k]>stones[i,k shl 1+2]then begin
    swap(stones[i,k],stones[i,k shl 1+2]);
    RevHeapify(i,k shl 1+2);
  end;
  }
end;

procedure AddStone(k,w:int);
begin
  SetLength(stones[k],length(stones[k])+1);
  stones[k,high(stones[k])]:=w;
  Heapify(k,high(stones[k]));
end;

procedure Remove(i,k:int);
begin
  swap(stones[i,k],stones[i,high(stones[i])]);
  SetLength(stones[i],high(stones[i]));
  RevHeapify(i,0);
end;

procedure WriteHeap(i:int);
var
  j:int;
begin
  for j:=0 to high(stones[i]) do write(' ',stones[i,j]);
end;

begin
  assign(input,'stones.dat');
  reset(input);
  assign(output,'stones.sol');
  rewrite(output);

  readln(n,m);
  for i:=1 to m do SetLength(stones[i],0);
  for i:=1 to n do begin
    read(x);
    if x=1 then begin
      read(t,w);
      AddStone(t,w);
      //write(t,'(',w,')');WriteHeap(t);writeln;
    end else begin
      y:=1;
      u:=stones[y,0];
      for j:=2 to m do if stones[j,0]>u then begin
        y:=j;
        u:=stones[j,0];
      end;
      Remove(y,0);
      //write(y,'(',u,')');WriteHeap(y);writeln;
      writeln(u);
    end;
  end;

  close(output);
  close(input);
end.