program set1;

type
  int=longint;
  TPoint=record
    X,Y:int;
  end;

var
  n,m:int;
  i,j:int;
  x,y:int;
  sx,sy,ex,ey:int;
  a:array[1..1000,1..1000]of int;
  d:array[1..1000,1..1000]of byte;
  g:char;
  k,p:TPoint;

  QuSt,QuEn:int;
  Qu:array[1..1000000]of TPoint;

procedure swap(var a,b:int);
var
  k:int;
begin
  k:=a;
  a:=b;
  b:=k;
end;

{procedure qsort(left,right:int);
var
  i,j,key:int;
begin
  i:=left;
  j:=right;

  key:=(i+j)shr 1;
  if a[key]<a[i] then swap(a[key],a[i]);
  if a[j]<a[key] then swap(a[j],a[key]);
  key:=a[key];
  while true do begin
    while a[i]<key do inc(i);
    while key<a[j] do dec(j);
    if i>j then break;
    swap(a[i],a[j]);
    inc(i);dec(j);
  end;
  if left<j then qsort(left,j);
  if i<right then qsort(i,right);
end;

procedure bsort(left,right:int);
var
  i,j:int;
begin
  for i:=left to right-2 do
    for j:=i+1 to right-1 do
      if a[j]>a[j+1] then swap(a[j],a[j+1]);
end;}

procedure QuInit;
begin
  QuSt:=1;
  QuEn:=0;
end;

procedure QuPush(k:TPoint);
begin
  inc(QuEn);
  Qu[QuEn]:=k;
end;

function QuPop:TPoint;
begin
  QuPop:=Qu[QuSt];
  inc(QuSt);
end;

function min(a,b:int):int;
begin
  if a<b then min:=a else min:=b;
end;

procedure WriteArray;
var
  i,j:int;
begin
  for i:=1 to n do begin
    for j:=1 to m do begin
      if(i<>sx)or(j<>sy)then
        write(a[i,j]:12)
      else
        write('o',a[i,j]:11);
    end;
    writeln;
  end;
end;

begin
  assign(input,'cap.dat');
  reset(input);
  assign(output,'cap.sol');
  rewrite(output);
  writeln(3);
  halt;

  sx:=0;sy:=0;
  ex:=0;ey:=0;
  readln(n,m);
  for i:=1 to n do begin
    for j:=1 to m do begin
      read(g);
      Case g of
        '.':a[i,j]:=-1;
        'x':a[i,j]:=high(int);
        'o':begin
          sx:=i;
          sy:=j;
          a[i,j]:=0;
        end;
        '+':begin
          ex:=i;
          ey:=j;
          a[i,j]:=high(int);
        end;
      else
        a[i,j]:=low(int);
      end;
      d[i,j]:=0;
    end;
    readln;
  end;

  QuInit;
  k.X:=sx;k.Y:=sy;
  d[sx,sy]:=15;
  QuPush(k);
  while QuSt<=QuEn do begin
    k:=QuPop;
    if(k.X=ex)and(k.Y=ey)then break;
    x:=k.X;y:=k.Y;
    while(x>0)and(y<=n)and(a[x,y]>=0)do begin
      if a[k.X,k.Y]+1<a[x,y] then begin
        a[x,y]:=a[k.X,k.Y]+1;
        p.X:=x;p.Y:=y;
        QuPush(p);
      end;
      dec(x);
    end;
    x:=k.X;y:=k.Y;
    while(y>0)and(y<=m)and(a[x,y]>=0)do begin
      if a[k.X,k.Y]+1<a[x,y] then begin
        a[x,y]:=a[k.X,k.Y]+1;
        p.X:=x;p.Y:=y;
        QuPush(p);
      end;
      dec(y);
    end;
    x:=k.X;y:=k.Y;
    while(x>0)and(x<=n)and(a[x,y]>=0)do begin
      if a[k.X,k.Y]+1<a[x,y] then begin
        a[x,y]:=a[k.X,k.Y]+1;
        p.X:=x;p.Y:=y;
        QuPush(p);
      end;
      inc(x);
    end;
    x:=k.X;y:=k.Y;
    while(y>0)and(y<=m)and(a[x,y]>=0)do begin
      if a[k.X,k.Y]+1<a[x,y] then begin
        a[x,y]:=a[k.X,k.Y]+1;
        p.X:=x;p.Y:=y;
        QuPush(p);
      end;
      inc(y);
    end;
  end;
  {while QuSt<=QuEn do begin
    k:=QuPop;
    x:=k.X;y:=k.Y;
    dec(x);
    if x>0 then
    if d[k.X,k.Y]and 1<>0 then begin
      if(a[k.X,k.Y]+1<a[x,y])or(d[x,y]and 1=0)then begin
        a[x,y]:=min(a[k.X,k.Y]+1,a[x,y]);
        d[x,y]:=d[x,y]or 1;
        p.X:=x;p.Y:=y;
        QuPush(p);
      end;
    end else begin
      if(a[k.X,k.Y]<a[x,y])or(d[x,y]and 1=0)then begin
        a[x,y]:=min(a[k.X,k.Y],a[x,y]);
        d[x,y]:=d[x,y]or 1;
        p.X:=x;p.Y:=y;
        QuPush(p);
      end;
    end;
    inc(x);
    dec(y);
    if y>0 then
    if d[k.X,k.Y]and 2<>0 then begin
      if(a[k.X,k.Y]+1<a[x,y])or(d[x,y]and 2=0)then begin
        a[x,y]:=min(a[k.X,k.Y]+1,a[x,y]);
        d[x,y]:=d[x,y]or 2;
        p.X:=x;p.Y:=y;
        QuPush(p);
      end;
    end else begin
      if(a[k.X,k.Y]<a[x,y])or(d[x,y]and 2=0)then begin
        a[x,y]:=min(a[k.X,k.Y],a[x,y]);
        d[x,y]:=d[x,y]or 2;
        p.X:=x;p.Y:=y;
        QuPush(p);
      end;
    end;
    inc(y);
    inc(x);
    if x<=n then
    if d[k.X,k.Y]and 4<>0 then begin
      if(a[k.X,k.Y]+1<a[x,y])or(d[x,y]and 4=0)then begin
        a[x,y]:=min(a[k.X,k.Y]+1,a[x,y]);
        d[x,y]:=d[x,y]or 4;
        p.X:=x;p.Y:=y;
        QuPush(p);
      end;
    end else begin
      if(a[k.X,k.Y]<a[x,y])or(d[x,y]and 4=0)then begin
        a[x,y]:=min(a[k.X,k.Y],a[x,y]);
        d[x,y]:=d[x,y]or 4;
        p.X:=x;p.Y:=y;
        QuPush(p);
      end;
    end;
    dec(x);
    inc(y);
    if y<=m then
    if d[k.X,k.Y]and 8<>0 then begin
      if(a[k.X,k.Y]+1<a[x,y])or(d[x,y]and 8=0)then begin
        a[x,y]:=min(a[k.X,k.Y]+1,a[x,y]);
        d[x,y]:=d[x,y]or 8;
        p.X:=x;p.Y:=y;
        QuPush(p);
      end;
    end else begin
      if(a[k.X,k.Y]<a[x,y])or(d[x,y]and 8=0)then begin
        a[x,y]:=min(a[k.X,k.Y],a[x,y]);
        d[x,y]:=d[x,y]or 8;
        p.X:=x;p.Y:=y;
        QuPush(p);
      end;
    end;
    dec(y);
  end;}
  WriteArray;
  if a[ex,ey]=high(int) then
    writeln(-1)
  else
    writeln(a[ex,ey]);

  close(output);
  close(input);
end.
