#include <iostream>
#include <fstream>
#include <vector>
using namespace std;

typedef unsigned long long ULL;

inline long long sqr(int x)
{
 return (long long)x * (long long)x;      
}


//vector<int> ch[35007];

struct fort
{
 int x,y,r,c,sod;  
 long long r2;
 
 bool isPointInside(int px,int py)
 {
      return ( sqr(px-x)+sqr(py-y)<r2 );
 } 
          
};
struct knight
{
    int x,y,l,sod;   
};

fort fs[35007];
knight ks[35007];

ULL cost[35007];

int path1[35007],p1;
int path2[35007],p2;


int main()
{
    ifstream cin("camelot.dat");
    ofstream cout("camelot.sol");
    int n,m,k,i,j;
    
    cin>>n>>m>>k;
    for(i=1;i<=n;i++)
    {
     cin>>fs[i].x>>fs[i].y>>fs[i].r>>fs[i].c;  
     fs[i].r2=(long long)(fs[i].r)*(long long)(fs[i].r);              
    }
    for(i=1;i<=m;i++)cin>>ks[i].x>>ks[i].y>>ks[i].l;
    
    for(i=1;i<=n;i++)fs[i].sod=0;
    for(j=1;j<=m;j++)ks[i].sod=0;
    
    for(i=1;i<=n;i++)
      {
       for(j=1;j<i;j++)
        if(fs[i].isPointInside(fs[j].x,fs[j].y))
          if(fs[j].sod==0 || fs[fs[j].sod].r>fs[i].r)
            fs[j].sod=i;    
      
       for(j=i+1;j<=n;j++)
        if(fs[i].isPointInside(fs[j].x,fs[j].y))
          if(fs[j].sod==0 || fs[fs[j].sod].r>fs[i].r)
            fs[j].sod=i;    
    
       for(j=1;j<=m;j++)
         if(fs[i].isPointInside(ks[j].x,ks[j].y))
           if(ks[j].sod==0 || fs[ks[j].sod].r>fs[i].r)
             ks[j].sod=i;
      }
      
    // for(i=1;i<=n;i++)ch[fs[i].sod].push_back(i); 
      
      
      //for(i=1;i<=n;i++)cout<<"SOD OF FORT " << i <<" IS " << fs[i].sod<<endl;
      //for(i=1;i<=m;i++)cout<<"SOD OF KNIGHT " << i <<" IS " << ks[i].sod<<endl;
      
    
    
    
    ULL ans=-1;
    
    
    
    for(i=0;i<=n;i++)
    {
     // cout<<"SBOR V "<<i<<endl;               
                     
                     
      p1=0;int t=i;
      do
      {
        path1[p1]=t;
        if(t!=0){t=fs[t].sod;p1++;}       
      }
      while(t!=0);
      
      for(j=0;j<=m;j++)cost[j]=0;
       
      
      for(j=1;j<=m;j++)
      { 
        
        //stroim put' ot rycara k kornu
        p2=0;int t=ks[j].sod;
        do
        {
          path2[p2]=t;
          if(t!=0){t=fs[t].sod;p2++;}       
        }
        while(t!=0);              
         
        int i1=p1,i2=p2,i3;
        do
        {
         i1--;i2--;   
        }while(i1>=0 && i2>=0 && path1[i1]==path2[i2]);
        for(i3=0;i3<=i1;i3++)cost[path1[i3]]+=(long long)fs[path1[i3]].c*(long long)ks[j].l;
        for(i3=0;i3<=i2;i3++)cost[path2[i3]]+=(long long)fs[path2[i3]].c*(long long)ks[j].l;            
      }         
      
      //for(j=1;j<=n;j++)cout<<cost[j]<<" ";cout<<endl;
      
      sort(cost,cost+m+1);     
      ULL val=0;
      for(j=0;j<=m-k;j++)val+=cost[j];  
   //cout<<"COST IS "<<val<<endl<<endl;              
      if(ans==-1 || ans>val)ans=val;               
    }
    
   
   
    cout<<ans<<endl;
   
    return 0;
}
