#include <iostream>
#include <fstream>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>

#define FOR0(i,n) for( i = 0 ; i < n ; i++ )
#define FOR1(i,n) for( i = 1 ; i <= n ; i++ )
#define sys_p system( "pause" ) 

using namespace std ;

typedef long long LL ;

ifstream Cin( "mutation.dat" ) ;
ofstream Cout( "mutation.sol" ) ;

vector < LL > proc( vector < LL > r )
{
      LL i, n = (LL)r.size() ;
      
      if( n == 1 )
        return vector < LL > (0) ;
      
      LL num[100001] = {}, found = 0 ;   
         
      FOR0( i, n )
              num[ r[i] ]++ ;
      FOR0( i, n )
        if( num[ r[i] ] > 1 )
        {
        
        if( i == 0 )
        {
          if( r[i] != r[i+1] )
          {
            found = r[i] ;
            break ;
          }
        }
        else if( i == n-1 )
        {
          if( r[i] != r[i-1] )
          {
            found = r[i] ;
            break ;
          }
        }    
        else if( r[i] != r[i+1] && r[i] != r[i-1] )
        {
          found = r[i] ;
          break ;
        }
        
        }
        
      if( !found )
        return vector < LL > (0) ;  
       
      //cout << found << endl ; 
        
      vector < LL > new_r ;
      FOR0( i, n )
        if( r[i] != found )
          new_r.push_back( r[i] ) ;
      return new_r ;
}

main()
{
      LL n, i, ans = 0 ;
      Cin >> n ;
      vector < LL > r(n,0) ;
      FOR0( i, n )
        Cin >> r[i] ;
        
      while( true )
      {
             vector < LL > got = proc( r ) ;
             if( (LL)got.size() == 0 ) 
               break ;
             ans++ ;
             r = got ;
      }
      Cout << ans ;
      //sys_p ;
}
