#include <stdio.h>
#include <vector>
#include <queue>
using namespace std;
#define mp make_pair 
#define INF 1000000000000000
vector <vector <pair<int,long long> > > g;


int main(){
#ifndef _DEBUG
	freopen("olympair.dat","r",stdin);
	freopen("olympair.sol","w",stdout);
#endif
	int n,m;
	scanf("%d%d",&n,&m);
	g.resize(n);
	for (int i=0; i<m; i++){
		int op,A,B,C;	
		scanf("%d %d %d %d",&op,&A,&B,&C);
		A--;
		B--;
		if (op==1){

			g[A].push_back(mp(B,C));
		}
		else {
			for (int j=0; j<g[A].size(); j++){
				g[B].push_back(mp(g[A][j].first,g[A][j].second+C));
			}
		}
	}
	vector <long long> d(n,INF);
	d[0]=0;
	for (int i=0; i<n-1; i++){
		for (int k=0; k<n; k++) {
			for (int j=0; j<g[k].size(); j++){
				int to=g[k][j].first,cost=g[k][j].second;
				if (d[k]<INF){
					d[to]=min(d[to],d[k]+cost);
				}
			}
		}
	}
	for (int i=1; i<n; i++){
		if (d[i]==INF) puts("-1");
		else printf("%lld\n",d[i]);
	}
	return 0;
}
