#include <stdio.h>
#include <vector>
#include <queue>
using namespace std;
#define mp make_pair 
#define INF 1000000000000000
#define MOD 0
struct edge{
	int b,cost;
	bool real;
};
vector <vector<edge> > g;


int main(){
#ifndef _DEBUG
	freopen("olympair.dat","r",stdin);
	freopen("olympair.sol","w",stdout);
#endif
	int n,m;
	scanf("%d%d",&n,&m);
	g.resize(n);
	for (int i=0; i<m; i++){
		int op,A,B,C;	
		scanf("%d %d %d %d",&op,&A,&B,&C);
		A--;
		B--;
		C+=MOD;
		edge temp; temp.cost=C;
		if (op==1){
			temp.b=B; temp.real=true;
			g[A].push_back(temp);
		}
		else {
			temp.b=A; temp.real=false;
			g[B].push_back(temp);
		}
	}
	vector <long long> dreal(n,INF),dvr(n,INF);
	dreal[0]=0;
	priority_queue <pair<long long,int>,vector<pair<long long,int> >,greater<pair<long long,int> > >  q;
	q.push(mp(0,0));
	while (!q.empty()){
		pair<long long,int> v=q.top();
		q.pop();
		int from=v.second;
		for (int i=0; i<g[v.second].size(); i++){
			long long cost=g[v.second][i].cost;
			int to=g[v.second][i].b;
			bool rl=g[v.second][i].real;
			if (rl && dreal[to]>dreal[from]+cost){
				dreal[to]=min(dreal[from],dvr[from])+cost;
				q.push(mp(dreal[to],to));
			}
			else if (!rl) {
				dvr[to]=dreal[from]+cost;
				q.push(mp(dvr[to],to));
			}
		}
	}
	for (int i=1; i<n; i++){
		if (dreal[i]==INF) puts("-1");
		else printf("%lld\n",dreal[i]-MOD);
	}
	return 0;
}
