#include <algorithm>
#include <fstream>
#include <numeric>
#include <vector>

#define trololo

bool check(const std::vector<long long>& length,long long n)
{
	long long index = 0;
	long long difference = length[n - 1] - length[0];
	for(long long i = 1;i < length.size() - n + 1;i++)
	{
		if(length[i + n - 1] - length[i] < difference)
		{
			index = i;
			difference = length[i + n - 1] - length[i];
		}
	}
	return std::accumulate(length.begin() + index,length.begin() + n - 1,0) > length[n - 1];
}

int main()
{
	std::ifstream in("set.dat"); //fix
	std::ofstream out("set.sol");
	long long n;
	in >> n;
	if(n < 3)
	{
		out << 0 << std::endl;
		in.close();
		out.close();
		return 0;
	}
	std::vector<long long> length(n);
	for(long long i = 0;i < length.size();i++)
		in >> length[i];
	in.close();
	std::sort(length.begin(),length.end());
	long long leftBorder = 3;
	long long rightBorder = length.size();
	while(leftBorder + 1 < rightBorder)
	{
		long long middle = (leftBorder + rightBorder) / 2;
		if(check(length,middle))
			leftBorder = middle;
		else 
			rightBorder = middle;
	}
	long long answer;
	if(check(length,rightBorder))
		answer = rightBorder;
	else if(check(length,leftBorder))
		answer = leftBorder;
	else
		answer = 0;
	out << answer << std::endl;
	out.close();
}