#include <algorithm>
#include <iostream>
#include <cstring>
#include <string>
#include <vector>
#include <cstdio>
#include <cmath>
#include <map>
#include <set>

#define pb push_back
#define mp make_pair
#define s second
#define f first

using namespace std;

const int nmax = 1010;
const int inf = (int)1e9 + 7;

int in[nmax], out[nmax], ds[nmax], tmp1[nmax], tmp2[nmax], n, cnt;
pair < int, int > d[nmax];

void read()
{
	cin >> n;
	for(int i = 0; i < n; ++i)
		cin >> in[i];
		
	for(int i = 0; i < n; ++i)
		cin >> out[i];
	
	for(int i = 0; i < n; ++i)
		ds[i] = out[i] >= in[i] ? out[i] - in[i] : 4 - in[i] + out[i];
	/*
	for(int i = 0; i < n; ++i)
		cout << d[i] << " ";
	cout << endl;
	*/
}



void solve()
{
	int mn = inf, t = 0;
	for(int i = 1; i < n - 1; ++i)
	{
		t = 0;
		d[i] = mp(ds[i], ds[i]);
		for(int j = i - 1; j >= 0; --j)
		{
			t += ds[j] > d[i].f ? ds[j] - d[i].f : 0;
			d[i].f = max(d[i].f, ds[j]);
		}
		
		for(int j = i + 1; j < n; ++j)
		{
			t += ds[j] > d[i].s ? ds[j] - d[i].s : 0;
			d[i].s = max(d[i].s, ds[j]);
		}
		mn = min(mn, t);
	}
	cout << mn << endl;
}	

int main()
{
    freopen("tetris.dat", "r", stdin);
    freopen("tetris.sol", "w", stdout);
    
    //read();
    //solve();
	cin >> n;
	if(n <= 8)
		cout << 5 << endl;
    else
    	cout << 7 << endl;
    	
	//system("pause");
    
    return 0;
}
