#include <iostream>
#include <stdio.h>

using namespace std;

long long int places, events;
long long int reach[10000];
long long int moves[10000][4]; // 0 - from, 1 - to, 2 - time, 4 - used.
long long int total = 0;

void f(long long int from, long long int time)
{
    if (time != 0 && from == 1) return;
    if (reach[from] > time || reach[from] == -1 || reach[from] == 0) reach[from] = time;
    for (long long int i = 0; i < total; i++)
    {
        if (moves[i][0] == from && moves[i][3] == 0)
        {
            moves[i][3] = 1;
            f(moves[i][1],time+moves[i][2]);
            moves[i][3] = 0;
        }
    }
}

int main()
{
    freopen("olympair.dat","r",stdin);
    freopen("olympair.sol","w",stdout);

    cin >> places >> events;

    for (long long int i = 0; i < places; i++) reach[i] = -1;

    for (long long int i = 0; i < events; i++)
    {
        int type;
        cin >> type;
        if (type == 1)
        {
            cin >> moves[total][0] >> moves[total][1] >> moves[total][2];
            moves[total][3] = 0;
            if (moves[total][0] != moves[total][1]) total++;
        }
        else
        {
            long long int A, B, C;
            cin >> A >> B >> C;
            for (long long int i = 0; i < total; i++)
            {
                if (moves[i][0] == A)
                {
                    moves[total][0] = B;
                    moves[total][1] = moves[i][1];
                    moves[total][2] = moves[i][2] + C;
                    moves[total][3] = 0;
                    total++;
                }
            }
        }
    }

    f(1,0);

    for (long long int j = 2; j <= places; j++)
    {
        if (reach[j] != 0) cout << reach[j] << endl; else cout << "-1\n";
    }

    return 0;
}
