#include <iostream>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <iomanip>
#include <vector>
#include <queue>
#include <deque>
#include <map>
#include <string>
#include <cstring>
#include <algorithm>
#include <utility>
#include <functional>
#include <stack>
#include <set>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;


#define mp make_pair
#define pb push_back
#define pii pair<int,int>
#define pll pair<ll,ll>
#define pdd pair<double,double>

struct vect{
	int x,y;
	vect( int x1 = 0, int y1 = 0, int x2 = 0, int y2 = 0 ):x(x2-x1),y(y2-y1){}
};


const int MXN = 200100;

set<pair<int,int>, greater<pair<int,int>> > all;

set<int> cts [MXN];
int sz [MXN];

void add( int i, int w ){
	if( sz[i] ){
		int cm = *cts[i].begin();

		if( cm>w ){
			all.erase(mp(cm,i));
			all.insert(mp(w,i));
		}
	}
	else all.insert(mp(w,i));

	cts[i].insert(w);
	sz[i]++;
}
int getres(){
	pair<int,int> cm = *all.begin();

	cts[cm.second].erase( cts[cm.second].begin());
	all.erase(all.begin());
	
	sz[cm.second]--;

	if( sz[cm.second] ){
		all.insert( mp(*cts[cm.second].begin(),cm.second) );
	}

	return cm.first;
}


int main(){
	freopen("stones.dat", "r", stdin);	freopen("stones.sol", "w", stdout);
	int n,m;
	scanf("%d%d", &n, &m);

	int q, t,w;

	for( int i = 0; i < n; i++ ){
		scanf("%d", &q);
		if( q-1 ){
			printf("%d\n", getres());
		}
		else{
			scanf("%d%d", &t, &w);
			add(t-1,w);
		}

	}
	
}
