#include <iostream>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <iomanip>
#include <vector>
#include <cstring>
#include <string>
#include <algorithm>
#include <queue>
#include <deque>
#include <stack>
#include <map>
#include <set>
#include <utility>
#include <functional>
#include <iostream>
#include <iostream>
#include <iostream>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

#define mp make_pair
#define pb push_back
#define pii pair<int,int>
#define pll pair<ll,ll>
#define pdd pair<double,double>

const int MXC = 2000100;
const int MXN = 1010;


bool mapp [MXN][MXN];


struct pos{
	int i,j;
	int dir; //1 - vert, 0 - hor
	pos( int i = 0, int j = 0, int dir = 0 ):i(i),j(j),dir(dir){}
};




int dst [MXN][MXN];

struct edgs{
	int pv,nv,ph,nh;
	edgs(int pv = -1, int nv = -1, int ph = -1, int nh = -1 ):pv(pv),nv(nv),ph(ph),nh(nh){}
};

edgs eds [MXN][MXN];


int lstv [MXN];

pos zr [MXC];
pos one [MXC];

int main(){
	freopen("cap.dat", "r", stdin);	
	freopen("cap.sol", "w", stdout);
	int n,m;
	char c;

	pii fr,to;

	scanf("%d%d", &n, &m);

	int lsth = -1;
	for( int i = 0; i < MXN; i++ ) lstv[i] = -1;

			scanf("%c",&c);
	for( int i = 0; i < n; i++ ){
		lsth = -1;
		for( int j = 0; j < m; j++ ){
			eds[i][j] = edgs();


			eds[i][j].pv = lstv[j];
			eds[i][j].ph = lsth;

			scanf("%c",&c);
			if( c=='o' ){
				fr = mp(i,j);
				mapp[i][j] = 1;

				if(lsth!=-1)
					eds[i][lsth].nh = j;
				if(lstv[j]!=-1)
					eds[ lstv[j] ][j].nv = i;

				lsth = j;
				lstv[j] = i;

			}
			else if( c=='+' ){
				to = mp(i,j);
				mapp[i][j] = 1;

				if(lsth!=-1)
					eds[i][lsth].nh = j;
				if(lstv[j]!=-1)
					eds[ lstv[j] ][j].nv = i;

				lsth = j;
				lstv[j] = i;

			}
			else if( c=='x' ){
				if(lsth!=-1)
					eds[i][lsth].nh = j;
				if(lstv[j]!=-1)
					eds[ lstv[j] ][j].nv = i;

				lsth = j;
				lstv[j] = i;
				mapp[i][j] = 1;
			}
		}
		scanf("%c",&c);
	}




	int zrc = 0, onc = 0;

	zr[zrc++] =  pos(fr.first, fr.second, 0) ;
	zr[zrc++] =  pos(fr.first, fr.second, 1) ;


	dst[fr.first][fr.second] = 1;

	while( zrc>0 ){
		for( int i = 0; i < zrc; i++ ){
			int ii = zr[i].i;
			int jj = zr[i].j;
			int dir = zr[i].dir;

			if( dir ){
				if( eds[ii][jj].nv!=-1 && !dst[ eds[ii][jj].nv ][jj] ){
					dst[ eds[ii][jj].nv ][jj] = dst[ii][jj];
					zr[zrc++] = pos( eds[ii][jj].nv, jj, 1 );
				}
				if( eds[ii][jj].pv!=-1 && !dst[ eds[ii][jj].pv ][jj] ){
					dst[ eds[ii][jj].pv ][jj] = dst[ii][jj];
					zr[zrc++] = pos( eds[ii][jj].pv, jj, 1 );
				}
			}
			else{
				if( eds[ii][jj].nh!=-1 && !dst[ii][ eds[ii][jj].nh ] ){
					dst[ii][ eds[ii][jj].nh ] = dst[ii][jj];
					zr[zrc++] = pos( ii, eds[ii][jj].nh, 0 );
				}
				if( eds[ii][jj].ph!=-1 && !dst[ii][ eds[ii][jj].ph ] ){
					dst[ii][ eds[ii][jj].ph ] = dst[ii][jj];
					zr[zrc++] = pos( ii, eds[ii][jj].ph, 0 );
				}
			}

		}
		onc = 0;
		for( int i = 0; i < zrc; i++ ){
			int ii = zr[i].i;
			int jj = zr[i].j;
			int dir = zr[i].dir;

			if( !dir ){
				if( eds[ii][jj].nv!=-1 && !dst[ eds[ii][jj].nv ][jj] ){
					dst[ eds[ii][jj].nv ][jj] = dst[ii][jj] + 1;
					one[onc++] = pos( eds[ii][jj].nv, jj, 1 );
				}
				if( eds[ii][jj].pv!=-1 && !dst[ eds[ii][jj].pv ][jj] ){
					dst[ eds[ii][jj].pv ][jj] = dst[ii][jj] + 1;
					one[onc++] = pos( eds[ii][jj].pv, jj, 1 );
				}
			}
			else{
				if( eds[ii][jj].nh!=-1 && !dst[ii][ eds[ii][jj].nh ] ){
					dst[ii][ eds[ii][jj].nh ] = dst[ii][jj] + 1;
					one[onc++] = pos( ii, eds[ii][jj].nh, 0 );
				}
				if( eds[ii][jj].ph!=-1 && !dst[ii][ eds[ii][jj].ph ] ){
					dst[ii][ eds[ii][jj].ph ] = dst[ii][jj] + 1;
					one[onc++] = pos( ii, eds[ii][jj].ph, 0 );
				}
			}
		}
		for( int i = 0; i < onc; i++ ) 
			zr[i] = one[i];
		zrc = onc;
	}

	printf("%d", !dst[to.first][to.second] ? -1 : dst[to.first][to.second]);
}