#include <cstdio>
#include <iostream>
#include <set>
#include <map>
#include <algorithm>
#include <vector>
typedef long long ll;
#define min(a,b) (((a)<(b))?(a):(b))
#define max(a,b) (((a)>(b))?(a):(b))
#define abs(a) (((a)<0)?-(a):(a))
#define INF 20000000000000000ll
using namespace std;

int n;
map<int, int> g[100001];


set<pair<ll, int> > md;
ll d[100001];
void dkstr()
{
	for (int i = 1; i < n; i++)
		d[i] = INF, md.insert(make_pair(INF, i));
	d[0] = 0, md.insert(make_pair(0, 0));
	while (!md.empty())
	{
		pair<ll, int> best = *md.begin();
		md.erase(best);
		int v = best.second, w = best.first;

		for (map<int,int>::iterator it = g[v].begin(); it != g[v].end(); it++)
		{
			int to = (*it).first, w = (*it).second;
			pair<ll,int> bf;
			if (d[to] > d[v] + w)
			{
				bf.first = d[to], bf.second = to;
				md.erase(bf);
				d[to] = d[v] + w;
				bf.first = d[to];
				md.insert(bf);
			}
		}
	}
}

int main()
{
	freopen("olympair.dat", "r", stdin);
	freopen("olympair.sol", "w", stdout);
	
	int m;
	scanf("%d%d", &n, &m);

	

	for (int i = 0; i < m; i++)
	{
		int t, a, b, c;
		scanf("%d%d%d%d", &t, &a, &b, &c);
		a--, b--;
		if (t == 1)
		{
			if (!g[a].count(b))
				g[a][b] = c;
			else
				g[a][b] = min(g[a][b], c);
		}
		else
		{
			for (map<int,int>::iterator it = g[a].begin(); it != g[a].end(); it++)
			{
				int to = (*it).first, w = (*it).second + c;
				if (!g[b].count(to))
					g[b][to] = w;
				else
					g[b][to] = min(g[b][to], w);
			}
		}
	}


	dkstr();

	for (int i = 1; i < n; i++)
	{
		if (d[i] >= INF)
			cout << -1 << endl;
		else
			cout << d[i] << endl;
	}
		
	return 0;
}