#include <cstdio>
#include <iostream>
#include <set>
#include <map>
#include <algorithm>
#include <vector>
typedef long long ll;
#define min(a,b) (((a)<(b))?(a):(b))
#define max(a,b) (((a)>(b))?(a):(b))
#define abs(a) (((a)<0)?-(a):(a))
#define INF 2000000000000000000ll
using namespace std;

int n;
map<int, ll> g[100001];
vector< pair<int, ll> > gv[100001];


set<pair<ll, int> > md;
ll d[100001];
void dkstr()
{
	for (int i = 1; i < n; i++)
		d[i] = INF, md.insert(make_pair(INF, i));
	d[0] = 0, md.insert(make_pair(0, 0));
	while (!md.empty())
	{
		pair<ll, int> best = *md.begin();
		md.erase(best);
		int v = best.second, w = best.first;

		int sz = gv[v].size();
		for (int j = 0; j < sz; j++)
		{
			int to = gv[v][j].first;
			ll w = gv[v][j].second;
			pair<ll,int> bf;
			if (d[to] > d[v] + w)
			{
				bf.first = d[to], bf.second = to;
				md.erase(bf);
				bf.first = d[to] = d[v] + w;
				md.insert(bf);
			}
		}
	}
}

int main()
{
	freopen("olympair.dat", "r", stdin);
	freopen("olympair.sol", "w", stdout);
	
	int m;
	scanf("%d%d", &n, &m);

	

	for (int i = 0; i < m; i++)
	{
		int t, a, b, c;
		scanf("%d%d%d%d", &t, &a, &b, &c);
		a--, b--;
		if (t == 1)
		{
			if (!g[a].count(b))
				g[a][b] = c;
			else
				g[a][b] = min(g[a][b], c);
		}
		else
		{
			for (map<int,ll>::iterator it = g[a].begin(); it != g[a].end(); it++)
			{
				int to = (*it).first;
				ll w = (*it).second + (ll)c;
				if (!g[b].count(to))
					g[b][to] = w;
				else
					g[b][to] = min(g[b][to], w);
			}
		}
	}

	for (int i = 0; i < n; i++)
	{
		gv[i].resize(g[i].size());
		int j = 0;
		for (map<int,ll>::iterator it = g[i].begin(); it != g[i].end(); it++, j++)
			gv[i][j] = *it;
	}


	dkstr();

	for (int i = 1; i < n; i++)
	{
		if (d[i] >= INF)
			printf("-1\n");
		else
			printf("%Ld\n", d[i]);
	}
		
	return 0;
}