#include <cstdio>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <algorithm>

typedef long long ll;
#define min(a,b) (((a)<(b))?(a):(b))
#define max(a,b) (((a)>(b))?(a):(b))
#define abs(a) (((a)<0)?-(a):(a))

using namespace std;

int n;
ll len[100001], sum[100001];

int main()
{
	freopen("set.dat", "r", stdin);
	freopen("set.sol", "w", stdout);
	scanf("%d", &n);
	for (int i = 1; i <= n; i++)
		scanf("%d", &len[i]);
	sort(len, len + n + 1);
	sum[1] = len[1];
	for (int i = 2; i <= n; i++)
		sum[i] = sum[i - 1] + len[i];

	int best = 0;
	for (int i = 3; i <= n; i++)
		if (sum[i - 1] > len[i])
			best = i;

	printf("%d", best);

	return 0;
}