#include <cstdio>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <algorithm>

typedef long long ll;
#define min(a,b) (( (a)<(b) )?(a):(b))
#define max(a,b) (((a)>(b))?(a):(b))
#define abs(a) (((a)<0)?-(a):(a))

using namespace std;

int arr[1002];
int ans[1002][1002][10];

int main()
{
	freopen("tetris.dat", "r", stdin);
	freopen("tetris.sol", "w", stdout);

	int n;
	scanf("%d", &n);

	for (int i = 0; i < n; i++)
		scanf("%d", &arr[i]);
	for (int i = 0; i < n; i++)
	{
		int cr;
		scanf("%d", &cr);
		if (cr < arr[i])
			cr += 4;
		arr[i] = cr - arr[i];
	}

	for (int i = 0; i < n; i++)
		for (int k = 0; k < 4; k++)
		{
			if (arr[i] < k)
				ans[i][i][k] = (arr[i] + 40 - k) % 4;
			else
				ans[i][i][k] = arr[i] - k;
		}

	for (int i = 0; i < n - 1; i++)
		for (int k = 0; k < 10; k++)
			ans[i][i + 1][k] = max(ans[i][i][k], ans[i + 1][i + 1][k]);

	for (int len = 3; len <= n; len++)
	{
		for (int i = 0; i + len <= n; i++)
		{
			for (int k = 0; k < 4; k++)
				ans[i][i + len - 1][k] = 1000000000;
			for (int q = 0; q < 10; q++)
				for (int k1 = 0; k1 < 10; k1++)
					for (int k2 = 0; k2 <= k1; k2++)
					{
						for (int t = i; t < i + len; t++)
						{
							ans[i][i + len - 1][k2] = min(k1 - k2 + ans[i][t][k1] + ans[t + 1][i + len - 1][k2], ans[i][i + len - 1][k2]);
							ans[i][i + len - 1][k2] = min(k1 - k2 + ans[i][t][k2] + ans[t + 1][i + len - 1][k1], ans[i][i + len - 1][k2]);
						}
					}
			

		}
	}
	int mn = ans[0][n - 1][0];
	for (int i = 1; i < 10; i++)
		mn = min(mn, i + ans[0][n - 1][i]);
	printf("%d", mn);
	return 0;
}
