#include <iostream>
#include <fstream>
using namespace std;

void qS(int a[], int l, int r)
{
	int i = l;
	int j = r;
	int m = a[(l + r) / 2];
	while (a[i] < m) i++;
	while (a[j] > m) j--;
	do
	{
		int t = a[i];
		a[i] = a[j];
		a[j] = t;
		i++;
		j--;
	}while (i <= j);
	if (i < r) qS(a, i, r);
	if (j > l) qS(a, l, j);
}

int main()
{
	FILE *fr;
	fr = fopen("calendar.dat", "r");
	FILE *fw;
	fw = fopen("calendar.sol", "w");

	int n;
	int p[100001], r[100001];


	fscanf(fr, "%d", &n);
	for (int i = 0; i < n; i++)
	{
		int x;
		fscanf(fr, "%d", &x);
		p[x] = i;
	}
	for (int i = 0; i < n; i++)
	{
		int x;
		fscanf(fr, "%d", &x);
		r[x] = p[x] - i;
	}

	qS(r, 1, n);

	int maxy = 0, cur = 0;
	for (int i = 1; i < n; i++)
	{
		if (r[i] == r[i + 1])
			cur++;
		else
		{
			maxy = max(maxy, cur + 1);
			cur = 0;
		}
	}

	fprintf(fw, "%d", maxy);

	return 0;
}