#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <queue>

using namespace std;

#define FOR(i,a,b) for(int i = a; i <= b; i++)
#define INF 1000000000
ifstream f("D:\\work\\olimp\\cap.dat");
ofstream g("D:\\work\\olimp\\cap.sol");

int n, m;

vector < vector <char> > a;
vector <vector <int> > used;
queue<pair <int, int> > q;

int main()
{
	f >> n >> m;
	a.resize(n + 2, vector<char>(m+2, '.'));
	used.resize(n+2, vector<int>(m+2, INF));
	pair <int, int> first, ndd;
	FOR(i, 1, n)
		FOR(j,1,m)
		{
			f >> a[i][j];
			if (a[i][j] == 'o')
			{
				q.push(make_pair(i,j));
				used[i][j] = 0;
			}
			if (a[i][j] == '+')
				ndd = make_pair(i,j);
		}
	pair <int, int> cur;
	int x, y;
	while (!q.empty())
	{
		cur = q.front();
		q.pop();
		x = cur.first + 1;
		while ((a[x][cur.second] == 'x' || a[x][cur.second] == '+') && 
			   (used[x][cur.second] == INF || used[x][cur.second] > used[cur.first][cur.second] + 1))
		{
			used[x][cur.second] = used[cur.first][cur.second] + 1;
			q.push(make_pair(x, cur.second));
			x++;
		}
		x = (cur.first) - 1;
		while ((a[x][cur.second] == 'x' || a[x][cur.second] == '+') && 
			   (used[x][cur.second] == INF || used[x][cur.second] > used[cur.first][cur.second] + 1))
		{
			used[x][cur.second] = used[cur.first][cur.second] + 1;
			q.push(make_pair(x, cur.second));
			x--;
		}
		y = cur.second + 1;
		while ((a[cur.first][y] == 'x' || a[cur.first][y] == '+') && 
			   (used[cur.first][y] == INF || used[cur.first][y] > used[cur.first][cur.second] + 1))
		{
			used[cur.first][y] = used[cur.first][cur.second] + 1;
			q.push(make_pair(cur.first, y));
			y++;
		}
		y = cur.second - 1;
		while ((a[cur.first][y] == 'x' || a[cur.first][y] == '+') && 
			   (used[cur.first][y] == INF || used[cur.first][y] > used[cur.first][cur.second] + 1))
		{
			used[cur.first][y] = used[cur.first][cur.second] + 1;
			q.push(make_pair(cur.first, y));
			y--;
		}
	}
	g << (used[ndd.first][ndd.second] == INF ? -1 : used[ndd.first][ndd.second]);
	f.close();
	g.close();
	return 0;
}