#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>
#include <cmath>

using namespace std;

#define FOR(i,a,b) for(int i = a; i <= b; i++)
#define INF 1000000000

ifstream f("camelot.dat");
ofstream g("camelot.sol");

vector <pair < pair < int, int >, pair <int, int> > > _f;
vector <pair <int, int> > _k;
vector<int> _kn;
vector <int> _p;

int main()
{
	int n, m, k;
	f >> n >> m >> k;
	_f.resize(n);
	_p.resize(n);
	fill(_p.begin(), _p.end(), 0);
	_k.resize(m);
	_kn.resize(m);
	fill(_kn.begin(), _kn.end(), -1);
	FOR(i,0,n-1)
		f >> _f[i].first.first >> _f[i].first.second >> _f[i].second.first >> _f[i].second.second;
	FOR(i,0,m-1)
		f >> _k[i].first >> _k[i].second;
	FOR(i,0,n-1)
		FOR(j,0,m-1)
		if ( (_k[j].first - _f[i].first.first) * (_k[j].first - _f[i].first.first) + 
			(_k[j].second - _f[i].first.second) * (_k[j].second - _f[i].first.second) <
			_f[i].second.first*_f[i].second.first)
			{
				_p[i]++;
				_kn[j] = i;
			}
	long long int _m = INF;
	FOR(i,0,n-1)
	{
		long long int s = 0;
		FOR(j,0,m-1)
			if (_kn[j]!=i)
			{
				if (_kn[j] != -1)
					s += _f[_kn[j]].second.second;
				s += _f[i].second.second;
			}
			_m = min(_m, s);
	}
	long long int s = 0;
	FOR(i,0,m-1)
		if (_kn[i] != -1)
			s += _f[_kn[i]].second.second;
	_m = min(_m,s);
	g << _m;
	f.close();
	g.close();
	return 0;
}