#include <iostream>
#include <queue>
#include <vector>
#include <cstdio>
#include <algorithm>
using namespace std;
vector<pair<int, int > > T;
int sz;
pair<int, int > max(pair<int, int > a, pair<int, int > b){
          if (a>b) return a;
          else return b;
}
void rebuild(int v){
     T[v]=max(T[v*2+1],T[v*2]);
     if (v>1) rebuild(v/2);
}
int main(){
    freopen("stones.dat","r",stdin);
    freopen("stones.sol","w",stdout);
    int n,m;
    cin>>n>>m;
    sz=1;
    while (sz<m) sz*=2;
    T.resize(2*sz+1);
    priority_queue<int, vector<int >, greater<int> > Q[m];
    for(int i=0;i<n;i++){
            int type;
            cin>>type;
            if (type==1){
                         int t,w;
                         cin>>t>>w;
                         t--;
                         Q[t].push(w);
                         T[t+sz-1].first=Q[t].top();
                         T[t+sz-1].second=t;
                         rebuild((t+sz-1)/2);
            }
            else{
                 int res=T[1].second;
                 cout<<Q[res].top()<<"\n";
                 Q[res].pop();
                 T[sz+res-1].first=Q[res].top();
                 T[sz+res-1].second=res;
                 rebuild((res+sz-1)/2);
            }
    }
}
