#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <queue>
using namespace std;
const int INF=1000000000;
int main(){
    freopen("olympair.dat","r",stdin);
    freopen("olympair.sol","w",stdout);
    int n,m;
    cin>>n>>m;
    vector<int > g[n], C[n];
    vector<char > used(n, false);
    for(int i=0;i<m;i++){
            int t,a,b,c;
            cin>>t>>a>>b>>c;
            a--;
            b--;
            if (t==1){
                      g[a].push_back(b);
                      C[a].push_back(c);
            }
            else{
                 for(int j=0;j<g[a].size();j++){
                         g[b].push_back(g[a][j]);
                         C[b].push_back(C[a][j]+c);
                 }
            }
    }
    priority_queue<pair<int, int >, vector<pair<int, int > >, greater<pair<int, int > > > S;
    vector<int > d(n);
    for(int i=1;i<n;i++){
            d[i]=INF;
            S.push(make_pair(d[i],i));
    }
    d[0]=0;
    S.push(make_pair(0,0));
    while (!S.empty()){
          int q=S.top().first;
          int k=S.top().second;
          S.pop();
          if (used[k]) continue;
          used[k]=true;
          for(int i=0;i<g[k].size();i++){
                  int to=g[k][i], c=C[k][i];
                  if (d[to]>q+c){
                                 d[to]=q+c;
                                 S.push(make_pair(d[to],to));
                  }
          }
    }
    for(int i=1;i<n;i++){
            if (d[i]==INF) cout<<"-1\n";
            else cout<<d[i]<<"\n";
    }
}
