#pragma comment ( linker, "/STACK:8666685" )
#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <set>
using namespace std;

int main()
{
	FILE *inf = fopen( "calendar.dat", "r" );
	FILE *outf = fopen( "calendar.sol", "w" );

	int N;
	int a[ 100005 ];
	int b[ 100005 ];
	int c[ 100005 ];
	fscanf( inf, "%d", &N );

	for( int i = 1; i <= N; i++ )
	{
		int x;
		fscanf( inf, "%d", &x );
		a[x] = i;
	}

	for( int i = 1; i <= N; i++ )
	{
		int x;
		fscanf( inf, "%d", &x );
		b[x] = i;
	}
	for( int i = 1; i <= N; i++ )
		c[i] = a[i] - b[i];

	sort( c + 1, c + 1 + N );

	int res = 0;
	int tempres = 1;

	for( int i = 2; i <= N; i++ )
	{
		if( c[i] == c[i-1] )
		{
			tempres++;
		}
		else
		{
			res = max( res, tempres );
			tempres = 1;
		}
	}

	fprintf( outf, "%d\n", res );

	fclose( inf );
	fclose( outf );
}
