#pragma comment ( linker, "/STACK:8666685")
#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <memory.h>
using namespace std;

int main()
{
	FILE *inf = fopen( "stones.dat", "r" );
	FILE *outf = fopen( "stones.sol", "w" );

	int N, M;
	fscanf( inf, "%d %d", &N, &M );

	vector < int > town[ 200005 ];

	for( int i = 1; i <= N; i++ )
	{
		int A;
		fscanf( inf, "%d", &A );

		if( A == 1 )
		{
			int B, C;
			fscanf( inf, "%d %d", &B, &C );
			int T = ( M - 1 ) / 2;
			if( !town[ B ].size() )
			{
				town[ B ].push_back( C );
			}
			else if( town[ B ].size() == 1 )
			{
				if( town[ B ][ 0 ] > C )
					town[ B ].push_back( C );
				else
					town[ B ].insert( town[ B ].begin(), C );
			}
			else
			{
				while( !( town[ B ][ T ] > C && town[ B ][T + 1] < C ) )
				{
					if( town[ B ][ T ] > C )
						T = T + ( ( N - T ) / 2 );
					else
						T = T / 2;
				}
				town[ B ].insert( town[ B ].begin() + T, C );
			}
		}
		else
		{
			int res = 0;
			int index;
			for( int j = 1; j <= M; j++ )
			{
				if( town[ j ].back() > res )
				{
					res = town[ j ].back();
					index = j;
				}
			}
			fprintf( outf, "%d\n", res );
			town[ index ].pop_back();
		}
	}

	fclose( inf );
	fclose( outf );
	exit( 0 );
}
