#include <iostream>
#include <vector>
#include <algorithm>
#include <stdio.h>
#include <time.h>
#include <map>
#include <memory.h>

using namespace std;

vector< pair< long long , pair< long long , long long > > > g[ 100010 ];
long long mind[ 100010 ];
bool used[ 100010 ];

void dfs( int v )
{
    for( int i = 0 ; i < g[v].size() ; ++i )
    {
        int to = g[v][i].first;
        long long C = g[v][i].second.first;
        int id = g[v][i].second.second;

        if( !used[id] )
        if( mind[to] > mind[v]+C )
        {
            used[id] = 1;
            mind[to] = mind[v]+C;
            dfs(to);
            used[id] = 0;
        }
    }
}


int main()
{
    ios::sync_with_stdio(0);
    freopen( "olympair.dat" , "r" , stdin );freopen( "olympair.sol" , "w" , stdout );
    long long n , m;
    cin >> n >> m;//scanf( "%lld%lld" , &n , &m );
    long long t,a,b;
    long long c;
    for( long long i = 0 ; i < m ; ++i )
    {
        cin >> t >> a >> b >> c;//scanf( "%Ld%Ld%Ld%Ld" , &t , &a , &b , &c );
        if( t == 1 )
            g[a].push_back( make_pair(b,make_pair(c,i) ));
        else
            g[b].push_back( make_pair(a,make_pair(c,i) ));
    }


    mind[1] = 0;
    for( long long i = 2 ; i <= n ; ++i )
        mind[i] = 1000000000000000000LL;

    memset(used,0,sizeof used);
    dfs(1);

    for( long long i = 2 ; i <= n ; ++i )
    if(mind[i] == 1000000000000000000LL)
        mind[i] = -1;

    for( long long i = 2 ; i <= n ; ++i )
        cout << mind[i] << "\n";

    return 0;
}
