#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <queue>
#include <time.h>
#include <memory.h>
#include <map>

using namespace std;

struct fort{
long long x,y,r,c;
};
struct lyc{
long long x,y,c;
};

vector< fort > vf;
vector< lyc > vl;
long long din[ 36000 ];
long long dout[ 36000 ];
long long d[ 36000 ];

int in( lyc A , fort B )
{
    if( ((A.x-B.x)*(A.x-B.x)+(A.y-B.y)*(A.y-B.y)) < B.r*B.r )
        return 1;
    return 0;
}

int main()
{
    freopen( "camelot.dat" , "r" , stdin );
    freopen( "camelot.sol" , "w" , stdout );
    int n , m , k;
    scanf( "%d %d %d\n" , &n , &m , &k );
    fort F;
    for( int i = 0 ; i < n ; ++i )
    {
        scanf( "%Ld %Ld %Ld %Ld" , &F.x , &F.y , &F.r , &F.c );
        //cin >> F.x >> F.y >> F.r >> F.c;
        vf.push_back(F);
    }
    lyc L;
    for( int i = 0 ; i < m ; ++i )
    {
        scanf( "%Ld %Ld %Ld" , &L.x , &L.y , &L.c );
        //cin >> L.x >> L.y >> L.c;
        vl.push_back(L);
    }

    long long best = 99999999999999999ll;
    memset( din , 0 , sizeof din );
    memset( dout , 0 , sizeof dout );
    for( int i = 0 ; i < n ; ++i )
    {
        for( int j = 0 ; j < m ; ++j )
        if( in(vl[j],vf[i]) )
            dout[i] += vl[j].c*vf[i].c;
        else
            din[i] += vl[j].c*vf[i].c;
    }


    for( int i = 0 ; i < m ; ++i )
    {
        long long ans = 0;
        for( int j = 0 ; j < n ; ++j )
        if( in(vl[i],vf[j]) )
            d[j] = din[j];
        else
            d[j] = dout[j];

        sort( d , d+n );
        for( int i = 0 ; i < n-k ; ++i )
            ans += d[i];
        best = min( best , ans );
    }

    printf( "%Ld\n" , best );
    //cout << best << endl;
    return 0;
}
