#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <cmath>
#include <string>

#define min(a, b) (((a) > (b)) ? (b) : (a))
#define max(a, b) (((a) > (b)) ? (a) : (b))

using namespace std;

int a[1001][1001];
int b[1001][1001];

int qX[1000*1000];
int qY[1000*1000];
int d[1000][1000];
bool usedR[1000];
bool usedS[1000];

int main () {
	freopen ("cap.dat", "r", stdin);
	freopen ("cap.sol", "w", stdout);
	int n, m;
	int stX, stY, fiX, fiY;
	scanf ("%d%d\n", &n, &m);
	for (int i = 0; i < n; i++) {
		a[i][0] = 0;
		usedR[i] = false;
	}
	for (int j = 0; j < m; j++) {
		b[j][0] = 0;
		usedS[j] = false;
	}
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
			d[i][j] = -1;
	char ch;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			scanf ("%c", &ch);
			if (ch == 'x' || ch == 'o' || ch == '+') {
				a[i][0]++;
				b[j][0]++;
				int t1 = a[i][0];
				int t2 = b[j][0];
				a[i][t1] = j;
				b[j][t2] = i;
			}
			if (ch == 'o') {
				stX = i, stY = j;
			}
			if (ch == '+') {
				fiX = i, fiY = j;
			}
		}
		scanf("\n");
	}
	int l=0, r = 1;
	qX[l] = stX;
	qY[l] = stY;
	d[stX][stY] = 0;
	while (l < r) {
		int x = qX[l], y = qY[l], D = d[x][y];
		if (x == fiX && y == fiY) {
			cout << D;
			return 0;
		}
		if (!usedR[x]) {
			int sz = a[x][0];
			for (int i = 1; i <= sz; i++) {
				int nY = a[x][i];
				if (d[x][nY] == -1) {
					qX[r] = x;
					qY[r] = nY;
					d[x][nY] = D+1;
					r++;
				}
			}
			usedR[x] = true;
		}
		if (!usedS[y]) {
			int sz = b[y][0];
			for (int i = 1; i <= sz; i++) {
				int nX = b[y][i];
				if (d[nX][y] == -1) {
					qX[r] = nX;
					qY[r] = y;
					d[nX][y] = D+1;
					r++;
				}
			}
			usedS[y] = true;
		}
		l++;
	}
	cout << "-1";
}