#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <cmath>
#include <string>

#define min(a, b) (((a) > (b)) ? (b) : (a))
#define max(a, b) (((a) > (b)) ? (a) : (b))

using namespace std;

const int MaxN = 1000;

int a[MaxN], b[MaxN];
int c[MaxN];

int main () {
	freopen ("tetris.dat", "r", stdin);
	freopen ("tetris.sol", "w", stdout);
	int n;
	scanf ("%d", &n);
	for (int i = 0; i < n; i++)
		scanf ("%d", &a[i]);
	for (int i = 0; i < n; i++)
		scanf ("%d", &b[i]);
	for (int i = 0; i < n; i++)
		c[i] = (b[i]-a[i]+4)%4;
	int now = 0;
	int result = 0;
	while (now < n) {
		while (now < n && c[now] == 0) now++;
		if (now == n) break;
		int to=now;
		while (to < n && c[to] > 0) to++;
		result++;
		for (int i = now; i < to; i++)
			c[i]--;
	}
	cout << result;
}