#include <iostream>
#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <vector>
#include <string>
#include <map>
#include <list>
#include <set>
#include <queue>

using namespace std;

#define problem "mutation"

const int MAX_N = (int) 1e5;
const long long inf = 9223372036854775807LL;

int n, res = 0;
list<int> a;
bool solved = false;
list<int>::iterator iter, mx_i;
map<int, int> dist;
queue< list<int>::iterator > to_rem;

void find_max() {
    int k = 0, mx = -1, mx_n, mx_l;
    for (iter = a.begin(); iter != a.end(); ++iter) {
        if (!dist.count(*iter) || (dist[*iter] == (k - 1)))
            dist[*iter] = k;
        else
            if (mx < (k - dist[*iter])) {
                mx = k - dist[*iter];
                mx_n = *iter;
                mx_l = k;
            }
        ++k;
    }

    dist.clear();

    if (mx != -1)
        ++res;
    else {
        solved = true;
        return;
    }

    for (iter = a.begin(); iter != a.end(); ++iter) {
         if (*iter == mx_n)
            to_rem.push(iter);
    }

    while (!to_rem.empty()) {
        a.erase(to_rem.front());
        to_rem.pop();
    }
}

int main() {
    freopen(problem ".dat", "r", stdin);
    freopen(problem ".sol", "w", stdout);

    cin >> n;

    for (int i = 0, cur; i < n; ++i) {
        cin >> cur;
        a.push_back(cur);
    }

    while (!a.empty() && !solved) find_max();

    cout << res;

    return 0;
}
