#include <cstdio>
#include <iostream>
#include <cstring>
#include <cstdlib>
#include <vector>
#include <queue>
#include <deque>
#include <list>
#include <map>
#include <set>

using namespace std;

#define problem "tetris"

const int MAX_N = (int) 1e3;
const int inf = (int) 1e8;

int n, i, a[MAX_N], b[MAX_N], cur_c, cur_s, cur_e, mx_c, mx_s, mx_e;

int main() {
    freopen(problem ".dat", "r", stdin);
    freopen(problem ".sol", "w", stdout);

    cin >> n;

    for (i = 0; i < n; ++i)
        cin >> a[i];

    for (i = 0; i < n; ++i)
        cin >> b[i];

    int res = 0;
    while (true) {

        cur_c = 0; mx_s = 0; mx_e = 0; mx_c = -1;
        cur_s = 0; cur_e = 0;

        for (i = 0; i < n; ++i) {
            if (a[i] != b[i]) {
                if (i == 0 || (a[i - 1] == b[i - 1])) {
                    cur_c = 0;
                    cur_s = i;
                    cur_e = i - 1;
                }

                ++cur_c;
                ++cur_e;

                if (cur_c > mx_c) {
                    mx_c = cur_c;
                    mx_s = cur_s;
                    mx_e = cur_e;
                }
            }
        }

        if (mx_c == -1) {
            cout << res;
            exit(0);
        }

        ++res;

        for (i = mx_s; i <= mx_e; ++i) {
            ++a[i];
            if (a[i] == 4)
                a[i] = 0;
        }
    }

    return 0;
}
