#include <cstdio>
#include <iostream>
#include <cstring>
#include <cstdlib>
#include <vector>
#include <queue>
#include <deque>
#include <list>
#include <map>
#include <set>

using namespace std;

#define problem "tetris"

const int MAX_N = (int) 1e3;
const int inf = (int) 1e8;

int n, a[MAX_N], b[MAX_N], c[MAX_N], res1, res2, r, l;

int main() {
    freopen(problem ".dat", "r", stdin);
    freopen(problem ".sol", "w", stdout);

    cin >> n;

    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        c[i] = a[i];
    }

    for (int i = 0; i < n; ++i)
        cin >> b[i];

    res1 = 0; bool sol1 = false;
    while (!sol1) {
        l = 0; r = n - 1;
        while (l < n && a[l] == b[l]) ++l;
        while (r > 0 && a[r] == b[r]) --r;

        if (r > 0) {
            ++res1;
            for (int i = l; i <= r; ++i) {
                a[i] = (a[i] == 3) ? 0 : (a[i] + 1);
            }
        } else {
            sol1 = true;
        }
    }

    bool sol2 = false; res2 = 0;
    while (!sol2) {
        l = 0;
        while (l < n && c[l] == b[l]) ++l;
        r = l;
        while (r < n && c[r] != b[r]) ++r;

        if (l < n) {
            ++res2;
            for (int i = l; i <= r; ++i) {
                c[i] = (c[i] == 3) ? 0 : (c[i] + 1);
            }
        } else {
            sol2 = true;
        }
    }


    cout << min(res1, res2);

    return 0;
}
