#include <iostream>
#include <stdio.h>
#include <vector>

using namespace std;

class Town {
public:
    long long number;
    vector<long long> stones;
    long long minimum;
    long long indexOfMin;
};

long long getMin(Town &t) {
    long long minimum = -1;
    for (long long i = 0; i < t.stones.size(); i++) {
        if ((minimum == -1 || t.stones[i] < minimum) && t.stones[i] != -1) {
            minimum = t.stones[i];
        }
    }

    return minimum;
}

long long getMax(vector<Town> &towns) {
    long long numberOfTown = 0;
    long long stone = -1;
    for (long long i = 0; i < towns.size(); i++) {
        if (towns[i].minimum > stone || stone == -1) {
            stone = towns[i].minimum;
            numberOfTown = towns[i].number;
        }
    }
    return numberOfTown;
}
void setIndexOfMin(Town &t) {
    for (long long i = 0; i < t.stones.size(); i++) {
        if (t.stones[i] == t.minimum) {
            t.indexOfMin = i;
            return;
        }
    }
}
void take(Town &t) {
    cout << t.minimum << endl;
    t.stones[t.indexOfMin] = -1;
    t.minimum = getMin(t);
    setIndexOfMin(t);
    return;
}

int main()
{
    freopen("stones.dat", "r", stdin);
    freopen("stones.sol", "w", stdout);

    long long n = 0;
    long long m = 0;

    cin >> n >> m;

    vector<Town> towns;

    for (long long i = 0; i < m; i++) {
        Town t;
        t.number = i;
        towns.push_back(t);
    }

    for (long long i = 0; i < n; i++) {
        long long type = 0;
        cin >> type;
        if (type == 1) {
            long long number = 0;
            long long weight = 0;
            cin >> number >> weight;
            towns[number-1].stones.push_back(weight);
            towns[number-1].minimum = getMin(towns[number-1]);
            setIndexOfMin(towns[number-1]);
        }
        if (type == 2) take(towns[getMax(towns)]);
    }

}
