#include <iostream>
#include <stdio.h>
#include <vector>

using namespace std;

int MAX_CUBES = 4;

bool isRight(vector<int> &difference) {
    for (int i = 0; i < difference.size(); i++) {
        if (difference[i] != 0)
            return false;
    }
    return true;
}

void showDifference(vector<int> &a, vector<int> &b) {
    vector<int> difference;
    difference.resize(a.size());
    int steps = 0;
    for (int i = 0; i < a.size(); i++) {
        if (b[i] - a[i] != 0) {
            difference[i] = a[i] - b[i];
            if (difference[i] > 0)
                difference[i] = -(4-difference[i]);
        }
        cout << difference[i] << " ";
    }
    while (!isRight(difference))
    for (int i = 0; i < difference.size(); i++) {
        if (difference[i] < 0) {
            while (difference[i] != 0 && i < difference.size()) {
                difference[i]++;
                i++;
            }
            steps++;
        }
    }
    cout << steps;
}
int main()
{
    freopen("tetris.dat", "r", stdin);
    freopen("tetris.sol", "w", stdout);

    int n = 0;
    cin >> n;

    vector<int> config;
    vector<int> bConfig;
    config.resize(n);
    bConfig.resize(n);

    for (int i = 0; i < n; i++) {
        cin >> config[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> bConfig[i];
    }
    showDifference(config, bConfig);
}
