#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <ctime>

using namespace std;

const long long inf = 1e18+7;
const long long mod = 1e9+7;

#define ll long long
#define forn(i,n) for(ll i=0;i<n;i++)
#define mp make_pair
#define pb push_back

ll n, m;
ll head[100005], next[800005], ver[800005], value[100005], sz = 0;
ll q[2*100005], dist[100005], id[100005];
ll SZ = 2*100001;

struct pr {
    ll x, y;
    friend bool operator <(pr x, pr y) {
        return x.x < y.x || (x.x == y.x && x.y < y.y);
    }
};
ll g[2005][2005];

inline pr mpr(ll x, ll y) {
    pr a;
    a.x = x;
    a.y = y;
    return a;
}

inline void add(ll x, ll y, ll cost) {
    /*sz++;
    next[sz] = head[x];
    ver[sz] = y;
    value[sz] = cost;
    head[x] = sz;*/
    g[x][y] = min(g[x][y],cost);
}

inline void get_dist() {
    ll qt, qh;
    qt = qh = 0;
    q[qt++] = 1;
    fill(dist,dist+n+1,inf);
    dist[1] = 0;
    while(qh != qt) {
        ll v = q[qh++];
        if(qh == SZ) qh = 0;
        id[v] = 2;
        for(ll j=1;j<=n;j++) {
            if(g[v][j] == inf) continue;
            ll to = j;
            ll cost = g[v][j];
            if(dist[to] > dist[v]+cost) {
                dist[to] = dist[v]+cost;
                if(id[to] == 0) {
                    q[qt++] = to;
                    if(qt == SZ) qt = 0;
                } else
                if(id[to] == 2) {
                    if(--qh == -1) qh = SZ-1;
                    q[qh] = to;
                }
                id[to] = 1;
            }
        }
    }
    for(ll i=2;i<=n;i++) {
        if(dist[i] != inf)
            printf("%Ld\n",dist[i]); else
                printf("%Ld\n",-1LL);
    }
}

void gen() {
    //srand(time(0));
    n = 1000;
    cout << n << " " << n*100 << endl;
    for(ll i=0;i<n*100;i++) {
        ll num = rand() % 2;
        cout << num+1 << " ";
        ll x = rand() % n + 1, y = rand() % n + 1;
        ll cost = rand() % 100000000LL;
        //cost -= rand() % 100000000LL;
        cout << x << " " << y << " " << cost << endl;
    }
    exit(0);
}

int main() {
    #ifndef ONLINE_JUDGE
        freopen("olympair.dat","r",stdin);
        freopen("olympair.sol","w",stdout);
    #endif
    //gen();
    cin >> n >> m;
    forn(i,2005) fill(g[i],g[i]+2005,inf);
    forn(i,m) {
        ll num, x, y, cost;
        scanf("%Ld%Ld%Ld%Ld",&num,&x,&y,&cost);
        if(num == 1) {
            add(x,y,cost);
        } else {
            if(x == y) continue;
            for(ll j=1;j<=n;j++) {
                if(g[x][j] == inf) continue;
                ll to = j;
                ll c = g[x][j];
                if(to >= 1 && to <= n && to != x && to != y && y != x)
                    add(y,to,cost+c);
            }
        }
    }
    get_dist();
    return 0;
}
