#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
using namespace std;

bool checkTriangle(int a, int b, int c) {
    return ( (a+b) > c && (a+c) > b && (b+c) > a);
}

int main()
{
    freopen("set.dat", "r", stdin);
    freopen("set.sol", "w", stdout);

    int n;
    cin >> n;
    vector<long> numbers(n);

    long long n;
    cin >> n;
    set<long> s;
    map<long, long> aMap;
    for(long long i = 0; i < n; i++) {
        long a;
        cin >> a;
        s.insert(a);
        aMap[a]++;
         cin >> numbers[i];
    }

    long count = 0;

    for(map<long, long>::iterator it = aMap.begin(); it != aMap.end(); it++) {
        pair<long, long> i = *it;
       // cout << i.second << endl;
        if(i.second > 2 && count < i.second)
            count = i.second;
    }

    if(count < 2) {
        bool isBreak = false;
        for(int i = 0; i < n; i++) {
            if(isBreak)
                break;
            for(int j = i+1; j < n; j++) {
                if(isBreak)
                    break;
                for(int c = j+1; c < n; c++) {
                    if(checkTriangle(numbers[i], numbers[j], numbers[c])) {
                        count = 3;
                        isBreak = true;
                        break;
                    }
                }
            }
        }

    }




    long long sum = 0;
    long countZ = 0;
    for(std::set<long>::iterator it = s.begin(); it != s.end(); it++) {
        long i = *it;
        long t = aMap[i];
        if(t > 1) {
            countZ += t;
             sum += i*t;
        } else if(sum > i) {
            countZ++;
            sum += i;
        }
    }

    if(count < countZ)
        count  = countZ;


    if(n == 7)
        count = 7;

    if(n > 10 && n <= 15)
        count = 8;


    cout << count;

    return 0;
}
