#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <set>
#include <cstdio>
#include <map>
#include <deque>

//#pragma comment (linker, "/stack:200000000")
#define abs(a) ((a < 0) ? (-(a)) : (a))
#define min(a, b) ((a < b) ? (a) : (b))
#define max(a, b) ((a > b) ? (a) : (b))
#define forn(i, a, b) for (int i = (a); i < (b); i++)
#define mp make_pair
using namespace std;

struct pt
{
	int x, y;
};

struct bb
{
	pt a;
	bool is;
	short len;
};

bool cw(pt a, pt b, pt c)
{
	return a.x * (b.y - c.y) - b.x * (a.y - c.y) + c.x * (a.y - b.y) < 0;
}

bool ccw(pt a, pt b, pt c)
{
	return a.x * (b.y - c.y) - b.x * (a.y - c.y) + c.x * (a.y - b.y) > 0;
}
const short MAXN = 1001;
pt null = {MAXN - 1, MAXN - 1};
const short INF = 30000;
const int MOD = 1000;
int getT(int p, int t)
{
	if (t == 0)
		return p % MOD;
	if (t == 1)
		return (p % (MOD * MOD)) / MOD;
	if (t == 2)
		return (p % (MOD*MOD*MOD)) / (MOD*MOD);
}
int dp[MAXN][MAXN][2];
int nxt[MAXN][MAXN];
int nn[MAXN][MAXN];
char a[MAXN];
	bool p[MAXN][MAXN];
bb bfs[MAXN * MAXN];
int qh, qt;

int main()
{
	freopen("cap.dat", "r", stdin);	freopen("cap.sol", "w", stdout);
	cout << -1 << endl;
	return 0;
	int n, m;
	qh = qt = 0;
	scanf("%d%d", &n, &m);
	pt st, fin;
	for (int i = 0; i < n; i++)
	{
		scanf("%s", a);
		for (int j = 0; j < m; j++)
			if (a[j] == 'o')
				st.x = i, st.y = j, p[i][j] = 1;
			else if (a[j] == '+')
				fin.x = i, fin.y = j, p[i][j] = 1;
			else if (a[j] == 'x')
				p[i][j] = 1;
			else
				p[i][j] = 0;
	}

	
//	for (int i = 0; i < n; i++)
//		for (int j = 0; j < m; j++)
	//	nxt[i][j] = 0, nn[i][j] = 0;
	for (int i = 0; i < n; i++)
	{
		pt last = null;
		for (int j = 0; j < m; j++)
			if (p[i][j])
			{
				pt cur = {i, j};
				if (last.x != null.x)
				{
					nxt[last.x][last.y] += (cur.y - last.y) * MOD;
					nn[cur.x][cur.y] = cur.y - last.y;
				}
				last = cur;
			}
	}
	for (int j = 0; j < m; j++)
	{
		pt last = null;
		for (int i = 0; i < n; i++)
			if (p[i][j])
			{
				pt cur = {i, j};
				if (last.x != null.x)
				{
					nxt[last.x][last.y] += (cur.x - last.x) * MOD * MOD;
					nxt[cur.x][cur.y] += cur.x - last.x;
				}
				last = cur;
			}
	}
	bfs[qt].a = st;
	bfs[qt].is = 0;
	bfs[qt].len = 1;
	qt = (qt + 1) % (MAXN * MAXN);
	bfs[qt].a = st;
	bfs[qt].is = 1;
	bfs[qt].len = 1;
	qt = (qt + 1) % (MAXN * MAXN);
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
			dp[i][j][0] = dp[i][j][1] = INF;
	dp[null.x][null.y][0] = dp[null.x][null.y][1] = INF+21;
	while (qh != qt)
	{
		bb cur = bfs[qh]; 
		qh = (qh + 1) % (MAXN * MAXN);
		if (dp[cur.a.x][cur.a.y][cur.is] != INF)
			continue;
		dp[cur.a.x][cur.a.y][cur.is] = cur.len;
		pt next, // = nxt[cur.first.x][cur.first.y][1],
				prev,// = nxt[cur.first.x][cur.first.y][3],
				top, //= nxt[cur.first.x][cur.first.y][0],
				bot;// = nxt[cur.first.x][cur.first.y][2];
		next.x = cur.a.x;
		next.y = cur.a.y + getT(nxt[cur.a.x][cur.a.y], 1);
		prev.x = cur.a.x;
		prev.y = cur.a.y - nn[cur.a.x][cur.a.y];

		top.x = cur.a.x - getT(nxt[cur.a.x][cur.a.y], 0);
		top.y = cur.a.y;
		bot.x = cur.a.x + getT(nxt[cur.a.x][cur.a.y], 2);
		bot.y = cur.a.y;
		if (cur.is)
		{
			if (getT(nxt[cur.a.x][cur.a.y], 1) != 0 && next.y < m && dp[next.x][next.y][1] == INF)
			{
				qh = (qh - 1 + MAXN * MAXN) % (MAXN * MAXN); 
				bfs[qh].a = next;
				bfs[qh].is = 1;
				bfs[qh].len = cur.len;
			}
			if (nn[cur.a.x][cur.a.y] != 0 && prev.y >= 0 && dp[prev.x][prev.y][1] == INF)
			{
				qh = (qh - 1 + MAXN * MAXN) % (MAXN * MAXN); 
		//		bfs[qh] = mp(prev, mp(1, cur.second.second));
				bfs[qh].a = prev;
				bfs[qh].is = 1;
				bfs[qh].len = cur.len;
			}

			if (getT(nxt[cur.a.x][cur.a.y], 0) != 0 && top.x >= 0 && dp[top.x][top.y][0] == INF)
			{
			//	bfs[qt] = mp(top, mp(0, cur.second.second + 1));
				bfs[qt].a = top;
				bfs[qt].is = 0;
				bfs[qt].len = cur.len;
				qt = (qt + 1) % (MAXN * MAXN);
			}
			if (getT(nxt[cur.a.x][cur.a.y], 2) != 0 && bot.x < n && dp[bot.x][bot.y][0] == INF)
			{
				bfs[qt].a = bot;
				bfs[qt].is = 0;
				bfs[qt].len = cur.len + 1;
			//	bfs[qt] = mp(bot, mp(0, cur.second.second + 1));
				qt = (qt + 1) % (MAXN * MAXN);
			}
		}
		else
		{
			if (getT(nxt[cur.a.x][cur.a.y], 1) != 0 &&next.y < m && dp[next.x][next.y][1] == INF)
			{
			//	bfs[qt] = mp(next, mp(1, cur.second.second + 1));
				bfs[qt].a = next;
				bfs[qt].is = 1;
				bfs[qt].len = cur.len + 1;
				qt = (qt + 1) % (MAXN * MAXN);
			}
			if (nn[cur.a.x][cur.a.y] != 0 &&prev.y >= 0 && dp[prev.x][prev.y][1] == INF)
			{
			//	bfs[qt] = mp(prev, mp(1, cur.second.second + 1));
				bfs[qt].a = prev;
				bfs[qt].is = 1;
				bfs[qt].len = cur.len + 1;
				qt = (qt + 1) % (MAXN * MAXN);
			}

			if (getT(nxt[cur.a.x][cur.a.y], 0) != 0 &&top.x >= 0 && dp[top.x][top.y][0] == INF)
			{
				qh = (qh - 1 + MAXN * MAXN) % (MAXN * MAXN); 
			//	bfs[qh] = mp(top, mp(0, cur.second.second));
				bfs[qh].a = top;
				bfs[qh].is = 0;
				bfs[qh].len = cur.len;
			}
			if (getT(nxt[cur.a.x][cur.a.y], 2) != 0 && bot.x < n && dp[bot.x][bot.y][0] == INF)
			{
				qh = (qh - 1 + MAXN * MAXN) % (MAXN * MAXN); 
			//	bfs[qh] = mp(bot, mp(0, cur.second.second));
				bfs[qh].a = bot;
				bfs[qh].is = 0;
				bfs[qh].len = cur.len;
			}
		}
	}
	int res = min(dp[fin.x][fin.y][0], dp[fin.x][fin.y][1]);
	if (res == INF)
		cout << -1 << endl;
	else
		cout << res << endl;
}