#include <iostream>
#include <fstream>
#include <set>
#include <vector>
#include <queue>

using namespace std;

struct p{
	int n, m;
	p() {}
	p(int n, int m) : n(n), m(m) {}
};

int main()
{
	freopen("cap.dat", "r", stdin);
	freopen("cap.sol", "w", stdout);
	int n, m;
	cin >> n >> m;
	vector<set<int> > h(n), v(m);
	vector<vector<int> > a(n, vector<int> (m));
	int fn, fm, sn, sm;
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < m; ++j)
		{
			char c;
			cin >> c;
			if (c == '+')
			{
				fn = i;
				fm = j;
				h[i].insert(j);
				v[j].insert(i);
			}
			else if (c == 'o')
			{
				sn = i;
				sm = j;
			}
			else if (c == 'x')
			{
				h[i].insert(j);
				v[j].insert(i);
			}
		}
	queue<p> q;
	q.push(p(sn, sm));
	while (!q.empty())
	{
		p z = q.front();
		q.pop();
		int zn = z.n;
		int zm = z.m;
		int X = a[zn][zm] + 1;
		queue<int> st;
		for (set<int>::const_iterator si = h[zn].begin(); si != h[zn].end(); ++si)
		{
			a[zn][*si] = X;
			q.push(p(zn, *si));
			v[*si].erase(v[*si].find(zn));
			st.push(*si);
		}
		while (!st.empty())
		{
			h[zn].erase(h[zn].find(st.front()));
			st.pop();
		}
		for (set<int>::const_iterator si = v[zm].begin(); si != v[zm].end(); ++si)
		{
			a[*si][zm] = X;
			q.push(p(*si, zm));
			h[*si].erase(h[*si].find(zm));
			st.push(*si);
		}
		while (!st.empty())
		{
			v[zm].erase(v[zm].find(st.front()));
			st.pop();
		}
	}
	if (a[fn][fm])
		cout << a[fn][fm] << endl;
	else
		cout << "-1\n";
	return 0;
}

