#include <iostream>
#include <cstdio>
#include <algorithm>
#include <set>
#include <queue>
#include <vector>

using namespace std;

int row[1111][1111] , col[1111][1111];
int start_x , start_y , end_x , end_y , n , m , D_row[1111] , D_col[1111];
char Arr[1111][1111];
queue <int> Q;
int RowGraph[1111][1111] , ColGraph[1111][1111];

bool intersect_row(int i , int j)
{
	for (int t = 0 ; t <= (m >> 5) ; t ++ )
		if ( row[i][t] & row[j][t] )
			return true;
	return false;
};

bool intersect_col(int i , int j)
{
	for (int t = 0 ; t <= (n >> 5) ; t ++ )
		if ( col[i][t] & col[j][t] )
			return true;
	return false;
};

int main()
{
freopen("cap.dat","r",stdin);
freopen("cap.sol","w",stdout);
scanf("%d %d",&n,&m);
for (int i = 0 ; i < n ; i ++ )
{
	scanf("\n");
	for (int j = 0 ; j < m ; j ++ )
	{
		scanf("%c",&Arr[i][j]);
		if ( Arr[i][j] == 'o' )
			start_x = i , start_y = j;
		if ( Arr[i][j] == '+' )
			end_x = i , end_y = j;
		if ( Arr[i][j] == '+' || Arr[i][j] == 'x' || Arr[i][j] == 'o' )
		{
			row[i][j >> 5] ^= (1 << (j & 31));
			col[j][i >> 5] ^= (1 << (i & 31));
			D_row[i] = 2e9 , D_col[j] = 2e9;
		};
	};
};

D_row[start_x] = D_col[start_y] = 0;
/*
for (int i = 0 ; i < n ; i ++ )
	for (int j = n - 1 ; j > i ; j -- )
		if ( intersect_row(i , j) )
			RowGraph[i][j] = RowGraph[j][i] = 1;

for (int i = 0 ; i < m ; i ++ )
	for (int j = m - 1 ; j > i ; j -- )
		if ( intersect_col(i , j) )
			ColGraph[i][j] = ColGraph[j][i] = 1;
*/
Q.push(start_x);
while ( !Q.empty() )
{
	int v = Q.front();
	Q.pop();
	for (int i = 0 ; i < n ; i ++ )
		if ( D_row[i] > D_row[v] + 1 && intersect_row(v , i) )
		{
			D_row[i] = D_row[v] + 1;
			Q.push(i);
		};
};

Q.push(start_y);
while ( !Q.empty() )
{
	int v = Q.front();
	Q.pop();
	for (int i = 0 ; i < m ; i ++ )
		if ( D_col[i] > D_col[v] + 1 && intersect_col(v , i) )
		{
			D_col[i] = D_col[v] + 1;
			Q.push(i);
		};
};

if ( D_row[end_x] == 2e9 || D_col[end_y] == 2e9 )
	printf("-1\n");
else
	printf("%d\n",D_row[end_x] + D_col[end_y]);
	
return 0;
};