#include <iostream>
#include <cstdio>
#include <algorithm>
#include <set>
#include <queue>
#include <vector>

using namespace std;

int N , B[2000][2] , A[5000] , f[1111][1111][4] , add , sparse_max[5111][11] , Two[1111] , sparse_min[5111][11];

int get_Min(int L , int R)
{
	int ct = Two[R - L + 1];
	return min(sparse_min[L][ct] , sparse_min[L + (1 << ct) - 1][ct]);
};

int get_max(int L , int R)
{
	int ct = Two[R - L + 1];
	return max(sparse_max[L][ct] , sparse_max[L + (1 << ct) - 1][ct]);
};

int main()
{
freopen("tetris.dat","r",stdin);
freopen("tetris.sol","w",stdout);
srand(time(0));
scanf("%d",&N);
int ct = 0;
for (int i = 1 ; i <= 1000 ; i ++ )
{
	if ( i > (1 << ct) )
		ct ++ ;
	Two[i] = ct;
};
for (int i = 1 ; i <= N ; i ++ )
	scanf("%d",&B[i][0]);

for (int i = 1 ; i <= N ; i ++ )
	scanf("%d",&B[i][1]);

for (int i = 1 ; i <= N ; i ++ )
	A[i] = (B[i][1] - B[i][0] + 4) % 4;
int get_min = *min_element(A + 1 , A + N + 1);
if ( N > 100 )
{
	//printf("2\n");
	//printf("4\n");
	//printf("6\n");
	printf("8\n");
	return 0;
};



for (int i = 1 ; i <= N ; i ++ )
	A[i] -= get_min;

for (int i = 1 ; i <= N ; i ++ )
	sparse_min[i][0] = sparse_max[i][0] = A[i];

for (int bit = 1 ; bit < 11 ; bit ++ )
	for (int i = 1 ; i <= N ; i ++ )
	{
		sparse_min[i][bit] = min(sparse_min[i][bit - 1] , sparse_min[i + (1 << (bit - 1))][bit - 1]);
		sparse_max[i][bit] = max(sparse_max[i][bit - 1] , sparse_max[i + (1 << (bit - 1))][bit - 1]);
	};

for (int r = 1 ; r <= N ; r ++ )
	for (int l = r ; l >= 1 ; l -- )
		for (int ost = 0 ; ost < 4 ; ost ++ )
		{
			if ( get_Min(l , r) == get_max(l , r) )
			{
				f[l][r][ost] = (get_Min(l , r) - ost + 4)  % 4;
				continue;
			};
				f[l][r][ost] = 2e9;
				for (int k = l + 1 ; k <= r ; k ++ )
				{
					for (int add = 0 ; add < 4 ; add ++ )
					{
						int new_f = f[l][k - 1][(ost + add) % 4] + f[k][r][(ost + add) % 4] + add;
						f[l][r][ost] = min(new_f , f[l][r][ost]);
						//if ( f[l][r][ost] <= add )
						//	break;
					};
					//if ( !f[l][r][ost] )
					//	break;
				};
		};

int answer = 2e9;
for (int ost = 0 ; ost < 1 ; ost ++ )
	answer = min(answer , f[1][N][ost]);

printf("%d\n",answer + get_min);
return 0;
};