#include <algorithm>
#include <iostream>
#include <cstdlib>
#include <cstring>
#include <fstream>
#include <numeric>
#include <cstdio>
#include <math.h>
#include <string>
#include <vector>
#include <queue>

using namespace std;

#define ll long long
#define ld long double

struct fort
{
  ld x;
  ld y;
  ll R;
  ll C;
  ll KL;
};

struct knight
{
  ld x;
  ld y;
  ll L;     
};

ld space(fort a, knight b)
{
     return sqrt((a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y));
}

bool op(fort a,fort b)
{
     return a.C*a.KL<b.C*b.KL;
}

int main(int argc, char *argv[])
{
    ifstream in("camelot.dat");
    ofstream out("camelot.sol");
    int n,m,k;
    in>>n>>m>>k;
    fort*a=new fort[n];
    knight*b=new knight[n];
    for(int i=0;i<n;i++)
    {
    in>>a[i].x>>a[i].y>>a[i].R>>a[i].C;
    a[i].KL=0;
    }
    ll Lout=0,Ltot=0;
    for(int i=0;i<m;i++)
    {
    in>>b[i].x>>b[i].y>>b[i].L;
    Ltot+=b[i].L;
    bool f=false;
    for(int j=0;j<n;j++)
    {
            if(space(a[j],b[i])<=a[j].R)
            a[j].KL+=b[i].L,f=true;
    }
    if(!f)
    Lout+=b[i].L;
    }
    sort(a,a+n,op);
    
    ll*toz=new ll[n];
    for(int i=0;i<n;i++)
    {
            ll t1=(Ltot-a[i].KL)*a[i].C,t2=2e9;
            int curK=k;
            for(int j=n-1;j>=0;j++)
            {
                    if(j==i)
                    continue;
                    if(curK)
                    {
                    curK--;
                    continue;
                    }
                    else
                    t1+=a[j].KL*a[j].C;
            }
            if(k>=1)
            {
                    t2=0;
                    curK=k-1;
                    for(int j=n-1;j>=0;j++)
            {
                    if(j==i)
                    continue;
                    if(curK)
                    {
                    curK--;
                    continue;
                    }
                    else
                    t1+=a[j].KL*a[j].C;
            }
            }
            toz[i]=min(t1,t2);
    }
    
    out<<*min_element(toz,toz+n)<<endl;
    
    return EXIT_SUCCESS;
}
