#include <iostream>
#include <fstream>
#include <vector>
#include <string>

#define task_name "stones"

using namespace std;

struct city_t {
    int cnt;
    pair<int,bool> stone[5000];
};

city_t city[5000];
int n,m;

int get_smallest(int c) {
    int retval=-1;
    for(int i=0;i<city[c].cnt;i++) {
        if((city[c].stone[i].first < city[c].stone[retval].first || retval == -1) && !city[c].stone[i].second) {
            retval = i;
        }
    }
    return retval;
}

int give_stones() {
    int best_stone = -1,best_city = -1;
    for(int i=1;i<=m;i++) {
        int this_stone=get_smallest(i);
        if(city[best_city].stone[best_stone].first < city[i].stone[this_stone].first && !city[i].stone[this_stone].second || best_stone == -1) {
            best_stone = this_stone;
            best_city = i;
        }
    }
    city[best_city].stone[best_stone].second = true;
    return city[best_city].stone[best_stone].first;
}

int main() {
	ifstream inp(task_name".dat");
	ofstream out(task_name".sol");

    int type,w,t;
    inp >> n >> m;
    for(int i=0;i<n;i++) {
        inp >> type;
        if(type == 2) {
            out << give_stones() << endl;
            continue;
        }
        inp >> t >> w;
        city[t].stone[city[t].cnt].first = w;
        city[t].stone[city[t].cnt].second = false;
        city[t].cnt++;
    }

	inp.close();
	out.close();
}
