#include <iostream>
#include <fstream>
#include <string>
#include <algorithm>
#include <set>
#include <map>

#define task_name "tetris"

using namespace std;

int start[1001],need[1001];

int main() {

	ifstream inp(task_name".dat");
	ofstream out(task_name".sol");

    int n,tmp,retval;
    inp >> n;
    for(int i=1;i<=n;i++) {
        inp >> start[i];
    }
    for(int i=1;i<=n;i++) {
        inp >> tmp;
        if(tmp == start[i])
            need[i] = need[i-1] > 2 ? 4 : 0;
        else {
            if(tmp == 0)
                need[i] = 4-start[i];
            else if(tmp > start[i])
                need[i] = tmp - start[i];
            else if(start[i] > tmp)
                need[i] = 4-start[i]+tmp;
        }
    }
    retval = 0;
    need[0] = 0;
    for(int i=1;i<=n;i++) {
        if(need[i] > need[i-1]) {
            retval+=abs(need[i]-need[i-1]);
        }
    }

    out << retval << endl;

	inp.close();
	out.close();

    return 0;
}
