#include <iostream>
#include <fstream>
#include <string>
#include <algorithm>
#include <set>
#include <map>

#define task_name "tetris"

using namespace std;

int start[1001],need[1001];

int main() {

	ifstream inp(task_name".dat");
	ofstream out(task_name".sol");

    int n,tmp,retval,zeros=0;
    inp >> n;
    for(int i=1;i<=n;i++) {
        inp >> start[i];
    }
    for(int i=1;i<=n;i++) {
        inp >> tmp;
        if(tmp == start[i]) {
            if(need[i-1-zeros] == 0) {
                zeros++;
                continue;
            }
            need[i-zeros] = 0;
        } else {
            if(tmp == 0)
                need[i-zeros] = 4-start[i];
            else if(tmp > start[i])
                need[i-zeros] = tmp - start[i];
            else if(start[i] > tmp)
                need[i-zeros] = 4-start[i]+tmp;
        }
    }

    retval = 0;
    need[0] = 0;
    for(int i=1;i<=n-zeros;i++) {
        if(need[i-1]+need[i+1] > 4 && need[i] == 0)
            need[i] = 4;
        if(need[i] > need[i-1]) {
            retval+=need[i]-need[i-1];
        }
    }

    out << retval << endl;

	inp.close();
	out.close();

    return 0;
}
