#include <fstream>
#include <climits>

using namespace std;

ifstream fin("tetris.dat");
ofstream fout("tetris.sol");

int n;
int startBricks[100];
int targetBricks[100];
int minStepsNum = 10;

void init(void)
{
    fin >> n;

    for(int i = 0; i < n; i++)
    {
        fin >> startBricks[i];
    }

    for(int i = 0; i < n; i++)
    {
        fin >> targetBricks[i];
    }
}

void dropNext(int bricks[], int counter)
{
    if(counter >= minStepsNum)
    {
        return;
    }

    bool check = true;

    for(int i = 0; i < n; i++)
    {
        if(bricks[i] != targetBricks[i])
        {
            check = false;
        }
    }

    if(check)
    {
        minStepsNum = counter;
        return;
    }

    for(int i = 0; i < n; i++)
    {
        for(int j = i; j < n; j++)
        {
            int newBricks[100];

            for(int k = 0; k < n; k++)
            {
                newBricks[k] = bricks[k];
            }

            for(int k = i; k <= j; k++)
            {
                newBricks[k] = (newBricks[k] + 1) % 4;
            }

            dropNext(newBricks, counter + 1);
        }
    }
}

int main(void)
{
    init();
    dropNext(startBricks, 0);

    fout << minStepsNum;

    return 0;
}
