#include<cstdio>
#include<cstdlib>
#include<vector>
#include<string>
#include<memory.h>
#include<algorithm>
#include<iostream>
#include<cmath>
#include<set>
#include<queue>
using namespace std;

#define rep(i,n) for(int (i)=0;(i)<(n);(i)++)
#define FOR(i,a,b) for(int (i)=(a);(i)<=(b);(i)++)
#define ROF(i,a,b) for(int (i)=(b);(i)>=(b);(i)--)
#define fe(i,a) for(int (i)=0;(i)<int((a).size());(i)++)

#define N 100010
#define pi 2*acos(0.0)
#define eps 1e-9
#define inf int(1e9)

#define pb push_back
#define ppb pop_back
#define all(c) (c).begin(),(c).end()
#define sz(c) int((c).size())

#define mp(a,b) make_pair((a),(b))

#define FREOPEN(a,b) freopen(a,"r",stdin);freopen(b,"w",stdout)

struct pii
{
	int fs,sc;
	bool friend operator<(pii a,pii b)
	{
		return a.fs < b.fs;
	}
};
priority_queue<int> s[2*N];
set<pii> st;
int Solve(int m)
{
	int ans=-inf,pos,cur;
	rep(i,m)
	{
		cur=-s[i].top();
		if(ans < cur)
		{
			pos=i;
			ans=cur;
		}
	}
	s[pos].pop();
	return ans;
}
int  get_ans()
{
	set<pii>::iterator it=st.begin();
	pii pt,ans=*it;
	s[ans.sc].pop();
	st.erase(it);
	if(!s[ans.sc].empty())
	{
		pt.sc=ans.sc;
		pt.fs=s[pt.sc].top();
		st.insert(pt);
	}
	return -ans.fs;
}
int main()
{
	//FREOPEN("input.txt","output.txt");
	FREOPEN("stones.dat","stones.sol");
	int n,m,op,t,w,cur;
	pii pt;
	scanf("%d%d",&n,&m);

	rep(i,n)
	{
		scanf("%d",&op);
		if(op == 1)
		{
			scanf("%d%d",&t,&w);
			t--;
			if(!s[t].empty() && -w > s[t].top())
			{
				cur=s[t].top();
				pt.fs=cur; pt.sc=t;
				st.erase(pt);
				pt.fs=-w;   s[t].push(-w); 
				st.insert(pt);
			} else 
			{
				if(s[t].empty())
				{
					pt.fs=-w;
					pt.sc=t;
					st.insert(pt);
				}
				s[t].push(-w);
			}
		} else
		if(op == 2)
		{
			printf("%d\n",get_ans());
		}
	}
	return 0;
}