#include<cstdio>
#include<cstdlib>
#include<vector>
#include<string>
#include<memory.h>
#include<algorithm>
#include<iostream>
#include<cmath>
#include<queue>
using namespace std;

#define rep(i,n) for(int (i)=0;(i)<(n);(i)++)
#define FOR(i,a,b) for(int (i)=(a);(i)<=(b);(i)++)
#define ROF(i,a,b) for(int (i)=(b);(i)>=(b);(i)--)
#define fe(i,a) for(int (i)=0;(i)<int((a).size());(i)++)

#define N 5010
#define pi 2*acos(0.0)
#define eps 1e-9
#define inf int(1e9)

#define pb push_back
#define ppb pop_back
#define all(c) (c).begin(),(c).end()
#define sz(c) int((c).size())

#define mp(a,b) make_pair((a),(b))
#define fs first
#define sc second
#define FREOPEN(a,b) freopen(a,"r",stdin);freopen(b,"w",stdout)

typedef pair<int,int> pii;
vector<pii> G[N];
int d[N];
bool used[N];

priority_queue<pii> q;
int main()
{
	//FREOPEN("input.txt","output.txt");
	FREOPEN("olympair.dat","olympair.sol");
	int n,m,op,a,b,c,to,len,v,cur;
	pii pt;
	scanf("%d%d",&n,&m);
	rep(i,m)
	{
		scanf("%d%d%d%d",&op,&a,&b,&c);
		a--; b--;
		if(op == 1)
		{
			G[a].pb(mp(b,c));
		} else
		if(op == 2)
		{
			fe(j,G[a])
			{
				to=G[a][j].first;
				len=G[a][j].second;
				G[b].pb(mp(to,len + c));
			}
		}
	}
	rep(i,n)d[i]=inf;
	d[0]=0;
	pt.fs=0; pt.sc=0;
	q.push(pt);
	while(!q.empty())
	{
		v=q.top().sc;
		cur=q.top().fs;
		q.pop();
		fe(i,G[v])
		{
			to=G[v][i].first;
			len=G[v][i].second;
			if(d[to] > cur + len)
			{
				d[to]=cur+len;
				pt.fs=d[to];
				pt.sc=to;
				q.push(pt);
			}
		}
	}
	for(int i=1;i<n;i++)
		if(d[i] == inf)puts("-1"); else printf("%d\n",d[i]);
		
	return 0;
}