const eps=1e-8;

var sz2,v,min,n,m,i,j,k,root,sz:longint;
    q,t,ost,res,tcost:int64;
    d:extended;
    used:array[0..40000] of boolean;
    st,cost,h,sum,w:array[0..1000000] of int64;
    g:record
        pred,last,y:array[0..1000000] of longint;
        size:longint;
    end;
    c:array[0..40000] of record x,y,r:longint; w:int64; end;
    l:array[0..40000] of record x,y,w:longint; end;


   function dist(x1,y1,x2,y2:int64):extended inline;
    begin
      dist:=sqrt(sqr(x1-x2)+sqr(y1-y2));
    end;
   procedure swap(var x,y:int64) inline;
    var q:int64;
     begin
       q:=x; x:=y; y:=q;
     end;
   procedure up(v:longint);
    begin
      while v>1 do
       begin
         if h[v]<h[v div 2] then
          begin
            swap(h[v],h[v div 2]);
            v:=v div 2;
          end
         else break;
       end;
    end;
   procedure down(v:longint);
   var t:longint;
    begin
      while true do
       begin
         if v+v>sz then break;
         if (v+v+1>sz)or(h[v+v]<h[v+v+1]) then t:=v+v
                                          else t:=v+v+1;
         if h[v]>h[t] then
          begin
            swap(h[v],h[t]);
            v:=t;
          end
         else break;
       end;
    end;
  procedure add(x,y:longint);
   begin
     inc(g.size);
     g.y[g.size]:=y;
     g.pred[g.size]:=g.last[x];
     g.last[x]:=g.size;
   end;
  procedure rec(v,p:longint);
  var x:longint;
   begin
     x:=g.last[v];
     sum[v]:=w[v];
     cost[v]:=0;
     while x<>0 do
      begin
        if g.y[x]<>p then
         begin
           rec(g.y[x],v);
           sum[v]:=sum[v]+sum[g.y[x]];
           cost[v]:=cost[v]+cost[g.y[x]];
         end;
        x:=g.pred[x];
      end;
     cost[v]:=cost[v]+(sum[v])*c[v].w;
   end;

  function calc:int64;
   var res:int64;
       i:longint;
   begin
     for i:=1 to n do
      if not used[i] then
       begin
         inc(sz);
         h[sz]:=sum[i]*c[i].w;
         res:=res+h[sz];
         up(sz);
         if sz>k then
          begin
            res:=res-h[1];
            h[1]:=h[sz];
            sz:=sz-1;
            down(1);
          end;
      end;

     calc:=res;

   end;
 begin
   assign(input,'camelot.dat');reset(input);
   assign(output,'camelot.sol');rewrite(output);
   read(n,m,k);
   for i:=1 to n do
    begin
      read(c[i].x,c[i].y,c[i].r,c[i].w);
    end;
   for i:=1 to m do
    begin
      read(l[i].x,l[i].y,l[i].w);
//      inc(l[i].w);
    end;
   root:=n+1;
   for i:=1 to n do
    for j:=1 to n do
     if c[i].r>c[j].r then
      begin
        d:=dist(c[i].x,c[i].y,c[j].x,c[j].y);
        if d+c[j].r<c[i].r+eps then
         begin
           add(i,j);
           add(j,i);
           used[j]:=true;
         end;
      end;

   for i:=1 to n do
    if not used[i] then add(root,i);

   for i:=1 to m do
    begin
      v:=-1;
      min:=maxlongint;
      for j:=1 to m do
       if c[j].r>min then continue
       else
       begin
         d:=dist(l[i].x,l[i].y,c[j].x,c[j].y);
         if d<c[j].r+eps then
          begin
            min:=c[j].r;
            v:=j;
          end;
       end;
      if (v=-1) then inc(w[root],l[i].w)
                else inc(w[v   ],l[i].w);
    end;
   res:=maxlongint*maxlongint;
   rec(root,root);
   fillchar(used,sizeof(used),false);
   used[root]:=true;
   res:=cost[root]-calc;

   used[root]:=false;
   for i:=1 to n do
    begin
      q:=tcost-sum[i]*c[i].w+(sum[root]-sum[i])*c[i].w;
      used[i]:=true;
      q:=q-calc;
      used[i]:=false;
      if q<res then res:=q;
    end;


   writeln(res);

 end.
