procedure qsort(var a: array of longint; first, last, elem: longint);
var
  m, left, right, temp: longint;
begin
  m := a[(first + last) div 2];
  left := first;
  right := last;

  while left <= right do
  begin
    while a[left] < m do
      inc(left);
    while a[right] > m do
      dec(right);
    if left <= right then
    begin
      if (a[left] = elem) or (a[right] = elem) then
      begin
        temp := a[left];
        a[left] := a[right];
        a[right] := temp;
      end;

      inc(left);
      dec(right);
    end;
  end;

  if left < last then
    qsort(a, left, last, elem);
  if right > first then
    qsort(a, first, right, elem);
end;


var
  n, i, k, len, len2, max, x, j, u: longint;
  ch: char;
  s: string;
  now, now2: array of string;
  y: boolean;

begin
  assign(input, 'mutation.dat');
  reset(input);
  assign(output, 'mutation.sol');
  rewrite(output);

  readln(n);

  for i := 0 to n - 1 do
  begin
    read(x);
    s := s + chr(x + 48);
  end;

  len := 1;
  setlength(now, 1);
  now[0] := s;

  k := 0;
  while len > 0 do
  begin
    len2 := 0;
    inc(k);
    for u := 0 to len - 1 do
    begin
      i := 1;
      y := true;
      while i < length(now[u]) do
      begin
        inc(i);
        if now[u, i] < now[u, i - 1] then
        begin
          inc(len2);
          setlength(now2, len2);
          now2[len2 - 1] := now[u];
          ch := now[u, i];
          j := 0;
          while j < length(now2[len2 - 1]) do
          begin
            inc(j);
            if now2[len2 - 1, j] = ch then
            begin
              delete(now2[len2 - 1], j, 1);
              dec(j);
            end;
          end;
          y := false;
        end;
      end;
      if y then
      begin
        writeln(k - 1);
        exit;
      end;
    end;
    now := now2;
    len := len2;
  end;
  writeln;
end.
