program olympair;
const maxc = 100000000;
      size = 1000000;
      inf = 1000000000000000;

type reb = record
  n, v: longint;
  bad: boolean;
  c: int64;
end;

type pair = record
  c, r: int64;
end;

var i, n, zn, j, a, b, m, tip, head, tail: longint;
    c: int64;
    st: array[1..100000] of longint;
    list: array[1..100000] of reb;
    q: array[1..size] of longint;
    dist: array[1..100000] of pair;
    used: array[1..100000] of boolean;

procedure add(tip, a, b: longint; c: int64);
  begin
    inc(zn);
    list[zn].v := b;
    list[zn].n := st[a];
    list[zn].c := c;
    st[a] := zn;
    if tip = 1 then list[zn].bad := false else list[zn].bad := true;
  end;

procedure calc;
  var i: longint;
  begin
    head := 1; tail := 2;
    q[1] := 1;
    used[1] := true;
    while head <> tail do
      begin
        i := st[q[head]];
        while i <> 0 do
          begin
            if (dist[q[head]].c + list[i].c > 0)and(dist[list[i].v].c > dist[q[head]].c + list[i].c) then
              begin
                dist[list[i].v].c := dist[q[head]].c + list[i].c;
                if not list[i].bad then dist[list[i].v].r := dist[list[i].v].c;
                if not used[list[i].v] then
                  begin
                    used[list[i].v] := true;
                    q[tail] := list[i].v;
                    inc(tail);
                    if tail = size then tail := 1;
                  end;
              end;
            if (dist[q[head]].r + list[i].c > 0)and(dist[list[i].v].r > dist[q[head]].r + list[i].c) then
              begin
                if not list[i].bad then dist[list[i].v].r := dist[list[i].v].c;
                if not used[list[i].v] then
                  begin
                    used[list[i].v] := true;
                    q[tail] := list[i].v;
                    inc(tail);
                    if tail = size then tail := 1;
                  end;
              end;
            i := list[i].n;
          end;
        used[q[head]] := false;
        inc(head);
        if head = size then head := 1;
      end;
  end;

begin
  assign(input, 'olympair.dat');
  assign(output, 'olympair.sol');
  reset(input); rewrite(output);
  read(n, m);
  zn := 0;
  for i := 1 to m do
    begin
      read(tip, a, b, c);
      if tip = 1 then add(tip, a, b, c) else
        add(tip, b, a, c);
    end;
  for i := 1 to n do begin dist[i].c := inf; dist[i].r := inf; end;
  dist[1].c := 0;
  dist[1].r := 0;
  calc;
  for i := 2 to n do if dist[i].r = inf then writeln(-1) else writeln(dist[i].r);
  close(input); close(output);
end.
