#include <iostream>
#include <cstdio>
#include <cmath>
#include <cstring>
#include <string>
#include <vector>
#include <list>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <cstdlib>
#include <bitset>
#include <algorithm>

using namespace std;

typedef long long INT;

#if (_WIN32 || __WIN32|__)
    #define LLD "%I64d"
#else
    #define LLD "%lld"
#endif

#define INPUT(a) freopen(#a, "r", stdin);
#define OUTPUT(a) freopen(#a, "w", stdout);
#define WITH_FILES(a, b) {INPUT(a) OUTPUT(b)}
#define pu push_back

const int MAXN = 1010;

int a[MAXN];

int main(){
    WITH_FILES(tetris.dat, tetris.sol)
    int n;
    scanf("%d", &n);
    for (int i = 0; i < n; i++)
        scanf("%d", &a[i]);
    for (int i = 0; i < n; i++){
        int x;
        scanf("%d", &x);
        a[i] = x - a[i];
        if (a[i] < 0)
            a[i] += 4;
    }
    /*for (int i = 0; i < n; i++)
        printf("%d ", a[i]);
    printf("\n");*/
    int ans = 0;
    for (int k = 3; k > 0; k--){
        int l = -1;
        for (int i = 0; i < n; i++)
            if (l == -1){
                if (a[i] == k)
                    l = i;
            }
            else
                if (a[i] != k){
                    ans++;
                    for (int j = l; j < i; j++)
                        a[j]--;
                    //printf(">>> k = %d, i = %d\n", k, i);
                    l = -1;
                }
        if (l != -1){
            ans++;
            for (int j = l; j < n; j++)
                a[j]--;
        }
    }
    printf("%d\n", ans);
    return 0;
}
