#include <iostream>
#include <fstream>
#include <map>

using namespace std;

typedef map<int, int> node; // <child, weight>

node **conv;

int n, m;

#define C(X) (*(conv[(X)]))

int main()
{
	ifstream in("olympair.dat");
	ofstream out("olympair.sol");

	in >> n >> m;

	conv = new node*[n];
	for (int i = 0; i < n; i++) {
		conv[i] = new node;
	}

	for (int i = 0; i < m; i++) {
		int op, a, b, c;
		in >> op >> a >> b >> c;
		a--, b--;
		if (op == 1) {
			C(a)[b] = c;
		} else {
			node A = C(a);
			for (node::iterator j = A.begin(); j != A.end(); j++) {
				C(b)[j->first] = j->second + c;
			}
		}
	}

	return 0;
}