#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <cstring>
#include <cassert>
#include <cmath>
#include <queue>
#include <deque>
using namespace std;

#define pb push_back
#define mp make_pair
#define sz(x) (int)(x).size()
#define foreach(i,x) for(__typeof(x.begin()) i = x.begin();i!=x.end();++i)
#define eprintf(...) fprintf(stderr, __VA_ARGS__)

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;

#define task "stones"

int main(){
	#ifdef DEBUG
	freopen("input.txt","r",stdin);
	freopen("output.txt","w",stdout);
	#else
	freopen(task".dat","r",stdin);
	freopen(task".sol","w",stdout);
	#endif
	int n,m;
	scanf("%d%d",&n,&m);
	set<int> s[m+1];
	for (int i=0;i<n;++i){
		int t;
		scanf("%d",&t);
		if (t==1){
			int c,st;
			scanf("%d%d",&c,&st);
			s[c].insert(st);
		} else{
			int ei,wi=0;
			for (int j=1;j<=m;++j){
				int w = *s[j].begin();
				if (w>wi){
					wi = w;
					ei = j;
				}
			}
			s[ei].erase(s[ei].begin());
			printf("%d\n",wi);
		}
	}
	return 0;
}
