#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
#include <deque>
using namespace std;

#define mp make_pair
#define pb push_back
#define sz(x) (int)(x).size()
#define eprintf(...) fprintf(stderr, __VA_ARGS__)

typedef long long ll;
typedef pair<int,int> pii;

const int maxn = 1024;
const ll inf = (ll)1e9;

#define task "cap"

int n,m,dx[] = {0,0,-1,1}, dy[] = {1,-1,0,0}, enx, eny, stx, sty;
ll  d[maxn][maxn];
char s[maxn][maxn];

#define x second
#define y first

int main(){
  #ifdef DEBUG
  freopen("input.txt","r",stdin);
  freopen("output.txt","w",stdout);
  #else
  freopen(task".dat","r",stdin);
  freopen(task".sol","w",stdout);
  #endif
  cin >> n >> m;
  for (int i=0;i<n;++i)
    for (int j=0;j<m;++j){
      d[i][j]=inf;
      cin >> s[i][j];
      if (s[i][j]=='o'){
        stx = j;
        sty = i;
      }
      if (s[i][j]=='+'){
        enx = j;
        eny = i;
      }
    }
  d[sty][stx] = 0;

  queue< pii > q;
  q.push(mp(sty,stx));
  while (!q.empty()){
    pii v = q.front();
    q.pop();
    for (int i=0;i<max(n,m);++i){
      if (i<n && s[i][v.x]!='.' && d[i][v.x]>d[v.y][v.x]+1){
        d[i][v.x] = d[v.y][v.x]+1;
        q.push(mp(i,v.x));

      }
      if (i<m && s[v.y][i]!='.' && d[v.y][i]>d[v.y][v.x]+1){
        d[v.y][i] = d[v.y][v.x]+1;
        q.push(mp(v.y,i));
      }
    }
   /* for (int i=0;i<m;++i)
      if (s[v.y][i]!='.' && d[v.y][i]>d[v.y][v.x]+1){
        d[v.y][i] = d[v.y][v.x]+1;
        q.push(mp(v.y,i));
      }*/
  }
  if (d[eny][enx]==inf)
    cout << -1; else
    cout << d[eny][enx];
  return 0;
}

