#include <queue>
#include <vector>
#include <stdio.h>
#include <iostream>

#define PB push_back
#define MP make_pair
#define X first
#define Y second

using namespace std;

char c;
int n, m, startX, startY, endX, endY, size_begin, size_end, k = 0;
bool pole[1001][1001];
bool used_begin[1001][1001], used_end[1001][1001];
vector < int > X[1001], Y[1001];
queue < pair < int, int > > q_begin, q_end;
pair < int, int > pos;

int main()
{
    freopen("cap.dat", "r", stdin);
    freopen("cap.sol", "w", stdout);
    
    scanf("%d%d", &n, &m);
    //used = new bool*[n];
    //pole = new bool*[n];
    
    for( int i = 0; i < n; i++ )
    {
         //used[i] = new bool[m];
         //pole[i] = new bool[m];
         for( int j = 0; j < m; j++ )
         {
              c = '\n';
              while( (c == '\n') || (c == ' ') ) scanf("%c", &c);
              switch( c )
              {
                      case 'o': pole[i][j] = 1, startX = i, startY = j, X[i].PB(j);
                      break;
                      
                      case '+': pole[i][j] = 1, endX = i, endY = j, X[i].PB(j);
                      break;
                      
                      case 'x': pole[i][j] = 1, X[i].PB(j);
                      break;
                      
                      default: pole[i][j] = 0;
              }
         }
    }
    
    for( int j = 0; j < m; j++ )
    {
         for( int i = 0; i < n; i++ )
         {
              if( pole[i][j] == 1 ) Y[j].PB(i);
              used_begin[i][j] = 0;
              used_end[i][j] = 0;
         }
    }
    
    used_begin[startX][startY] = 1;
    used_end[endX][endY] = 1;
    q_begin.push( MP( startX, startY ) );
    q_end.push( MP( endX, endY ) );
    size_begin = q_begin.size();
    size_end = q_end.size();
    while( (size_begin != 0) && (size_end != 0) )
    {
           /*----------------------*/
           for( int i = 0; i < size_begin; i++ )
           {
                pos = q_begin.front();
                q_begin.pop();
                
                if( used_end[pos.X][pos.Y] == 1 )
                {
                    printf("%d\n", k*2);
                    fclose(stdin);
                    fclose(stdout);
                    return 0;
                }
                
                for( int j = 0; j < X[pos.X].size(); j++ )
                {
                     if( used_begin[pos.X][X[pos.X][j]] == 0 )
                     {
                         used_begin[pos.X][X[pos.X][j]] = 1;
                         q_begin.push( MP( pos.X, X[pos.X][j] ) );
                     }
                }
                
                for( int j = 0; j < Y[pos.Y].size(); j++ )
                {
                     if( used_begin[Y[pos.Y][j]][pos.Y] == 0 )
                     {
                         used_begin[Y[pos.Y][j]][pos.Y] = 1;
                         q_begin.push( MP( Y[pos.Y][j], pos.Y ) );
                     }
                }
           }
           /*------------------*/
           /*----------------------*/
           for( int i = 0; i < size_end; i++ )
           {
                pos = q_end.front();
                q_end.pop();
                
                if( used_begin[pos.X][pos.Y] == 1 )
                {
                    printf("%d\n", k*2 + 1);
                    fclose(stdin);
                    fclose(stdout);
                    return 0;
                }
                
                for( int j = 0; j < X[pos.X].size(); j++ )
                {
                     if( used_end[pos.X][X[pos.X][j]] == 0 )
                     {
                         used_end[pos.X][X[pos.X][j]] = 1;
                         q_end.push( MP( pos.X, X[pos.X][j] ) );
                     }
                }
                
                for( int j = 0; j < Y[pos.Y].size(); j++ )
                {
                     if( used_end[Y[pos.Y][j]][pos.Y] == 0 )
                     {
                         used_end[Y[pos.Y][j]][pos.Y] = 1;
                         q_end.push( MP( Y[pos.Y][j], pos.Y ) );
                     }
                }
           }
           /*------------------*/
           size_begin = q_begin.size();
           size_end = q_end.size();
           k++;
    }
    
    printf("-1\n");
    fclose(stdin);
    fclose(stdout);
    return 0;
}
