#include <cstdio>
#include <cmath>
#include <cstring>
#include <iostream>
#include <list>
#include <vector>

using namespace std;

typedef list<int> li;
typedef li::const_iterator clit;

int n;

void arc(const li &a, li &b ){
    b.clear();
    clit curr, next;
    curr = next = a.begin();
    ++next;
    while(curr != a.end()){
       // cout  << *curr << endl;
        if ( *curr != *next ) b.push_back(*curr);
        curr = next++;
    }
}
void del_single(const li &a, li &b){
    b.clear();
    static vector < int > cnt;
    cnt.resize(n, 0);
    for ( clit it = a.begin(); it != a.end(); ++it ){
            cnt[*it]++;
    }
    for ( clit it = a.begin(); it != a.end(); ++it ) {
        if ( cnt[*it] > 1 ){
            b.push_back(*it);
        }
    }
}

int main(){
    FILE *fh = fopen( "mutation.dat", "r" );
    fscanf( fh, "%d\n", &n );
    li g;
    int max_c = -1;
    for ( int i = 0; i < n; ++i ){
        int curr;
        fscanf(fh, "%d ", &curr);
        max_c = max ( max_c, curr );
        g.push_back(curr);
    }
    li a;
    arc(g, a);
    del_single(a, g);
    fh = fopen( "mutation.sol", "w" );
    fprintf ( fh, "%d\n", int(ceil(1.0*g.size()/max_c)) );
    fclose ( fh );

    return 0;
}
