#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <list>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <utility>

using namespace std;

/*ifstream fin("cap.dat");
ofstream fout("cap.sol");*/
FILE *fh;
typedef long long LL;
typedef long double LD;
const LD PI = 3.1415926535897932384626433832795L;
template < typename T > const T sqr(const T x){return x*x;}
const LL binpow(const LL a, const LL n, const LL mod){if ( n == 0 ) return 1;if ( n == 1 ) return a%mod;return (binpow( sqr(a), n/2, mod ) * ( n % 2 ? a : 1 ))%mod;}

const int MAXN = 1042;
const char EMPTY = '.';
const char START = 'o';
const char USED = '&';
const char UNUSED = 'x';
const char FINISH = '+';
int n, m;

char a[MAXN][MAXN];

inline void out(const int cnt){
	fh = fopen("cap.sol", "w");
	fprintf(fh,"%d\n",cnt);
	fclose(fh);
	exit(0);
}

int main(){
	fh = fopen("cap.dat", "r");
    fscanf(fh, "%d %d\n", &n, &m);
    int i0, j0, i1, j1;
    for ( int i = 1; i <= n; ++i){
		fscanf(fh, "%s\n", a[i]+1);
        for ( int j = 1; j <= m; ++j ){
            if ( a[i][j] == START) {
                i0 = i;
                j0 = j;
            }else if (a[i][j] == FINISH){
				i1 = i;
				j1 = j;
			}
			if ( a[i][j] == '.' ) {
				a[i][j] = USED;
			}else {
				a[i][j] = UNUSED;
			}
        }
    }

    queue < pair < int, pair < int, int > > > q;
    a[i0][j0] = USED;
    q.push ( make_pair ( 0, make_pair ( i0, j0 ) ) );
    while ( !q.empty() ){
        int cnt = q.front().first;
        int i0 = q.front().second.first;
        int j0 = q.front().second.second;
        q.pop();
        if ( i0 == i1 && j0 == j1){
            out(cnt);
        }
        for ( int i = 1; i <= n; ++i ){
            if ( a[i][j0] == UNUSED ){
                a[i][j0] = USED;
                q.push(make_pair(cnt+1, make_pair(i, j0)));
            }
		}
        for ( int j = 1; j <= m; ++j ){
            if ( a[i0][j] == UNUSED ){
                a[i0][j] = USED;
                q.push(make_pair(cnt+1, make_pair(i0, j)));
            }
        }
    }

    out(-1);
    return 0;
}
