#include<cstdio>
#include<iostream>
#include<algorithm>
#include<queue>
#include<map>
using namespace std;
long long const infinyty=(long long)1000*1000*1000*1000*1000*10;
map<int,long long> m[200000];
vector<pair<int,int> > fi[200000];
long long dist[200000];
priority_queue<pair<long long,int> > q;
void create(int a,int b,long long cost)
{
    int k=m[a][b];
	if(k==0 || k>cost)
		m[a][b]=cost;
}
void mascreate(int a,int b,int dop)
{
	fi[b].push_back(make_pair(a,dop));
}
void dextra()
{
	while(!q.empty())
	{
		pair<int,int> p=q.top();
		q.pop();
		long long cost=p.first*-1;
		int from=p.second;
		if(dist[from]<cost)
			continue;
		for(map<int,long long>::iterator i=m[from].begin();i!=m[from].end();i++)
		{
			if(cost+i->second<dist[i->first])
			{
				q.push(make_pair(-1*(cost+i->second),i->first));
				dist[i->first]=cost+i->second;
			}
		}
		for(int j=0;j<fi[from].size();j++)
        {
            for(map<int,long long>::iterator i=m[fi[from][j].first].begin();i!=m[fi[from][j].first].end();i++)
			{
				if(i->first==from)
					continue;
				if(cost+i->second+fi[from][j].second<dist[i->first])
				{
					q.push(make_pair(-1*(cost+i->second+fi[from][j].second),i->first));
					dist[i->first]=cost+i->second+fi[from][j].second;
				}
			}
        }

	}
}
int main()
{
	freopen("olympair.dat","r",stdin);
	freopen("olympair.sol","w",stdout);
	int n,m;
	cin>>n>>m;
	for(int i=0;i<m;i++)
	{
		int t,a,b,c;
		scanf("%d%d%d%d",&t,&a,&b,&c);
		if(t==1)
			create(a,b,c);
		else
			mascreate(a,b,c);
	}
	for(int i=0;i<=n;i++)
		dist[i]=infinyty;
	dist[1]=0;
	q.push(make_pair(0,1));
	dextra();
	for(int i=2;i<=n;i++)
	{
		if(dist[i]!=infinyty)
		printf("%lld\n",dist[i]);
		else
			printf("-1\n");
	}
	return 0;
}
