#include <iostream>
#include <fstream>
#include <math.h>

using namespace std;

FILE *Input, *Output;

int i, j, n, m, temp, res[100001], a, b, c, r[10000][1000];

void dfs(int v, int time)
{
	int i, temp;
	if (time < res[v] || res[v] == 0) res[v] = time;
	for (i = 2; i <= n; i++)
	{
		if (r[v][i] != 0)
		{
			temp = r[v][i];
			r[v][i] = 0;
			dfs(i, time + temp);
			r[v][i] = temp;
		}
	}
}

int main()
{
	Input = fopen("olympair.dat", "r");
	fscanf(Input, "%d%d", &n, &m);
	for (i = 0; i < m; i++)
	{
		fscanf(Input, "%d%d%d%d", &temp, &a, &b, &c);
		if (temp == 1)
		{
			r[a][b] = c;
		} 
		else
		{
			for (j = 1; j <= n; j++)
			{
				if (r[a][j] != 0)
					r[b][j] = r[a][j] + c;
			}
		}
	}
	fclose(Input);

	dfs(1, 0);

	Output = fopen("olympair.sol", "w");
	for (i = 2; i <= n; i++)
	{
		if (i != 2)
			fprintf(Output, "\n");
		if (res[i] != 0)
			fprintf(Output, "%d", res[i]);
		else fprintf(Output, "%d", -1);
	}
	fclose(Output);

	return 0;
}