#include <iostream>
#include <fstream>
#include <math.h>

using namespace std;

FILE *Input, *Output;

int i, j, x, n, temp, a[1000], b[1000], k[1000];
long long res = 0;

bool perev()
{
	bool can = true;
	for (i = 0; i < n && can; i++)
		if (k[i] != 0) can = false;
	return can;
}

int main()
{
	Input = fopen("tetris.dat", "r");
	fscanf(Input, "%d", &n);
	for (i = 0; i < n; i++)
	{
		fscanf(Input, "%d", &a[i]);
	}
	for (i = 0; i < n; i++)
	{
		fscanf(Input, "%d", &b[i]);
		k[i] = b[i] - a[i];
		if (k[i] < 0)
			k[i] += 4;
	}
	fclose(Input);

	for (i = 1; i <= n-2; i++)
	{
		j = i;
		if (k[i] == 0 && (k[i-1] == 3 || k[i-1] == 2))
		{
			while (k[j] == 0) j++;
			if ((k[i-1] == 3 && k[j] == 2) || (k[i-1] == 2 && k[j] == 3) || (k[i-1] == 3 && k[j] == 3))
			{
				temp = j - 1;
				for (j = i; j <= temp; j++)
					k[j] = 4;
			}
		}
	}

	while (!perev())
		for (i = 0; i < n; i++)
		{
			if (k[i] > 0)
			{
				temp = k[i];
				j = i + 1;
				while(k[j] > 0)
				{
					if (k[j] < temp)
						temp = k[j];
					j++;
				}
				res += temp;
				x = j;
				for (j = i; j < x; j++)
					k[j] -= temp;
				i--;
			}
		}
	
	Output = fopen("tetris.sol", "w");
	fprintf(Output, "%d", res);
	fclose(Output);
	
	return 0;
}