#include <iostream>
#include <cstdio>
#include <queue>
#include <algorithm>
#include <string>
#include <cstring>
#include <map>

using namespace std;

//|| used[i][y]>used[x][y]+1   || used[x][j]>used[x][y]+1
queue< pair<int, int> > q;
int n,m,i,j,x,y;
char a[1000][1000];
int used[1000][1000];
map<int, int> mm;
bool b[1000][1000];
void bfs(){
    while (!q.empty()){
        int x=q.front().first;
        int y=q.front().second;
        q.pop();
        for (int i=0; i<n; ++i)
            if (i!=x && used[i][y]==0  && a[i][y]!='.'){
                used[i][y]=used[x][y]+1;
                if (a[i][y]=='+') return;
                int s=i*n+y;
                if (mm[s]!=1){
                    q.push(make_pair(i, y));
                    mm[s]=1;
                }
            }
        for (int j=0; j<m; ++j)
            if (j!=y && used[x][j]==0 && a[x][j]!='.'){
                used[x][j]=used[x][y]+1;
                if (a[x][j]=='+') return;
                int s=x*n+j;
                if (mm[s]!=1){
                    q.push(make_pair(x, j));
                    mm[s]=1;
                }
            }
        mm[x*n+y]=1;
        b[x][y]=false;
    }


}

int main(){
    freopen("cap.dat", "r", stdin);
    freopen("cap.sol", "w", stdout);
    scanf("%d%d", &n, &m);
    for(i=0; i<n; ++i)
        scanf("%s", a[i]);
    for (i=0; i<n; ++i){
        memset(used[i], 0, m*sizeof(int) );
        memset(b[i], true, m*sizeof(int));
    }
    for (i=0; i<n; ++i)
        for (j=0; j<m; ++j){
            if (a[i][j]=='o') { q.push(make_pair(i,j)); a[i][j]='.'; }
            if (a[i][j]=='+') {x=i; y=j;}
        }
    bfs();

    if (used[x][y]>0) printf("%d", used[x][y]); else printf("-1");
    return 0;
}
