type
  int=longint;

var
  n:int;
  i,j:int;
  c,k:int;
  a,b:array[1..200000]of int;
  q,w:array[1..100000]of int;
  d:array[1..100000]of int;

procedure swap(var a,b:int);
var
  k:int;
begin
  k:=a;
  a:=b;
  b:=k;
end;

procedure qsort(first,last:int);
var
  i,j:int;
  key:int;
begin
  if(last-first<30)then begin
    for i:=first to last-1 do
      for j:=i+1 to last do
        if d[j]>d[j+1] then swap(d[j],d[j+1]);
  end;
  if(last=first+1)then begin
    if d[first]>d[last] then swap(d[first],d[last]);
    exit;
  end;
  i:=first;
  j:=last;
  key:=(i+j)shr 1;
  if d[first]>d[key] then swap(d[first],d[key]);
  if d[key]>d[last]  then swap(d[key],d[last]);
  key:=d[key];
  while true do begin
    while(d[i]<key)do inc(i);
    while(key<d[j])do dec(j);
    if i>=j then break;
    swap(d[i],d[j]);
    inc(i);dec(j);
  end;
  if first<j then qsort(first,j);
  if i<last then qsort(i,last);
end;

begin
  assign(input,'calendar.dat');
  reset(input);
  assign(output,'calendar.sol');
  rewrite(output);

  readln(n);
  for i:=1 to n do begin
    read(a[i]);
    q[a[i]]:=i;
  end;
  for i:=1 to n do begin
    read(b[i]);
    w[b[i]]:=i;
    d[b[i]]:=q[b[i]]-w[b[i]];
    if d[b[i]]<=0 then inc(d[b[i]],n);
    b[i+n]:=b[i];
  end;

  qsort(1,n);

  c:=1;
  k:=1;
  for i:=2 to n do begin
    if(d[i]=d[i-1])then begin
      inc(k);
    end else begin
      if k>c then c:=k;
      k:=1;
    end;
  end;
  writeln(c);

  {c:=0;
  for i:=1 to n-1 do begin
    k:=0;
    for j:=1 to n do
      if(a[j]=b[j+i])then inc(k);
    if k>c then c:=k;
  end;
  writeln(c);}

  close(output);
  close(input);
end.
