#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <cstdlib>
#include <cmath>

#define FOR0(i,n) for( i = 0 ; i < n ; i++ )
#define FOR1(i,n) for( i = 1 ; i <= n ; i++ )
#define sys_p system( "pause" ) 
#define mp make_pair
#define pb push_back

using namespace std ;

typedef long long LL ;

struct pt
{
       LL i, j, type ;
       pt()
       {
           i = j = type = 0 ;
       }
       pt( LL x, LL y, LL t )
       {
           i = x ; j = y ; type = t ;
       }
};

ifstream Cin( "cap.dat" ) ;
ofstream Cout( "cap.sol" );

main()
{
     LL n, m, i, j, curi, curj, curt, si, sj, ni, nj, visi[1001] = {}, visj[1001] = {}, op[1001][1001] = {}, r[1001][1001] ; ;
     char c ;
     Cin >> n >> m ;
     FOR1( i, n )
       FOR1( j, m )
       {
         Cin >> c ;
         if( c == 'x' )
           r[i][j] = 1 ;
         else if( c == 'o' )
         {
           r[i][j] = 2 ;
           si = i ;
           sj = j ;
         }
         else if( c == '+' )
         {
           r[i][j] = 3 ;
           ni = i ;
           nj = j ;
         }
       } 
       
     queue < pt > Q ;
     Q.push( pt( si, sj, 1 ) ) ;
     Q.push( pt( si, sj, 2 ) ) ;
     while( !Q.empty() )
     {
            curi = Q.front().i ;
            curj = Q.front().j ;
            curt = Q.front().type ;
            //cout << curi << " " << curj << " " << curt << endl ;
            Q.pop() ;
            if( curt == 1 )
            {
                visj[curj] = 1 ;
                for( i = 1 ; i <= n ; i++ )
                  if( i != curi && r[i][curj] && !op[i][curj] && !visi[i] )
                  {
                    op[i][curj] = op[curi][curj] + 1 ;
                    Q.push( pt( i, curj, 2 ) ) ;
                  }
            }
            else
            {               
                visi[curi] = 1 ;
                for( j = 1 ; j <= m ; j++ )
                  if( j != curj && r[curi][j] && !op[curi][j] && !visj[j] )
                  {
                    op[curi][j] = op[curi][curj] + 1 ;
                    Q.push( pt( curi, j, 1 ) ) ;
                  }
            }
                        
     }  
       
     if( !op[ni][nj] )
         Cout << -1 ;
     else
         Cout << op[ni][nj] ;
     //sys_p ;
}
