#include <cstdio>
#include <list>
#include <utility>
#include <set>
#include <vector>

using namespace std;

const int maxn = 100010;

int n, m;

struct list_str {
	int to;
	int val;
	list_str (int _to, int _val){to=_to; val=_val;}
};

vector<vector<list_str> > g;
int t,A,B,C;

struct dstruct {
	int to, val;
	dstruct (int _to, int _val) {to=_to; val=_val;}
};

bool operator< (dstruct a, dstruct b){return a.val<b.val;}

set < dstruct > dd;

long long d [maxn];

int main(){
	freopen ("olympair.dat","r", stdin);
	freopen ("olympair.sol", "w", stdout);
	scanf ("%d %d", &n, &m);
	g.resize(n+1);
	for (int i = 0; i<m; i++){
		scanf ("%d %d %d %d", &t, &A, &B, &C);
		if (t == 1){
			g [A].push_back(list_str(B, C));
		}else{
			for (int i = 0; i<g[A].size(); i++)
				g[B].push_back(list_str(g[A][i].to, g[A][i].val+C));
		}
	}
	for (int i = 1; i<=n; i++){
		d [i] = -1;
	}
	d[1] = 0;
	for (int i = 0; i<g[1].size(); i++){
		dd.insert (dstruct (g[1][i].to,  g[1][i].val));
		if (d[g[1][i].to] == -1 || d [g[1][i].to]>g[1][i].val)
			d[g[1][i].to] = g[1][i].val;
	}
	while (!dd.empty()){
		dstruct now = *(dd.begin());
		for (int i = 0; i<g[now.to].size(); i++){
			if (d[now.to]+g[now.to][i].val<=d[g[now.to][i].to])
				d[g[now.to][i].to] = d[now.to]+g[now.to][i].val;
		}
		dd.erase(now);
	}
	for (int i = 2; i<=n; i++)
		printf("%d\n", d[i]);
	return 0;
}