#include <cstdio>
#include <set>
#include <algorithm>

using namespace std;

struct line {
	int from, to, value, fict;
	line (int _from, int _to, int _value, bool _fict = false) {from=_from; to=_to; value=_value; fict=_fict;}
	line () {}
};

bool operator< (line a, line b){ return a.value<b.value;}
bool line_p (line a, line b) { if (a.from==b.from) return a.to<b.to; return a.from<b.from;}

const int maxnm = 100010;

line lines [maxnm];
int line_starts [maxnm];

int n, m;

int res_normal [maxnm];
int res_fict [maxnm];



set < int > dd;

int main (){
	int t, A,B,C;
	freopen ("olympair.dat","r", stdin);
	freopen ("olympair.sol", "w", stdout);
	scanf ("%d %d", &n, &m);
	for (int i = 0; i<m; i++){
		scanf ("%d %d %d %d", &t,&A,&B,&C);
		if (t == 1)
			lines[i] = line (A,B,C);
		else
			lines[i] = line(B,A,C,false);
	}
	sort (lines, lines+m, &line_p);
	for (int i = 0; i<m; i++)
		line_starts[i] = -1;
	for (int i = 0; i<m; i++){
		if (line_starts[lines[i].from] == -1)
			line_starts[lines[i].from] = i;
	}
	for (int i = 1; i<=n; i++)
		res_normal [i] = res_fict[i] = 1000000000;
	for (int i = 0; lines[i].from == 1; i++){
		dd.insert (lines[i].to);
		res_normal [lines[i].to] = res_fict [lines[i].to] = lines[i].value;
	}
	while (!dd.empty()){
		int now = *(dd.begin());
		for (int i = line_starts[now]; lines[i].from == now; i++){
			if (res_fict [lines[i].to]>res_fict[1]+res_fict[now]+lines[i].value)
				res_fict [lines[i].to] = res_fict[1]+res_fict[now]+lines[i].value;
			if (!lines[i].fict){
				if (res_normal [lines[i].to]>res_fict[1]+res_fict[now]+lines[i].value)
					res_normal [lines[i].to] = res_fict[1]+res_fict[now]+lines[i].value;
			}
		}
		dd.erase(now);
	}
	for (int i = 2; i<=n; i++){
		if (res_normal[i]==1000000000)
			printf("-1\n");
		else
			printf ("%d\n", res_normal[i]);
	}
	return 0;
}