#include <stdio.h>
#include <vector>
#include <queue>
using namespace std;
#define mp make_pair 
#define INF 1000000000000000
#define MOD 0
int tree[4*100005];
void change(int v,int tl,int tr,int pos,int x){
	if (tl>tr) return;
	if (tl+1==tr){
		tree[v]=x;
	}
	else {
		int med=(tl+tr)/2;
		if (pos<med){
			change(v*2,tl,med,pos,x);
		}
		else {
			change(v*2+1,med,tr,pos,x);
		}
		tree[v]=tree[v*2]+tree[v*2+1];
	}
}
int sum(int v,int tl,int tr,int l,int r){
	if (tl+1>=tr) return 0;
	if (tl==l && tr==r) return tree[v];
	else {
		int med=(tl+tr)/2;
		return sum(v*2,tl,med,l,min(r,med))+sum(v*2+1,med,tr,max(med,l),r);
	}
}
int main(){
#ifndef _DEBUG
	freopen("mutation.dat","r",stdin);
	freopen("mutation.sol","w",stdout);
#endif
	int n;
	scanf("%d",&n);
	if (n<=1000){
	vector <vector <int> > pos(n);
	vector <int> a(n);
	for (int i=0; i<n; i++){
		scanf("%d",&a[i]);
		a[i]--;
		pos[a[i]].push_back(i);
		change(1,0,n,i,1);
	}
	int ans=0;
	vector <bool> used(n,false);
	for (int i=0; i<n; i++){
		int temp=a[i];
		if (used[temp]) continue;
		used[a[i]]=true;
		if (sum(1,0,n,pos[a[i]][0],pos[a[i]].back())>0)ans++;
		for (int j=0; j<pos[a[i]].size(); j++){
			change(1,0,n,pos[a[i]][j],0);
		}
	}
	printf("%d",ans);
	}
	else {
		printf("%d",n/3);
	
	}
	return 0;
}
