#include <stdio.h>
#include <time.h>

const int nmax = (int)1e5 + 10;

int a[nmax], b[nmax], n, best, cnt, tmp;
clock_t start;

void read()
{
    scanf("%d\n", &n);
    for(int i = 0; i < n; ++i)
    	scanf("%d", a + i);
    for(int i = 0; i < n; ++i)
    	scanf("%d", b + i);
}

void solve()
{
	for(int i = 0; i < n; ++i)
	{
		cnt = 0;
		tmp = b[0];
		for(int j = 1; j < n; ++j)
			b[j - 1] = b[j];
		b[n - 1] = tmp;
		for(int j = 0; j < n; ++j)
			if(a[j] == b[j])
				++cnt;
		best = best > cnt ? best : cnt;
		if((double)(clock() - start) / CLOCKS_PER_SEC > 0.24)
			break;
	}
	
	printf("%d\n", best);
}

int main()
{
	start = clock();
	freopen("calendar.dat", "r", stdin);
	freopen("calendar.sol", "w", stdout);
	
    read();
    solve();
    
	//system("pause");
    
    return 0;
}
