#include <algorithm>
#include <iostream>
#include <cstring>
#include <string>
#include <vector>
#include <cstdio>
#include <cmath>
#include <map>
#include <set>

#define pb push_back
#define mp make_pair
#define s second
#define f first

using namespace std;

const int nmax = 1010;

int d[nmax][nmax], sx, sy, fx, fy, tx, ty, u[nmax][nmax], m, n; 
char a[nmax][nmax];
pair < int, int > q[nmax * nmax];

void read()
{
	scanf("%d %d\n", &m, &n);
	for(int i = 0; i < m; ++i)
		scanf("%s\n", a + i);
		
	for(int i = 0; i < m; ++i)
		for(int j = 0; j < n; ++j)
		{
			if(a[i][j] == '+')
				sx = i, sy = j;
			else if(a[i][j] == 'o')
				fx = i, fy = j;
			if(a[i][j] != '.')
				u[i][j] = 1;
		}
}

void solve()
{
	int qh = 0, qt = 1; 
	q[0] = mp(sx, sy); u[sx][sy] = 0;
	
	while(qh < qt)
	{
		tx = q[qh].f, ty = q[qh].s; ++qh;
		if(tx == fx && ty == fy)
			break;
		for(int i = 0; i < n; ++i)
			if(u[tx][i])
			{
				u[tx][i] = 0;
				d[tx][i] = d[tx][ty] + 1;
				q[qt++] = mp(tx, i);
			}
			
		for(int i = 0; i < m; ++i)
			if(u[i][ty])
			{
				u[i][ty] = 0;
				d[i][ty] = d[tx][ty] + 1;
				q[qt++] = mp(i, ty);
			}	
	}
	
	if(d[fx][fy] == 0)
		printf("-1\n");
	else
		printf("%d\n", d[fx][fy]);
}

int main()
{
    freopen("cap.dat", "r", stdin);
    freopen("cap.sol", "w", stdout);
    
    read();
    solve();
    
    //system("pause");
    
    return 0;
}
