#include <algorithm>
#include <iostream>
#include <cstring>
#include <string>
#include <vector>
#include <cstdio>
#include <cmath>
#include <map>
#include <set>

#define pb push_back
#define mp make_pair
#define s second
#define f first

using namespace std;

const int nmax = 1010;

int d[nmax][nmax], sx, sy, fx, fy, tx, ty, u[nmax][nmax], m, n; 
char a[nmax][nmax];
pair < int, int > q[nmax * nmax];
vector < int > u1[nmax], u2[nmax];

void read()
{
	scanf("%d %d\n", &m, &n);
	for(int i = 0; i < m; ++i)
		scanf("%s\n", a + i);
		
	for(int i = 0; i < m; ++i)
		for(int j = 0; j < n; ++j)
		{
			if(a[i][j] == '+')
				sx = i, sy = j;
			else if(a[i][j] == 'o')
				fx = i, fy = j;
			if(a[i][j] == 'x' || a[i][j] == 'o')
				u1[i].pb(j), u2[j].pb(i), u[i][j] = 1;
		}
}

void solve()
{
	int qh = 0, qt = 1; 
	q[0] = mp(sx, sy); u[sx][sy] = 0;
	
	while(qh < qt)
	{
		tx = q[qh].f, ty = q[qh].s; ++qh;
		if(tx == fx && ty == fy)
			break;
		for(int i = 0; i < u1[tx].size(); ++i)
		{
			int to = u1[tx][i];
			if(u[tx][to])
			{
				u[tx][to] = 0;
				d[tx][to] = d[tx][ty] + 1;
				q[qt++] = mp(tx, to);
			}
		}
			
		for(int i = 0; i < u2[ty].size(); ++i)
		{
			int to = u2[ty][i];
			if(u[to][ty])
			{
				u[to][ty] = 0;
				d[to][ty] = d[tx][ty] + 1;
				q[qt++] = mp(tx, to);
			}
		}	
	}
	
	if(d[fx][fy] == 0)
		printf("-1\n");
	else
		printf("%d\n", d[fx][fy]);
}

int main()
{
    freopen("cap.dat", "r", stdin);
    freopen("cap.sol", "w", stdout);
    
    read();
    solve();
    
    //system("pause");
    
    return 0;
}
