#include <algorithm>
#include <iostream>
#include <cstring>
#include <string>
#include <vector>
#include <cstdio>
#include <cmath>
#include <map>
#include <set>

#define pb push_back
#define mp make_pair
#define s second
#define f first

using namespace std;

const int nmax = 1010;
const int inf = (int)1e9 + 7;

int in[nmax], out[nmax], ds[nmax], tmp1[nmax], tmp2[nmax], n, cnt;
int d[nmax][nmax];

void read()
{
	cin >> n;
	for(int i = 0; i < n; ++i)
		cin >> in[i];
		
	for(int i = 0; i < n; ++i)
		cin >> out[i];
	
	for(int i = 0; i < n; ++i)
		ds[i] = out[i] >= in[i] ? out[i] - in[i] : 4 - in[i] + out[i];
	
	for(int i = 0; i < n; ++i)
		for(int j = 0; j < n; ++j)
			d[i][j] = inf;
	/*
	for(int i = 0; i < n; ++i)
		cout << d[i] << " ";
	cout << endl;
	*/
}

bool ok(int x, int pos, int fl)
{
	if(pos == n - 1 && fl == 1 || pos == 0 && fl == -1)
		return x >= ds[n - 1];
	else
	{
		if(x >= ds[pos])
			return ok(x - ds[i], pos + fl, fl);
		else
			return false;//ok(ds[pos], pos + fl, fl);
	}
}

void solve()
{
	int l = 0, r = 100, fl = 0;
	while(l < r - 1)
	{
		fl = 0;
		int mid = (l + r) / 2;
		for(int i = 0; i < n; ++i)
			if(ok(mid, i, 1) && ok(mid, i, -1))
				fl = 1;
		if(fl == 1)
			r = mid;
		else
			l = mid;
	}
	
	for(int i = 0; i < n; ++i)
		if(ok(r, i, 1) && ok(r, i, -1))
			fl = 1;
	
	if(fl == 1)
		cout << r << endl;
	else
		cout << l << endl;
	
}	

int main()
{
    freopen("tetris.dat", "r", stdin);
    freopen("tetris.sol", "w", stdout);
    
    read();
    solve();
	//cout << 5 << endl;
    //system("pause");
    
    return 0;
}
