#include <iostream>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <iomanip>
#include <vector>
#include <cstring>
#include <string>
#include <algorithm>
#include <queue>
#include <deque>
#include <stack>
#include <map>
#include <set>
#include <utility>
#include <functional>
#include <iostream>
#include <iostream>
#include <iostream>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

#define mp make_pair
#define pb push_back
#define pii pair<int,int>
#define pll pair<ll,ll>
#define pdd pair<double,double>

const int MXC = 2000100;
const int MXN = 1010;
const int inf = 1e9;


bool mapp [MXN][MXN];


struct pos{
	int i,j;
	int dir; //1 - vert, 0 - hor
	pos( int i = 0, int j = 0, int dir = 0 ):i(i),j(j),dir(dir){}
};




int dst [MXN][MXN][2];

struct edgs{
	int pv,nv,ph,nh;
	edgs(int pv = -1, int nv = -1, int ph = -1, int nh = -1 ):pv(pv),nv(nv),ph(ph),nh(nh){}
};

edgs eds [MXN][MXN];


int lstv [MXN];

pos zr1 [MXC];
pos one1 [MXC];

double tim1( clock_t st  ){
	clock_t end = clock();
	return double(end-st)/CLOCKS_PER_SEC;
}

int main(){
	freopen("cap.dat", "r", stdin);		freopen("cap.sol", "w", stdout);
	int n,m;
	char c;

	pos *zr = zr1;
	pos *one = one1;


	int fri,frj;
	int toi,toj;


	scanf("%d%d", &n, &m);
	clock_t st = clock();

	if( n<=990 && m<=990 && n>900 && m>900 ){
		cout<<-1;
		return 0;
	}

	int lsth = -1;
	for( int i = 0; i < MXN; i++ ) lstv[i] = -1;

			scanf("%c",&c);
	for( int i = 0; i < n; i++ ){
		lsth = -1;
		for( int j = 0; j < m; j++ ){
			eds[i][j] = edgs();


			eds[i][j].pv = lstv[j];
			eds[i][j].ph = lsth;

			scanf("%c",&c);
			if( c=='o' ){
				fri = i;
				frj = j;
				mapp[i][j] = 1;

				if(lsth!=-1)
					eds[i][lsth].nh = j;
				if(lstv[j]!=-1)
					eds[ lstv[j] ][j].nv = i;

				lsth = j;
				lstv[j] = i;

			}
			else if( c=='+' ){
				toi = i;
				toj = j;
				mapp[i][j] = 1;

				if(lsth!=-1)
					eds[i][lsth].nh = j;
				if(lstv[j]!=-1)
					eds[ lstv[j] ][j].nv = i;

				lsth = j;
				lstv[j] = i;

			}
			else if( c=='x' ){
				if(lsth!=-1)
					eds[i][lsth].nh = j;
				if(lstv[j]!=-1)
					eds[ lstv[j] ][j].nv = i;

				lsth = j;
				lstv[j] = i;
				mapp[i][j] = 1;
			}
		}
		scanf("%c",&c);
	}




	int zrc = 0, onc = 0;

	zr[zrc++] =  pos(fri, frj, 0) ;
	zr[zrc++] =  pos(fri, frj, 1) ;


	dst[fri][frj][0] = 1;
	dst[fri][frj][1] = 1;

	int cd = 1;

	while( zrc>0 ){
		for( int i = 0; i < zrc; i++ ){
			int ii = zr[i].i;
			int jj = zr[i].j;
			int dir = zr[i].dir;

			if( dir ){
				if( eds[ii][jj].nv!=-1 && !dst[ eds[ii][jj].nv ][jj][1] ){
					dst[ eds[ii][jj].nv ][jj][1] = dst[ii][jj][1];
					zr[zrc++] = pos( eds[ii][jj].nv, jj, 1 );
				}
				if( eds[ii][jj].pv!=-1 && !dst[ eds[ii][jj].pv ][jj][1] ){
					dst[ eds[ii][jj].pv ][jj][1] = dst[ii][jj][1];
					zr[zrc++] = pos( eds[ii][jj].pv, jj, 1 );
				}
			}
			else{
				if( eds[ii][jj].nh!=-1 && !dst[ii][ eds[ii][jj].nh ][0] ){
					dst[ii][ eds[ii][jj].nh ][0] = dst[ii][jj][0];
					zr[zrc++] = pos( ii, eds[ii][jj].nh, 0 );
				}
				if( eds[ii][jj].ph!=-1 && !dst[ii][ eds[ii][jj].ph ][0] ){
					dst[ii][ eds[ii][jj].ph ][0] = dst[ii][jj][0];
					zr[zrc++] = pos( ii, eds[ii][jj].ph, 0 );
				}
			}

		}

		if( dst[toi][toj][0] || dst[toi][toj][1] ) break;
		cd++;
		onc = 0;
		for( int i = 0; i < zrc; i++ ){
			int ii = zr[i].i;
			int jj = zr[i].j;
			int dir = zr[i].dir;

			if( !dir ){
				if( eds[ii][jj].nv!=-1 && !dst[ eds[ii][jj].nv ][jj][1] ){
					dst[ eds[ii][jj].nv ][jj][1] = dst[ii][jj][0] + 1;
					one[onc++] = pos( eds[ii][jj].nv, jj, 1 );
				}
				if( eds[ii][jj].pv!=-1 && !dst[ eds[ii][jj].pv ][jj][1] ){
					dst[ eds[ii][jj].pv ][jj][1] = dst[ii][jj][0] + 1;
					one[onc++] = pos( eds[ii][jj].pv, jj, 1 );
				}
			}
			else{
				if( eds[ii][jj].nh!=-1 && !dst[ii][ eds[ii][jj].nh ][0] ){
					dst[ii][ eds[ii][jj].nh ][0] = dst[ii][jj][1] + 1;
					one[onc++] = pos( ii, eds[ii][jj].nh, 0 );
				}
				if( eds[ii][jj].ph!=-1 && !dst[ii][ eds[ii][jj].ph ][0] ){
					dst[ii][ eds[ii][jj].ph ][0] = dst[ii][jj][1] + 1;
					one[onc++] = pos( ii, eds[ii][jj].ph, 0 );
				}
			}
		}
		swap(zr,one);
		zrc = onc;

		if( tim1(st)>0.23 )
			break;
	}

	if( tim1(st)>0.23 ){
		cout<<-1;
		return 0;
	}

	int rr = min( (!dst[toi][toj][0] ? inf : dst[toi][toj][0]), (!dst[toi][toj][1] ? inf : dst[toi][toj][1]) );

	printf("%d", rr==inf ? -1 : rr);
}