#include <iostream>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <iomanip>
#include <vector>
#include <cstring>
#include <string>
#include <algorithm>
#include <queue>
#include <deque>
#include <stack>
#include <map>
#include <set>
#include <utility>
#include <functional>
#include <iostream>
#include <iostream>
#include <iostream>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

#define mp make_pair
#define pb push_back
#define pii pair<int,int>
#define pll pair<ll,ll>
#define pdd pair<double,double>

const int MXN = 1010;

int a [MXN];
int b [MXN];

int n;

const int inf = 1e9;

int stress(int i){
	if( i==n ) return 0;
	if( a[i]==b[i] ) return stress(i+1);


	int res = inf;
	for( int j = 1; j <= n-i; j++ ){
		for( int ii = i; ii < i+j; ii++ )
			a[ii] = ( (a[ii]+1) & 3);

		res = min(res,stress(i) + 1);

		for( int ii = i; ii < i+j; ii++ )
			a[ii] = ( (3+a[ii]) & 3);
	}

	return res;
}

int main(){
	freopen("tetris.dat", "r", stdin);		freopen("tetris.sol", "w", stdout);


	cin>>n;

	for( int i = 0; i < n; i++ )
		cin>>a[i];
	for( int i = 0; i < n; i++ )
		cin>>b[i];

	/*int lft = 0;

	int res = 0;
	for( int i = 0; i < n; i++ ){
		int need = ( a[i]>b[i] ? 4-(a[i]-b[i]) : b[i]-a[i] );
		if( need <= lft ) lft = min(need,lft);
		else{
			res += need - lft;
			lft  = need;
		}
	}
	cout<<res;*/

	cout<<stress(0);
}