#include <cstdio>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <algorithm>

typedef long long ll;
#define min(a,b) (((a)<(b))?(a):(b))
#define max(a,b) (((a)>(b))?(a):(b))
#define abs(a) (((a)<0)?-(a):(a))

using namespace std;

int n, m;
char tbl[1001][1001];
int ld[1001][1001];
int dpth[1001][1001];

int dx[] = {0, 0, 1, -1};
int dy[] = {-1, 1, 0, 0};

#define MAXQ 2000000
int qx[4001][4001], qy[4001][4001];
int qh[4001], qt[4001];
bool seen[1001][1001];




int main()
{
	freopen("cap.dat", "r", stdin);
	freopen("cap.sol", "w", stdout);

	int sx, sy, fx, fy;
	scanf("%d %d\n", &n, &m);
	for (int i = 0; i < n; i++)
		scanf("%s", tbl[i]);

	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
		{
			if (tbl[i][j] == 'o')
				sx = i, sy = j;
			if (tbl[i][j] == '+')
			{
				fx = i, fy = j;
				tbl[i][j] = 'x';
			}
			ld[i][j] = 0;
			dpth[i][j] = -1;
		}

	dpth[sx][sy] = 0;
	qt[0] = 1;
	qx[0][0] = sx, qy[0][0] = sy;

	int cq = 0;
	for (cq = 0; cq <= 4*n; cq++)
	{
		while(qh[cq] != qt[cq])
		{
			int vx = qx[cq][qh[cq]], vy = qy[cq][qh[cq]];
			qh[cq]++;

			if (seen[vx][vy])
				continue;

			seen[vx][vy] = true;

			for (int i = 0; i < 4; i++)
			{
				int tx = vx + dx[i], ty = vy + dy[i];
				if (tx < 0 || tx >= n || ty < 0 || ty >= m)
					continue;

				while (tx + dx[i] >= 0 && tx + dx[i] < n && ty + dy[i] >= 0 && ty + dy[i] < m && tbl[tx][ty] != 'x')
				{
					tx += dx[i];
					ty += dy[i];
				}

				if (tbl[tx][ty] != 'x' || (dpth[tx][ty] != -1 && dpth[tx][ty] < dpth[vx][vy]))
					continue;

				if ((1<<i) & ld[vx][vy])
				{
					ld[tx][ty] |= (1<<i);
					qx[cq][qt[cq]] = tx, qy[cq][qt[cq]] = ty;
					dpth[tx][ty] = dpth[vx][vy];
					qt[cq]++;
				}
				else
				{
					if (dpth[tx][ty] != -1 && dpth[tx][ty] < dpth[vx][vy] + 1)
						continue;

					ld[tx][ty] |= (1<<i);
					qx[cq+1][qt[cq+1]] = tx, qy[cq+1][qt[cq+1]] = ty;
					qt[cq+1]++;
					dpth[tx][ty] = dpth[vx][vy] + 1;
				}
			}
		}
	}

	printf("%d", dpth[fx][fy]);
	return 0;
}