#include <cstdio>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <algorithm>

typedef long long ll;
#define min(a,b) (((a)<(b))?(a):(b))
#define max(a,b) (((a)>(b))?(a):(b))
#define abs(a) (((a)<0)?-(a):(a))

using namespace std;

int n;
int lt[1001];

int main()
{
	freopen("tetris.dat", "r", stdin);
	freopen("tetris.sol", "w", stdout);

	scanf("%d", &n);
	for (int i = 0; i < n; i++)
		scanf("%d", &lt[i]);

	for (int i = 0; i < n; i++)
	{
		int cr;
		scanf("%d", &cr);
		if (cr < lt[i])
			cr += 4;
		lt[i] = cr - lt[i];
	}

	int res = 0, rl = 0;
	while (true)
	{
		for (int i = 0; i < n; i++)
		{
			while (lt[i] == 0 && i < n)
				i++;
			if (i < n)
				res++;
			else
				break;
			while (lt[i] != 0 && i < n)
				--lt[i++];
		}
		if (rl == res)
			break;
		rl = res;
	}

	printf("%d", res);

	return 0;
}