#include<iostream>
#include<cstdio>
#include<set>
#include<vector>
#include<algorithm>
using namespace std;
int n,m;
vector< set< pair<int, long long> > > g;
long long d[200000]={0};
set<pair< long long, int> > P;
void Dijekstra()
{
     if (P.empty()) return ;
     pair<long long , int > v = *P.begin();
     P.erase(v);
     while (!P.empty() && v.first != d[v.second]) v = *P.begin(),P.erase(v);
     if (v.first != d[v.second]) return ;
     for (set<pair<int , long long> > :: iterator it = g[v.second].begin();it!=g[v.second].end();it++)
     {
         if (d[(*it).first] == -1 || (d[(*it).first] > v.first + (*it).second))
         {
                          d[(*it).first] = v.first + (*it).second;
                          P.insert(make_pair(d[(*it).first] , (*it).first));
         }
     }
}
int main()
{
    freopen("olympair.dat","r",stdin);
    freopen("olympair.sol","w",stdout);
    cin >> n >> m;
    g.resize(n+1);
    for (int i = 0 ;i < m ; i ++ )
    {
        int t;
        long long a,b,c;
        scanf("%d%lld%lld%lld",&t,&a,&b,&c);
        if (t == 1) {
              g[a].insert(make_pair(b,c));
              continue;
              }
        for (set<pair<int, long long> > :: iterator it = g[a].begin(); it!=g[a].end();it++)
         g[b].insert(make_pair((*it).first,(*it).second + c));
    }
    for (int i = 1 ;i <= n; i ++ )
    {
        set<pair<int, long long> > :: iterator it = g[i].begin();
        while (it!=g[i].end())
        {
              set<pair<int, long long> > :: iterator itt = it;
              while (itt !=g[i].end() && (*it).first == (*itt).first) itt++;
              g[i].erase(++it , itt );              
        }
    }
    d[1] = 0;
    for (int i = 2; i <= n ;i ++ )
     d[i] = -1;
    P.insert(make_pair(0,1));
    for (int i = 1; i <= n ; i ++ )
     Dijekstra();
    for (int i = 2; i <= n ;i ++ )
     printf("%lld\n",d[i]);
    return 0;
}
